The CRP routine can be called via a python wrappen by using f2py as follows:

First run `f2py -h libcrp.pyf -m libcrp CRP_Python_Wrapper.f90`

Some things needs to be corrected in libcrp.pyf by hand:

The following needs to be commented with an exclamation mark (!):
!type(crp_moleculesurface_pes), save :: pes
!type(units), save :: friendlyunits

All 'real' needs to be changed to 'real*8'

Then run `f2py -c libcrp.pyf CRP_Constants.f90 CRP_ErrorTrap.f90 CRP_UnitConversion.f90 CRP_Spline.f90 CRP_General.f90  CRP_GasPhase.f90 CRP_*Surface.f90  CRP_PotentialData.f90  CRP_Wrapper.f90 CRP_Python_Wrapper.f90 --f90flags='-fdefault-real-8' --f77flags='-fdefault-real-8'`

Make sure that the resulting library is called 'libcrp.so' (it is expected by the ASE CRPCalculator)

You might want to use f2py3 instead f2py (it enforces python3 instead of python2).

Then 'example.py' shows how energies and forces can be obtained. The CRPCalculator.py includes an ASE calculator class for the CRP python library so one can simply use ASE to perform calculations.

This Readme is orientated towards the PES, for a quick install guide of the calculator see: 'README_CalculatorInstallGuide'

In this folder there are two main components. The CRP PES 'input' files for O2 on Al(111), and a Python interfaced Fortran calculator that can compute the forces and energies on the PES. 
Note that to get a continuous representation for the PES this Python Calculator is required to be used, as this is where the CRP fitting happens.

The calculator was last tested on Jan 8th 2024 on: Python 3.6.8; it could also work in the deprecated python 2
The Python script will need the following modules:
- NumPy (this should install the required f2py modules as well)
- SciPy
- ASE

If you wish to know how the calculator works you can run and inspect the 'example.py' script. (and inspect the Calculator Python script: 'CRPCalculator.py')
'example.py' returns the pot E and the forces computed at coordinates given in the script.

The PES data for this O2 on At(111) CRP Pes can be found in the folder: 'O2-Al111_HSE03-13x@RPBE_CRP_data'
Note: It is imperative that you DO NOT change any file names inside this folder, as this will very likely break the Calculator.


~ R.A.B. van Bree; Leiden University, 08-01-2024

!*******************************************************************************
!> @brief Unit conversion module.
!*******************************************************************************
!> Converts length, energy and mass units. Units can either by accessed by ID
!> number (UNITS_*) or through a type Units. This module should be initialized
!> before use (Initialize_UnitConversion_Module).
!>
!> @author Mark Wijzenbroek
!> @date 2012
!*******************************************************************************
MODULE UnitConversion

!> A set of units.
  TYPE Units
    INTEGER :: LengthUnit, EnergyUnit, MassUnit, TimeUnit
  END TYPE

! Length units
  INTEGER, PARAMETER :: UNITS_BOHR     = 0 !< Index for bohr
  INTEGER, PARAMETER :: UNITS_ANGSTROM = 1 !< Index for Angstrom

  REAL, PARAMETER :: CONV_ANGSTROM = 0.529177249 !< Conversion factor from bohr to Angstrom

! Energy units
  INTEGER, PARAMETER :: UNITS_HARTREE = 2 !< Index for Hartree
  INTEGER, PARAMETER :: UNITS_EV      = 3 !< Index for eV
  INTEGER, PARAMETER :: UNITS_KCALMOL = 4 !< Index for kcal/mol
  INTEGER, PARAMETER :: UNITS_KJMOL   = 5 !< Index for kJ/mol
  INTEGER, PARAMETER :: UNITS_JOULE   = 6 !< Index for Joule

  REAL, PARAMETER :: CONV_EV = 27.2113961           !< Conversion factor from Hartree to eV
  REAL, PARAMETER :: CONV_KCALMOL = 627.50956       !< Conversion factor from Hartree to kcal/mol
  REAL, PARAMETER :: CONV_KJMOL = 627.50956 * 4.184 !< Conversion factor from Hartree to kJ/mol
  REAL, PARAMETER :: CONV_JOULE = 4.35974434e-18    !< Conversion factor from Hartree to Joule

! Mass units
  INTEGER, PARAMETER :: UNITS_MELEC = 7 !< Index for electron mass
  INTEGER, PARAMETER :: UNITS_MPROT = 8 !< Index for proton mass
  INTEGER, PARAMETER :: UNITS_AMU = 9   !< Index for amu
  INTEGER, PARAMETER :: UNITS_KG = 10   !< Index for kg

  REAL, PARAMETER :: CONV_MPROT = 1/1836.153  !< Conversion factor from electron mass to proton mass
  REAL, PARAMETER :: CONV_AMU = 1/1822.88839  !< Conversion factor from electron mass to amu
  REAL, PARAMETER :: CONV_KG = 9.10938291e-31 !< Conversion factor from electron mass to kg

! Time units
  INTEGER, PARAMETER :: UNITS_AUT = 11 !< Index for atomic units of time
  INTEGER, PARAMETER :: UNITS_PS = 12  !< Index for picoseconds
  INTEGER, PARAMETER :: UNITS_FS = 13  !< Index for femtoseconds

  REAL, PARAMETER :: CONV_PS = 2.418884e-5 !< Conversion factor from atomic units of time to picoseconds
  REAL, PARAMETER :: CONV_FS = 2.418884e-2 !< Conversion factor from atomic units of time to femtoseconds

!> A wrapper for converting length units.
  INTERFACE Convert_Length_Units
    MODULE PROCEDURE Convert_Length_Units_Type, &
                     Convert_Length_Units_Int
  END INTERFACE

!> A wrapper for converting energy units.
  INTERFACE Convert_Energy_Units
    MODULE PROCEDURE Convert_Energy_Units_Type, &
                     Convert_Energy_Units_Int
  END INTERFACE

!> A wrapper for converting mass units.
  INTERFACE Convert_Mass_Units
    MODULE PROCEDURE Convert_Mass_Units_Type, &
                     Convert_Mass_Units_Int
  END INTERFACE

!> A wrapper for converting time units.
  INTERFACE Convert_Time_Units
    MODULE PROCEDURE Convert_Time_Units_Type, &
                     Convert_Time_Units_Int
  END INTERFACE

!> Units internally used in the program (set to atomic units).
  TYPE ( Units ) :: InternalUnits

  INTEGER :: UnitConversion_Module_SetUp = 0

CONTAINS

!*******************************************************************************
! Convert_Length_Units_Type
!*******************************************************************************
!> Convert length units with a Units type.
!>
!> @param Num The number that has to be converted.
!> @param InUnits A Units with the input units.
!> @param OutUnits A Units with the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Length_Units_Type( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Units)     :: InUnits, OutUnits
    REAL :: Num, Val

    Val = Convert_Length_Units_Int( Num, InUnits%LengthUnit, OutUnits%LengthUnit )
  END FUNCTION

!*******************************************************************************
! Convert_Length_Units_Int
!*******************************************************************************
!> Convert length units by index.
!>
!> @param Num The number that has to be converted.
!> @param InUnits The index of the input units.
!> @param OutUnits The index of the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Length_Units_Int( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    INTEGER          :: InUnits, OutUnits
    REAL :: Num, Val
    REAL :: Conversion

    IF ( InUnits .EQ. OutUnits ) THEN
      Val = Num
      RETURN
    END IF

    SELECT CASE ( InUnits )
      CASE ( UNITS_BOHR )
        Conversion = 1.0
      CASE ( UNITS_ANGSTROM )
        Conversion = 1.0 / CONV_ANGSTROM
      CASE DEFAULT
        PRINT *, "Unknown input units"
        STOP
    END SELECT

    SELECT CASE ( OutUnits )
      CASE ( UNITS_BOHR )
      CASE ( UNITS_ANGSTROM )
        Conversion = Conversion * CONV_ANGSTROM
      CASE DEFAULT
        PRINT *, "Unknown output units"
        STOP
    END SELECT

    Val = Num * Conversion
  END FUNCTION

!*******************************************************************************
! Convert_Energy_Units_Type
!*******************************************************************************
!> Convert energy units with a Units type.
!>
!> @param Num The number that has to be converted.
!> @param InUnits A Units with the input units.
!> @param OutUnits A Units with the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Energy_Units_Type( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Units)     :: InUnits, OutUnits
    REAL :: Num, Val

    Val = Convert_Energy_Units_Int( Num, InUnits%EnergyUnit, OutUnits%EnergyUnit )
  END FUNCTION

!*******************************************************************************
! Convert_Energy_Units_Int
!*******************************************************************************
!> Convert energy units by index.
!>
!> @param Num The number that has to be converted.
!> @param InUnits The index of the input units.
!> @param OutUnits The index of the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Energy_Units_Int( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    INTEGER          :: InUnits, OutUnits
    REAL :: Num, Val
    REAL :: Conversion

    IF ( InUnits .EQ. OutUnits ) THEN
      Val = Num
      RETURN
    END IF

    SELECT CASE ( InUnits )
      CASE ( UNITS_HARTREE )
        Conversion = 1.0
      CASE ( UNITS_EV )
        Conversion = 1.0 / CONV_EV
      CASE ( UNITS_KCALMOL )
        Conversion = 1.0 / CONV_KCALMOL
      CASE ( UNITS_KJMOL )
        Conversion = 1.0 / CONV_KJMOL
      CASE ( UNITS_JOULE )
        Conversion = 1.0 / CONV_JOULE
      CASE DEFAULT
        PRINT *, "Unknown input units"
        STOP
    END SELECT

    SELECT CASE ( OutUnits )
      CASE ( UNITS_HARTREE )
      CASE ( UNITS_EV )
        Conversion = Conversion * CONV_EV
      CASE ( UNITS_KCALMOL )
        Conversion = Conversion * CONV_KCALMOL
      CASE ( UNITS_KJMOL )
        Conversion = Conversion * CONV_KJMOL
      CASE ( UNITS_JOULE )
        Conversion = Conversion * CONV_JOULE
      CASE DEFAULT
        PRINT *, "Unknown output units"
        STOP
    END SELECT

    Val = Num * Conversion
  END FUNCTION

!*******************************************************************************
! Convert_Time_Units_Type
!*******************************************************************************
!> Convert time units with a Units type.
!>
!> @param Num The number that has to be converted.
!> @param InUnits A Units with the input units.
!> @param OutUnits A Units with the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Time_Units_Type( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Units)     :: InUnits, OutUnits
    REAL :: Num, Val

    Val = Convert_Time_Units_Int( Num, InUnits%TimeUnit, OutUnits%TimeUnit )
  END FUNCTION

!*******************************************************************************
! Convert_Time_Units_Int
!*******************************************************************************
!> Convert time units by index.
!>
!> @param Num The number that has to be converted.
!> @param InUnits The index of the input units.
!> @param OutUnits The index of the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Time_Units_Int( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    INTEGER          :: InUnits, OutUnits
    REAL :: Num, Val
    REAL :: Conversion

    IF ( InUnits .EQ. OutUnits ) THEN
      Val = Num
      RETURN
    END IF

    SELECT CASE ( InUnits )
      CASE ( UNITS_AUT )
        Conversion = 1.0
      CASE ( UNITS_PS )
        Conversion = 1.0 / CONV_PS
      CASE ( UNITS_FS )
        Conversion = 1.0 / CONV_FS
      CASE DEFAULT
        PRINT *, "Unknown input units"
        STOP
    END SELECT

    SELECT CASE ( OutUnits )
      CASE ( UNITS_AUT )
      CASE ( UNITS_PS )
        Conversion = Conversion * CONV_PS
      CASE ( UNITS_FS )
        Conversion = Conversion * CONV_FS
      CASE DEFAULT
        PRINT *, "Unknown output units"
        STOP
    END SELECT

    Val = Num * Conversion
  END FUNCTION

!*******************************************************************************
! Convert_Mass_Units_Type
!*******************************************************************************
!> Convert mass units with a Units type.
!>
!> @param Num The number that has to be converted.
!> @param InUnits A Units with the input units.
!> @param OutUnits A Units with the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Mass_Units_Type( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Units)     :: InUnits, OutUnits
    REAL :: Num, Val

    Val = Convert_Mass_Units_Int( Num, InUnits%MassUnit, OutUnits%MassUnit )
  END FUNCTION

!*******************************************************************************
! Convert_Mass_Units_Int
!*******************************************************************************
!> Convert mass units by index.
!>
!> @param Num The number that has to be converted.
!> @param InUnits The index of the input units.
!> @param OutUnits The index of the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Mass_Units_Int( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    INTEGER          :: InUnits, OutUnits
    REAL :: Num, Val
    REAL :: Conversion

    IF ( InUnits .EQ. OutUnits ) THEN
      Val = Num
      RETURN
    END IF

    SELECT CASE ( InUnits )
      CASE ( UNITS_MELEC )
        Conversion = 1.0
      CASE ( UNITS_MPROT )
        Conversion = 1.0 / CONV_MPROT
      CASE ( UNITS_AMU )
        Conversion = 1.0 / CONV_AMU
      CASE ( UNITS_KG )
        Conversion = 1.0 / CONV_KG
      CASE DEFAULT
        PRINT *, "Unknown input units"
        STOP
    END SELECT

    SELECT CASE ( OutUnits )
      CASE ( UNITS_MELEC )
      CASE ( UNITS_MPROT )
        Conversion = Conversion * CONV_MPROT
      CASE ( UNITS_AMU )
        Conversion = Conversion * CONV_AMU
      CASE ( UNITS_KG )
        Conversion = Conversion * CONV_KG
      CASE DEFAULT
        PRINT *, "Unknown output units"
        STOP
    END SELECT

    Val = Num * Conversion
  END FUNCTION

!*******************************************************************************
! Convert_Force_Units
!*******************************************************************************
!> Convert force units with a Units type.
!>
!> @param Num The number that has to be converted.
!> @param InUnits A Units with the input units.
!> @param OutUnits A Units with the output units.
!> @returns The number in the new units.
!*******************************************************************************
  FUNCTION Convert_Force_Units( Num, InUnits, OutUnits ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Units)     :: InUnits, OutUnits
    REAL :: Num, Val

    Val = Num * Convert_Energy_Units( 1.0, InUnits, OutUnits ) / Convert_Length_Units( 1.0, InUnits, OutUnits )
  END FUNCTION

!*******************************************************************************
! Initialize_UnitConversion_Module
!*******************************************************************************
!> Initialize the UnitConversion module. Needs to be run before use!
!*******************************************************************************
  SUBROUTINE Initialize_UnitConversion_Module()
    IMPLICIT NONE

    IF ( UnitConversion_Module_SetUp .LT. 1 ) THEN
      UnitConversion_Module_SetUp = 1
      InternalUnits%LengthUnit = UNITS_BOHR
      InternalUnits%EnergyUnit = UNITS_HARTREE
      InternalUnits%MassUnit   = UNITS_MELEC
      InternalUnits%TimeUnit   = UNITS_AUT
    END IF
  END SUBROUTINE

END MODULE

MODULE PotentialData

! This module allows the program to smartly detect where the data for a
! potential is stored.

  USE ErrorTrap

  IMPLICIT NONE

  PRIVATE :: NumLocations, Locations, CurrentLocation

  INTEGER, PARAMETER :: NumLocations = 10, MaxStringLength = 200
  CHARACTER( LEN=MaxStringLength ), DIMENSION( NumLocations ) :: Locations
  INTEGER :: CurrentLocation = 1

CONTAINS

! Set up standard potential data folders. The program checks the following
! directories, in order:
!
! Input file parameter PESDataBase (this folder is not added here but in Read_Input())
! Environment variable PESDATA (requires -DHAVE_GET_ENVIRONMENT_VARIABLE)
! The current folder (.)
! The folders QCTraj, .QCTraj, PESDATA, .PESDATA in the home directory of the user (requires -DHAVE_GET_ENVIRONMENT_VARIABLE)
  SUBROUTINE Standard_Potential_Data_Folders( )
    IMPLICIT NONE

#ifdef HAVE_GET_ENVIRONMENT_VARIABLE
    CHARACTER( LEN=MaxStringLength ) :: HomeDir, PESDir
#endif

#ifdef HAVE_GET_ENVIRONMENT_VARIABLE
    CALL GET_ENVIRONMENT_VARIABLE( "PESDATA", PESDir )
    CALL Add_Potential_Data_Folder( TRIM(PESDir) )
#endif
    CALL Add_Potential_Data_Folder( "." )
#ifdef HAVE_GET_ENVIRONMENT_VARIABLE
    CALL GET_ENVIRONMENT_VARIABLE( "HOME", HomeDir )
    CALL Add_Potential_Data_Folder( TRIM(HomeDir) // "/QCTraj" )
    CALL Add_Potential_Data_Folder( TRIM(HomeDir) // "/.QCTraj" )
    CALL Add_Potential_Data_Folder( TRIM(HomeDir) // "/PESDATA" )
    CALL Add_Potential_Data_Folder( TRIM(HomeDir) // "/.PESDATA" )
#endif
  END SUBROUTINE

  SUBROUTINE Add_Potential_Data_Folder( Location )
    IMPLICIT NONE

    CHARACTER( LEN=* ) :: Location

    IF ( CurrentLocation .LE. NumLocations ) THEN
      Locations( CurrentLocation ) = Location
      CurrentLocation = CurrentLocation + 1
    ELSE
      CALL AbortwithError( "Could not add location of potential data, array is full." )
    END IF
  END SUBROUTINE

  FUNCTION Test_Potential_Data( PotentialFile )
    IMPLICIT NONE

    INTEGER :: i
    CHARACTER( LEN=* ) :: PotentialFile
    CHARACTER( LEN=MaxStringLength ) :: Test_Potential_Data
    LOGICAL :: Exists

    IF ( CurrentLocation == 1 ) THEN
      CALL AbortwithError( "The potential data search path was not set up." )
    END IF

    DO i = 1, CurrentLocation - 1
      INQUIRE( FILE=TRIM(Locations(i)) // "/" // TRIM(PotentialFile), EXIST=Exists )
      IF ( Exists ) THEN
        Test_Potential_Data = TRIM(Locations(i))
        RETURN
      END IF
    END DO
    CALL AbortwithError( "Could not find potential data " // PotentialFile // " in the potential data search path." )
  END FUNCTION

END MODULE

!---------------------------------------------------------------------------
! This module has been modified to use a larger reference cluster in the
! calculation of atomic potentials.
!
! E.W.F. Smeets  6-2-18
!---------------------------------------------------------------------------

MODULE CRP_C3v_AtomSurface

  USE CRP_Constants
  USE CRP_General
  USE Spline

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: Initialize_CRP_C3v_AtomSurface_Module, &
            Initialize_CRP_C3v_AtomSurface_PES, &
            Calculate_CRP_C3v_AtomSurface_PES

  INTEGER, PARAMETER :: idf3 = 10
  REAL   :: fouri3D(idf3, idf3)
!  INTEGER, PARAMETER :: idz = 57, idrep = 46
  REAL, PARAMETER :: sq3 = 1.7320508075688772935, usq3 = 1.0 / sq3

  INTEGER :: CRP_C3v_AtomSurface_Module_SetUp = 0

  INTERFACE Calculate_CRP_C3v_AtomSurface_PES
    MODULE PROCEDURE Calculate_CRP_C3v_AtomSurface_PES_Scalar, &
                     Calculate_CRP_C3v_AtomSurface_PES_Array
  END INTERFACE

CONTAINS

  ! Initialize_CRP_C3v_AtomSurface_Module
  !   Initialize this module. Call before use.
  SUBROUTINE Initialize_CRP_C3v_AtomSurface_Module()
    IMPLICIT NONE

    IF ( CRP_C3v_AtomSurface_Module_SetUp .LT. 1 ) THEN
      CRP_C3v_AtomSurface_Module_SetUp = 1
      CALL FOUR3D()
    END IF
  END SUBROUTINE

  ! Initialize_CRP_C3v_AtomSurface_PES
  !   Initialize a PES.
  SUBROUTINE Initialize_CRP_C3v_AtomSurface_PES( PES )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES

    CALL Read_PES_Info( PES )
    CALL Read_AtomSurface_Data( PES )
  END SUBROUTINE

  ! Read_PES_Info
  !   Read information about the PES from disk.
  SUBROUTINE Read_PES_Info( PES )
    IMPLICIT NONE

    INTEGER                      :: i, N
    TYPE ( CRP_AtomSurface_PES ) :: PES

    OPEN(87, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/CRPData.3D", STATUS="OLD")
    READ(87, *) N
    PES%NumCuts = N
    ALLOCATE( PES%Cuts(N) )
    PES%Alloced = .TRUE.
    DO i = 1, N
      READ(87, *) PES%Cuts(i)%X, PES%Cuts(i)%Y, PES%Cuts(i)%FileName
    END DO
    CLOSE(87)
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C3v_AtomSurface_PES_Scalar( PES, X, Y, Z, V, Fx, Fy, Fz, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    TYPE ( Units )               :: OutUnits
    REAL             :: X, Y, Z, V, Fx, Fy, Fz
    REAL             :: MyX, MyY, MyZ

    MyX = Convert_Length_Units( X, OutUnits, InternalUnits )
    MyY = Convert_Length_Units( Y, OutUnits, InternalUnits )
    MyZ = Convert_Length_Units( Z, OutUnits, InternalUnits )
    CALL ATII( MyX, MyY, MyZ, V, Fx, Fy, Fz, PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    Fx = Convert_Force_Units( Fx, InternalUnits, OutUnits )
    Fy = Convert_Force_Units( Fy, InternalUnits, OutUnits )
    Fz = Convert_Force_Units( Fz, InternalUnits, OutUnits )
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C3v_AtomSurface_PES_Array( PES, R, V, F, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    TYPE ( Units )               :: OutUnits
    REAL             :: R(3), V, F(3)
    INTEGER                      :: i
    REAL             :: MyR(3)

    DO i = 1, 3
      MyR(i) = Convert_Length_Units( R(i), OutUnits, InternalUnits )
    END DO
    CALL ATII( MyR(1), MyR(2), MyR(3), V, F(1), F(2), F(3), PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    DO i = 1, 3
      F(i) = Convert_Force_Units( F(i), InternalUnits, OutUnits )
    END DO
  END SUBROUTINE

  ! Read_AtomSurface_Data
  !   This programs reads the data files for the 3D PES and determines
  !   the 3D Interpolation function. The 1D potential is read from the
  !   file INTREP.DAT and calculated by interpolation in murII.
  !   WARNING: the Z values must be the same for all sites.
  SUBROUTINE Read_AtomSurface_Data( PES )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES

!   DELTA: is the nearest neighbour distance on the surface
!   IDELTA=233 means delta is in Angstroms
!   IDELTA=247 means delta is in a.u.
!    REAL :: delta
!    INTEGER          :: idelta

!    REAL :: potfin, derifin
!    REAL :: vasint

    REAL :: b0, b1, der1, der2, deriz, dz1, dz2, pot, vm1
    INTEGER          :: i, j

! ----------------------------------------------------
!  First we read the 1D corrugation reducing function
! ----------------------------------------------------
    OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Atom/intrep.dat", STATUS="OLD")
!    READ(10, *) delta, idelta
!    READ(10, *) vasint
    READ(10, *) dz1
    READ(10, *) dz2
    dz1 = Convert_Force_Units( dz1, PES%InputUnits, InternalUnits )
    dz2 = Convert_Force_Units( dz2, PES%InputUnits, InternalUnits )
    READ(10, *) PES%CorrugationFunction1D%NX
    CALL Allocate_Spline1D( PES%CorrugationFunction1D, PES%CorrugationFunction1D%NX )
    DO i = 1, PES%CorrugationFunction1D%NX
      READ(10, *) PES%CorrugationFunction1D%X(i), PES%CorrugationFunction1D%F(i)
      PES%CorrugationFunction1D%X(i) = Convert_Length_Units( PES%CorrugationFunction1D%X(i), PES%InputUnits, InternalUnits )
      PES%CorrugationFunction1D%F(i) = Convert_Energy_Units( PES%CorrugationFunction1D%F(i), PES%InputUnits, InternalUnits )
    END DO
!EWF
!EWF
!   PRINT *, "READ intrep OK"
!EWF
    CLOSE(10)

    CALL Compute_Spline1D( PES%CorrugationFunction1D, 2, dz1, 2, dz2 )
!    potfin = PES%CorrugationFunction1D%V(PES%CorrugationFunction1D%N)
!    derifin = dz2

! ---------------------------------------------------------------
!  Then we read the cuts through the 3D PES at the various sites
! ---------------------------------------------------------------
    DO j = 1, SIZE(PES%Cuts)
      OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Atom/" // TRIM(ADJUSTL(PES%Cuts(j)%FileName)), STATUS="OLD")
      READ(10, *) PES%Cuts(j)%Spline%NX
      CALL Allocate_Spline1D( PES%Cuts(j)%Spline, PES%Cuts(j)%Spline%NX )
      READ(10, *) dz1
      READ(10, *) dz2
      dz1 = Convert_Force_Units( dz1, PES%InputUnits, InternalUnits )
      dz2 = Convert_Force_Units( dz2, PES%InputUnits, InternalUnits )
      DO i = 1, PES%Cuts(j)%Spline%NX
        READ(10, *) PES%Cuts(j)%Spline%X(i), pot
        PES%Cuts(j)%Spline%X(i) = Convert_Length_Units( PES%Cuts(j)%Spline%X(i), PES%InputUnits, InternalUnits )
        pot = Convert_Energy_Units( pot, PES%InputUnits, InternalUnits )

!        IF (j .GT. 1 .AND. PES%Cuts(j)%Spline%X(i) .NE. PES%Cuts(1)%Spline%X(i)) THEN
!          PRINT *, "Error in data for site ", j
!          STOP
!        END IF

        CALL MURII(PES%Cuts(j)%X * PES%Geometry%LatticeConstant, PES%Cuts(j)%Y * PES%Geometry%LatticeConstant, &
                   PES%Cuts(j)%Spline%X(i), vm1, b0, b1, deriz, PES)
        PES%Cuts(j)%Spline%F(i) = pot - vm1
        IF (i .EQ. 1) THEN
          der1 = dz1 - deriz
        END IF
        IF (i .EQ. PES%Cuts(j)%Spline%NX) THEN
          der2 = dz2 - deriz
        END IF
      END DO
      CLOSE(10)
!EWF
!EWF  now to make sure that we read in the file
!      PRINT *, "READ ATOM OK: ", PES%Cuts(j)%FileName
!EWF 
      CALL Compute_Spline1D( PES%Cuts(j)%Spline, 2, der1, 2, der2 )
    END DO
  END SUBROUTINE

!************************ F O U R 3 D ******************************
!     Matrix allowing to calculate the coefficients of the Fourier
!     interpolation for the 3D Interpolation Function.
!     This matrix depends on the set of reference sites.
!*******************************************************************
  SUBROUTINE FOUR3D()
    IMPLICIT NONE

    REAL :: tour(idf3, idf3)
    INTEGER          :: i, j

    DATA tour/3.0,9.0,3.0,9.0,3*18.0,9.0,18.0,3.0, &
              6.0,-6.0,-3.0,3.0,-12.0,24.0,0.0,3.0,-12.0,-3.0, &
              2*0.0,2*-5.19615242270663188056,-20.78460969082652752224, &
              2*0.0,5.19615242270663188056,20.78460969082652752224, &
              5.19615242270663188056, &
              6.0,-6.0,6.0,-6.0,2*6.0,-18.0,-6.0,2*6.0, &
              6.0,18.0,-3.0,-9.0,3*0.0,-9.0,0.0,-3.0, &
              2*0.0,5.19615242270663188056,-15.58845726811989564168, &
              3*0.0,15.58845726811989564168,0.0,-5.19615242270663188056, &
              6.0,-6.0,-3.0,3.0,6.0,-12.0,0.0,3.0,6.0,-3.0, &
              2*0.0,2*-5.19615242270663188056,10.39230484541326376112, &
              2*0.0,5.19615242270663188056,-10.39230484541326376112, &
              5.19615242270663188056, &
              3.0,-3.0,3.0,-3.0,2*-6.0,18.0,-3.0,-6.0,3.0, &
              2.0,6.0,2.0,6.0,3*-6.0,6.0,-6.0,2.0/

    DO i = 1, idf3
      DO j = 1, idf3
        fouri3D(i, j) = tour(i, j) / 108.0
      END DO
    END DO
  END SUBROUTINE

!************************ A T I I **************************************
!     Calculation of the 3D potential as well as its
!     first derivatives using the Fourier series expansion.
!     The atom position is xa, ya, za.

!     FOURI3D: comes from the solution of the linear system associated
!              with the Fourier expansion and reference sites. It is
!              calculated in FOUR3D which is called within the input
!              data reading routine because it must be called once before
!              the first call to ATII
!      Version 1.0           H.F. Busnengo        09/09/10
!***********************************************************************
  SUBROUTINE ATII( xa, ya, za, v, dvdx, dvdy, dvdz, PES )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES

    REAL :: xa, ya, za, v, dvdx, dvdy, dvdz
    REAL :: vrep, dvrepdx, dvrepdy, dvrepdz
    REAL :: x0c, y0c

    REAL :: a(idf3), fxy(idf3), dfdx(idf3), dfdy(idf3), b(idf3)
    REAL :: vs(idf3), dvsdz(idf3)

    INTEGER :: i, j, ksit

!   Contribution from 1D potential
    CALL ORIGEN2(xa, ya, PES%Geometry%LatticeConstant, x0c, y0c)
    CALL MURII(x0c, y0c, za, vrep, dvrepdx, dvrepdy, dvrepdz, PES)

!   Interpolation over Z for each site
    IF (za .LT. PES%Cuts(1)%Spline%X(1) .OR. za .GT. PES%Cuts(1)%Spline%X(PES%Cuts(1)%Spline%NX)) THEN
      PRINT *, "ERROR: Z outside range for 3D PES", za
      STOP
    END IF

    DO i = 1, SIZE(PES%Cuts)
      vs(i) = Evaluate_Spline1D( PES%Cuts(i)%Spline, za )
      dvsdz(i) = Evaluate_Spline1D_Derivative( PES%Cuts(i)%Spline, za )
    END DO

!   Calculate basis functions for Fourier expansion
    CALL FOUR3II( xa, ya, fxy, dfdx, dfdy, PES )

!   Calculation of potential and derivatives
    v = 0.0
    dvdx = 0.0
    dvdy = 0.0
    dvdz = 0.0

    DO j = 1, idf3
      a(j) = 0.0
      b(j) = 0.0
      DO ksit = 1, idf3
        a(j) = a(j) + fouri3D(ksit, j) * vs(ksit)
        b(j) = b(j) + fouri3D(ksit, j) * dvsdz(ksit)
      END DO
      v = v + a(j) * fxy(j)
      dvdx = dvdx + a(j) * dfdx(j)
      dvdy = dvdy + a(j) * dfdy(j)
      dvdz = dvdz + b(j) * fxy(j)
    END DO

!   Addition of 1D term y para que al infinito valga cero,
!   NO se suma VASINT.
    v = v + vrep
    dvdx = dvdx + dvrepdx
    dvdy = dvdy + dvrepdy
    dvdz = dvdz + dvrepdz
  END SUBROUTINE

!************************ F O U R 3 I I ******************************
!     Calculates the basis functions of the Fourier expansion and
!     their derivatives with respect to X and Y. 3D potential.
!*********************************************************************
  SUBROUTINE FOUR3II( xa, ya, fxy, dfdx, dfdy, PES )
    IMPLICIT NONE

    REAL :: xa, ya
    REAL :: fxy(idf3), dfdx(idf3), dfdy(idf3)

    TYPE ( CRP_AtomSurface_PES ) :: PES

    INTEGER :: i

    REAL :: fac, bigx, bigy, fbigx, fbigy
    REAL :: c2a, c2b, c2c, s2a, s2b, s2c
    REAL :: c3a, c3b, c3c, s3a, s3b, s3c
    REAL :: c4a, c4b, c4c, s4a, s4b, s4c
    REAL :: c5a, c5b, c5c, c5d, c5e, c5f, s5a, s5b, s5c, s5d, s5e, s5f
    REAL :: c6a, c6b, c6c, s6a, s6b, s6c
    REAL :: c7a, c7b, c7c, s7a, s7b, s7c

    fac = 2.0 * CRP_Constants_PI / PES%Geometry%LatticeConstant
    bigx = xa - ya * usq3
    bigy = 2.0 * ya * usq3
    fbigx = fac * bigx
    fbigy = fac * bigy

!   Basis functions and derivatives with respect to crystal coordinates
    fxy(1) = 1.0
    dfdx(1) = 0.0
    dfdy(1) = 0.0

    c2a = COS(fbigx)
    c2b = COS(fbigy)
    c2c = COS(fbigx + fbigy)
    s2a = SIN(fbigx)
    s2b = SIN(fbigy)
    s2c = SIN(fbigx + fbigy)

    fxy(2) = c2a + c2b + c2c
    dfdx(2) = -fac * (s2a + s2c)
    dfdy(2) = -fac * (s2b + s2c)

    fxy(3) =- s2a - s2b + s2c
    dfdx(3) = -fac * (c2a - c2c)
    dfdy(3) = -fac * (c2b - c2c)

    c3a = COS(2.0 * fbigx + fbigy)
    c3b = COS(fbigx + 2.0 * fbigy)
    c3c = COS(fbigx - fbigy)
    s3a = SIN(2.0 * fbigx + fbigy)
    s3b = SIN(fbigx + 2.0 * fbigy)
    s3c = SIN(fbigx - fbigy)

    fxy(4) = c3a + c3b + c3c
    dfdx(4) = -fac * (2.0 * s3a + s3b + s3c)
    dfdy(4) = -fac * (s3a + 2.0 * s3b - s3c)

    c4a = COS(2.0 * fbigx)
    c4b = COS(2.0 * fbigy)
    c4c = COS(2.0 * (fbigx + fbigy))
    s4a = SIN(2.0 * fbigx)
    s4b = SIN(2.0 * fbigy)
    s4c = SIN(2.0 * (fbigx + fbigy))

    fxy(5) = c4a + c4b + c4c
    dfdx(5) = -2.0 * fac * (s4a + s4c)
    dfdy(5) = -2.0 * fac * (s4b + s4c)

    fxy(6) = -s4a - s4b + s4c
    dfdx(6) = -2.0 * fac * (c4a - c4c)
    dfdy(6) = -2.0 * fac * (c4b - c4c)

    c5a = COS(3.0 * fbigx + fbigy)
    c5b = COS(fbigx + 3.0 * fbigy)
    c5c = COS(2.0 * fbigx + 3.0 * fbigy)
    c5d = COS(3.0 * fbigx + 2.0 * fbigy)
    c5e = COS(-fbigx + 2.0 * fbigy)
    c5f = COS(2.0 * fbigx - fbigy)
    s5a = SIN(3.0 * fbigx + fbigy)
    s5b = SIN(fbigx + 3.0 * fbigy)
    s5c = SIN(2.0 * fbigx + 3.0 * fbigy)
    s5d = SIN(3.0 * fbigx + 2.0 * fbigy)
    s5e = SIN(-fbigx + 2.0 * fbigy)
    s5f = SIN(2.0 * fbigx - fbigy)

    fxy(7) = c5a + c5b + c5c + c5d + c5e + c5f
    dfdx(7) = -fac * (3.0 * s5a + s5b + 2.0 * s5c + 3.0 * s5d - s5e + 2.0 * s5f)
    dfdy(7) = -fac * (s5a + 3.0 * s5b + 3.0 * s5c + 2.0 * s5d + 2.0 * s5e - s5f)

    fxy(8) = -s5a - s5b + s5c + s5d - s5e - s5f
    dfdx(8) = fac * (-3.0 * c5a - c5b + 2.0 * c5c + 3.0 * c5d + c5e - 2.0 * c5f)
    dfdy(8) = fac * (-c5a - 3.0 * c5b + 3.0 * c5c + 2.0 * c5d - 2.0 * c5e + c5f)

    c6a = COS(3.0 * fbigx)
    c6b = COS(3.0 * fbigy)
    c6c = COS(3.0 * (fbigx + fbigy))
    s6a = SIN(3.0 * fbigx)
    s6b = SIN(3.0 * fbigy)
    s6c = SIN(3.0 * (fbigx + fbigy))

    fxy(9) = c6a + c6b + c6c
    dfdx(9) = -3.0 * fac * (s6a + s6c)
    dfdy(9) = -3.0 * fac * (s6b + s6c)

    c7a = COS(2.0 * (2.0 * fbigx + fbigy))
    c7b = COS(2.0 * (fbigx + 2.0 * fbigy))
    c7c = COS(2.0 * (fbigx - fbigy))
    s7a = SIN(2.0 * (2.0 * fbigx + fbigy))
    s7b = SIN(2.0 * (fbigx + 2.0 * fbigy))
    s7c = SIN(2.0 * (fbigx - fbigy))

    fxy(10) = c7a + c7b + c7c
    dfdx(10) = -2.0 * fac * (2.0 * s7a + s7b + s7c)
    dfdy(10) = -2.0 * fac * (s7a + 2.0 * s7b - s7c)

!   Derivatives with respect to cartesian coordinates
    DO i = 1, idf3
      dfdy(i) = (-dfdx(i) + 2.0 * dfdy(i)) * usq3
    END DO
  END SUBROUTINE

!************************ M U R I I **********************************
!   Calculates 1D potential and derivatives with respect to x,y,z.
!   A sum is carried out over all atoms on the surface at a
!   distance from the elementary quadrangle smaller than a
!   prescribed value (see program SNEARN). The crystal coordinates
!   for these atoms are given in IVEC. The first index of IVEC
!   is the atom index and the second is 1 for X and 2 for Y.
!   The actual number of nearest neighbours is NVEC
!   The 1D potential and its derivative are given through VREPII.
!   Version 1.0  H.F. Busnengo
!   Version 2.0  A. Salin                 01/02/02
!*********************************************************************
!   This routine had been modified to include a larger reference cluster.
!   E.W.F. Smeets
  SUBROUTINE MURII( x, y, z, v, dvdx, dvdy, dvdz, PES )
    IMPLICIT NONE

    INTEGER i,j,k,l,m,n
    PARAMETER(n=3,m=3)          
  
    TYPE ( CRP_AtomSurface_PES ) :: PES
    REAL, PARAMETER    :: Constants_PI       = 3.1415926535897932384626433832795028841971    ! accurate enough for most CPU's...
    REAL :: x, y, z, v, dvdx, dvdy, dvdz, uuc, vuc, yijk, xijk, zijk, r, vr, dvdr, dvdrsr
    REAL cossurf,sinsurf

    IF ( m .GT. PES%Geometry%NumLayers - 1 ) THEN
      PRINT *,"ERROR in MURII not enough layers in slab"
      STOP
    END IF
    IF ( PES%Disp1 .NE. 0.0 ) THEN
      PRINT *, "Module MURII in C3v Atom Potential not designed for use with displacements"
      STOP
    END IF 

    v = 0.0
    dvdx = 0.0
    dvdy = 0.0
    dvdz = 0.0

    cossurf = COS( Constants_PI / 3.0 )
    sinsurf = SIN( Constants_PI / 3.0 )

    !loop over all surface atoms
    DO i = -n, n + 1
      DO j = -n, n + 1
        DO k = 0, m
          !generate crystal coordinates based on fcc(111)
          uuc = (FLOAT(i) + MOD(k, 3) * (1.0 / 3.0)) * PES%Geometry%LatticeConstant
          vuc = (FLOAT(j) + MOD(k, 3) * (1.0 / 3.0)) * PES%Geometry%LatticeConstant
          xijk = uuc + vuc * cossurf
          yijk = vuc * sinsurf
          zijk = 0.0
          IF ( k .GT. 0 ) THEN
            DO l = 1, k
              zijk = zijk - PES%Geometry%InterlayerSpacings(l)
            END DO
          END IF

          r = SQRT( (x - xijk)**2 + (y - yijk)**2 + (z - zijk)**2 )
!          PRINT *, "r=", r
!         -----------------------------------------
!         Calculating the 1D repulsive potential

          IF(r .GT. PES%CorrugationFunction1D%X(PES%CorrugationFunction1D%NX)) THEN
            vr = 0.0
            dvdr = 0.0
          ELSE
            IF (r .LT. PES%CorrugationFunction1D%X(1)) THEN
              PRINT *, "Error in MURII: R too small"
              STOP
            ELSE
              CALL SPLINT(PES%CorrugationFunction1D%X, PES%CorrugationFunction1D%F, PES%CorrugationFunction1D%Coefs, &
                          PES%CorrugationFunction1D%NX, r, vr, dvdr)
            END IF
          END IF
!         -------------------------------------------
          dvdrsr = dvdr / r

          v = v + vr
          IF (r .GT. 0.0) THEN
            dvdx = dvdx + dvdrsr * (x - xijk)
            dvdy = dvdy + dvdrsr * (y - yijk)
            dvdz = dvdz + dvdrsr * (z - zijk)
          ELSE
            !if top layer 
            IF ( k .EQ. 0 ) THEN
              dvdz = dvdz + dvdr
            ELSE
              PRINT *, "ERROR in MURII -- r smaller then 0"
              STOP
            END IF
          END IF
        END DO 
      END DO
    END DO
    RETURN
  END SUBROUTINE
!************************  O R I G E N 2 *****************************
!     Shifts the coordinate to the inside of the quadrangle with
!     bottom left corner at the origin. Input and output are
!     cartesian coordinates.
!     X,Y are the initial coordinates. DELTA is the internuclear
!     distance on the surface and XT,YT are the calculated shifted
!     values.
!             Version 1.0              01/02/02
!*********************************************************************
  SUBROUTINE ORIGEN2( x, y, delta, xt, yt )
    IMPLICIT NONE

    INTEGER          :: i, ind(2)
    REAL :: x, y, delta, xt, yt, ori(2), bigx, bigy

    bigx = x - y * usq3
    bigy = 2.0 * y * usq3
    ori(1) = bigx / delta
    ori(2) = bigy / delta

    DO i = 1, 2
      IF (ori(i) .GE. 0.0) THEN
        ind(i) = ori(i)
      ELSE
        ind(i) = ori(i) - 1
      ENDIF
    END DO

    bigx = bigx - ind(1) * delta
    bigy = bigy - ind(2) * delta
    xt = bigx + bigy * 0.5
    yt = sq3 * bigy * 0.5
  END SUBROUTINE

END MODULE

!*******************************************************************************
!*MOD* CRP_Wrapper
!*******************************************************************************
!> CRP wrapper module. You should only need this module to perform interpolations.
!*******************************************************************************
MODULE CRP_Wrapper
  USE CRP_Constants
  USE CRP_C3v_AtomSurface
  USE CRP_C3v_MoleculeSurface
  USE CRP_C4v_AtomSurface
  USE CRP_C4v_MoleculeSurface
  USE CRP_C6v_AtomSurface
  USE CRP_C6v_MoleculeSurface
  USE CRP_General
!  USE PotentialData

  IMPLICIT NONE

  INTEGER :: CRP_Wrapper_Module_SetUp = 0

CONTAINS

!*******************************************************************************
!*SUB* Initialize_CRP_Wrapper_Module
!*******************************************************************************
!> Initialize the CRP wrapper module. Call before using any of the CRP routines.
!*******************************************************************************
  SUBROUTINE Initialize_CRP_Wrapper_Module()
    IMPLICIT NONE

    IF ( CRP_Wrapper_Module_SetUp .LT. 1 ) THEN
      CRP_Wrapper_Module_SetUp = 1
      CALL Initialize_UnitConversion_Module()
      CALL Initialize_CRP_C3v_AtomSurface_Module()
      CALL Initialize_CRP_C3v_MoleculeSurface_Module()
      CALL Initialize_CRP_C4v_AtomSurface_Module()
      CALL Initialize_CRP_C4v_MoleculeSurface_Module()
      CALL Initialize_CRP_C6v_AtomSurface_Module()
      CALL Initialize_CRP_C6v_MoleculeSurface_Module()
    END IF
  END SUBROUTINE

!*******************************************************************************
!*SUB* SetUp_CRP_AtomSurface_PES
!*******************************************************************************
!> Set up a potential energy surface for an atom/surface system.
!>
!> @param[in] DataSet The name of the dataset on disk.
!> @param[out] PES The set up potential energy surface.
!*******************************************************************************
  SUBROUTINE SetUp_CRP_AtomSurface_PES( DataSet, PES )
    IMPLICIT NONE

    CHARACTER(LEN = *)           :: DataSet
    CHARACTER(LEN = 50)          :: Symmetry
    TYPE ( CRP_AtomSurface_PES ) :: PES
    LOGICAL                      :: Exists
    INTEGER                      :: i

    IF ( CRP_Wrapper_Module_SetUp .LT. 1 ) CALL Initialize_CRP_Wrapper_Module()

    PES%DataSet = DataSet ! The data files should reside in this folder.
    PES%Mixing = 1.0      ! By default, we set a mixing of 1

    INQUIRE( FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData", EXIST=Exists )

    ! The PES seems to exist, so continue reading...
    IF ( Exists ) THEN
      OPEN( 200, FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData", STATUS="OLD" )
      READ( 200, * ) Symmetry
      READ( 200, * ) PES%InputUnits%LengthUnit, PES%InputUnits%EnergyUnit
      READ( 200, * ) PES%Geometry%LatticeConstant
      PES%Geometry%LatticeConstant = Convert_Length_Units( PES%Geometry%LatticeConstant, PES%InputUnits, InternalUnits )
      READ( 200, * ) PES%Geometry%NumLayers
      CALL Allocate_Slab_Geometry(PES%Geometry)
      PES%Alloced = .TRUE.
      READ( 200, * ) PES%Geometry%InterlayerSpacings
      READ( 200, *, END=100, ERR=100 ) PES%Disp1, PES%Disp2
      GOTO 101
100   CONTINUE
      PES%Disp1 = 0.0
      PES%Disp2 = 0.0
101   CONTINUE
      DO i = 1, PES%Geometry%NumLayers - 1
        PES%Geometry%InterlayerSpacings(i) = Convert_Length_Units( PES%Geometry%InterlayerSpacings(i), PES%InputUnits, &
                                                                   InternalUnits )
      END DO
      CLOSE( 200 )

      INQUIRE( FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData.info", EXIST=Exists )
      IF ( Exists ) THEN
        OPEN( 200, FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData.info", STATUS="OLD" )
        READ( 200, "(A)", END=102, ERR=102 ) PES%InfoShort
        READ( 200, "(A)", END=102, ERR=102 ) PES%InfoLong
        READ( 200, "(A)", END=102, ERR=102 ) PES%InfoRef
102     CONTINUE
        CLOSE( 200 )
      END IF

      ! Here comes the symmetry dependent part: choose which version of the CRP
      ! to use...
      IF ( Symmetry .EQ. "C3v" ) THEN
        PES%Symmetry = 3
        CALL Initialize_CRP_C3v_AtomSurface_PES( PES )
      ELSE IF ( Symmetry .EQ. "C4v" ) THEN
        PES%Symmetry = 4
        CALL Initialize_CRP_C4v_AtomSurface_PES( PES )
      ELSE IF ( Symmetry .EQ. "C6v" ) THEN
        PES%Symmetry = 6
        CALL Initialize_CRP_C6v_AtomSurface_PES( PES )
      ELSE
      END IF
    ELSE
      PRINT *, "ERROR: Dataset " // TRIM(ADJUSTL(DataSet)) // " does not exist?"
      STOP
    END IF
  END SUBROUTINE

!  SUBROUTINE TEST()
!    USE CRP_Interpolation_Matrix
!
!    IMPLICIT NONE
!
!    TYPE (InterpolationMatrix) :: M
!
!    CALL Allocate_Interpolation_Matrix( M, 3 )
!
!    M%Basis(1)%BasisType = BASIS_CONSTANT
!    M%Basis(2)%BasisType = BASIS_COSINE
!    M%Basis(3)%BasisType = BASIS_COSINE
!!    M%Basis(4)%BasisType = BASIS_COSINE
!    CALL Allocate_Basis_Function( M%Basis(2) )
!    CALL Allocate_Basis_Function( M%Basis(3) )
!!    CALL Allocate_Basis_Function( M%Basis(4) )
!    M%Basis(2)%Parameters(1) = 2.0
!    M%Basis(3)%Parameters(1) = 4.0
!!    M%Basis(4)%Parameters(1) = 6.0
!
!    M%Points(1) = 0.0
!    M%Points(2) = CRP_Constants_PI / 3.0
!    M%Points(3) = CRP_Constants_PI / 2.0
!!    M%Points(4) = CRP_Constants_PI / 4.0
!
!    CALL Compute_Interpolation_Matrix( M )
!
!    CALL Invert_Interpolation_Matrix( M )
!
!    PRINT *, Compute_Interpolated( M, (/ 1.0, 2.0, 3.0 /), 0.0 )
!
!    STOP
!  END SUBROUTINE

!*******************************************************************************
!*SUB* SetUp_CRP_MoleculeSurface_PES
!*******************************************************************************
!> Set up a potential energy surface for a molecule/surface system.
!>
!> @param[in] DataSet The name of the dataset on disk.
!> @param[out] PES The set up potential energy surface.
!*******************************************************************************
  SUBROUTINE SetUp_CRP_MoleculeSurface_PES( DataSet, PES )
    IMPLICIT NONE

    CHARACTER(LEN = *)               :: DataSet
    CHARACTER(LEN = 50)              :: Symmetry
    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    LOGICAL                          :: Exists
    INTEGER                          :: i

    IF ( CRP_Wrapper_Module_SetUp .LT. 1 ) CALL Initialize_CRP_Wrapper_Module()

    PES%DataSet = DataSet ! The data files should reside in this folder.
    PES%Mixing = 1.0      ! By default, we set a mixing of 1

    INQUIRE( FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData", EXIST=Exists )

    ! The PES seems to exist, so continue reading...
    IF ( Exists ) THEN
      OPEN( 200, FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData", STATUS="OLD" )
      READ( 200, * ) Symmetry
      READ( 200, * ) PES%InputUnits%LengthUnit, PES%InputUnits%EnergyUnit
      READ( 200, * ) PES%Geometry%LatticeConstant
      PES%Geometry%LatticeConstant = Convert_Length_Units( PES%Geometry%LatticeConstant, PES%InputUnits, InternalUnits )
      READ( 200, * ) PES%Geometry%NumLayers
      CALL Allocate_Slab_Geometry(PES%Geometry)
      PES%Alloced = .TRUE.
      READ( 200, * ) PES%Geometry%InterlayerSpacings
      DO i = 1, PES%Geometry%NumLayers - 1
        PES%Geometry%InterlayerSpacings(i) = Convert_Length_Units( PES%Geometry%InterlayerSpacings(i), PES%InputUnits, &
                                                                   InternalUnits )
      END DO
      CLOSE( 200 )

      INQUIRE( FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData.info", EXIST=Exists )
      IF ( Exists ) THEN
        OPEN( 200, FILE=TRIM(ADJUSTL(DataSet)) // "/CRPData.info", STATUS="OLD" )
        READ( 200, "(A)", END=102, ERR=102 ) PES%InfoShort
        READ( 200, "(A)", END=102, ERR=102 ) PES%InfoLong
        READ( 200, "(A)", END=102, ERR=102 ) PES%InfoRef
102     CONTINUE
        CLOSE( 200 )
      END IF

      ! Here comes the symmetry dependent part: choose which version of the CRP
      ! to use...
      IF ( Symmetry .EQ. "C3v" ) THEN
        PES%Symmetry = 3
        PES%AtomSurface%Symmetry = PES%Symmetry
        CALL SetUp_CRP_AtomSurface_PES( DataSet, PES%AtomSurface )
        CALL Initialize_CRP_C3v_MoleculeSurface_PES( PES )
      ELSE IF ( Symmetry .EQ. "C4v" ) THEN
        PES%Symmetry = 4
        PES%AtomSurface%Symmetry = PES%Symmetry
        CALL SetUp_CRP_AtomSurface_PES( DataSet, PES%AtomSurface )
        CALL Initialize_CRP_C4v_MoleculeSurface_PES( PES )
      ELSE IF ( Symmetry .EQ. "C6v" ) THEN
        PES%Symmetry = 6
        PES%AtomSurface%Symmetry = PES%Symmetry
        CALL SetUp_CRP_AtomSurface_PES( DataSet, PES%AtomSurface )
        CALL Initialize_CRP_C6v_MoleculeSurface_PES( PES )
      ELSE
        PRINT *, "Unknown symmetry"
        STOP
      END IF
    ELSE
      PRINT *, "ERROR: Dataset " // TRIM(ADJUSTL(DataSet)) // " does not exist?"
      STOP
    END IF
  END SUBROUTINE

!*******************************************************************************
!*SUB* Calculate_CRP_AtomSurface_PES
!*******************************************************************************
!>
!>
!> @param PES
!> @param R
!> @param V
!> @param F
!> @param OutUnits
!*******************************************************************************
  SUBROUTINE Calculate_CRP_AtomSurface_PES( PES, R, V, F, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    REAL             :: R(:), V, F(:)
    TYPE ( Units )               :: OutUnits

    IF ( CRP_Wrapper_Module_SetUp .LT. 1 ) CALL Initialize_CRP_Wrapper_Module()

    IF ( PES%Symmetry .EQ. 3 ) THEN
      CALL Calculate_CRP_C3v_AtomSurface_PES( PES, R, V, F, OutUnits )
    ELSE IF ( PES%Symmetry .EQ. 4 ) THEN
      CALL Calculate_CRP_C4v_AtomSurface_PES( PES, R, V, F, OutUnits )
    ELSE IF ( PES%Symmetry .EQ. 6 ) THEN
      CALL Calculate_CRP_C6v_AtomSurface_PES( PES, R, V, F, OutUnits )
    END IF
  END SUBROUTINE

!*******************************************************************************
!*SUB* Calculate_CRP_MoleculeSurface_PES
!*******************************************************************************
!>
!>
!> @param PES
!> @param R
!> @param V
!> @param F
!> @param OutUnits
!*******************************************************************************
  SUBROUTINE Calculate_CRP_MoleculeSurface_PES( PES, R, V, F, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    REAL                 :: R(:), V, F(:)
    TYPE ( Units )                   :: OutUnits

    IF ( CRP_Wrapper_Module_SetUp .LT. 1 ) CALL Initialize_CRP_Wrapper_Module()

    IF ( PES%Symmetry .EQ. 3 ) THEN
      CALL Calculate_CRP_C3v_MoleculeSurface_PES( PES, R, V, F, OutUnits )
    ELSE IF ( PES%Symmetry .EQ. 4 ) THEN
      CALL Calculate_CRP_C4v_MoleculeSurface_PES( PES, R, V, F, OutUnits )
    ELSE IF ( PES%Symmetry .EQ. 6 ) THEN
      CALL Calculate_CRP_C6v_MoleculeSurface_PES( PES, R, V, F, OutUnits )
    END IF
  END SUBROUTINE
END MODULE

!> General routines and types for doing the CRP.
MODULE CRP_General
  USE Spline
  USE UnitConversion

! To initialize the module call:
!   SUBROUTINE Initialize_CRP_General_Module()

! This module provides the following functions:
!   SUBROUTINE CAMBCORD(xa,ya,za,xb,yb,zb,x,y,z,r,teta,fi)
!   SUBROUTINE CHECKR(zin,nin,zc,nc)
!   SUBROUTINE DPL2D(ax,im,ay,jn,x,m,y,n,f,cx,cy,cint,idx,idy,res)
!   FUNCTION DPL(n,x,y,m,t)
!   FUNCTION DPLP(n,x,y,m,t)
!   SUBROUTINE DPLCOFT(n,x,t,c,dc,k)
!   SUBROUTINE DSPLIN(n,x,y,cm,cm1,ic1,cmn,icn,alpha,beta,b)
!   SUBROUTINE LOCATE(t,k,x,n)
!   SUBROUTINE SPLCOFII(x,y,x0,y0,ia,ja,idx,idy)
!   SUBROUTINE SPLIN2D(x,m,y,n,f,cx,cy,cint,idx,idy)
!   SUBROUTINE SPLINII(f,d2fdx,d2fdy,d4fdydx,ia,ja,vint,idx,idy)
!   SUBROUTINE SPLINT(xa,ya,cya,n,x,y,yp)
!   SUBROUTINE TRICYCLE(alpha,beta,gamma,cbot,ctop,b,x,n,z)
!   SUBROUTINE TRIDIA(alpha,beta,gamma,b,x,n)
!   SUBROUTINE TRISPL(n,x,y,cm,alpha,beta,gamma,b,bz)
!   SUBROUTINE UBICAR(XA,X,N,KLO,PARO)

!> A 1D cut from the 3D atom-surface PES.
  TYPE PESCut3D
    REAL    :: X, Y
    TYPE (Spline1D)     :: Spline
    CHARACTER(LEN = 50) :: FileName
  END TYPE PESCut3D

!> A 2D cut from the 6D atom-surface PES.
  TYPE PESCut6D
    REAL    :: X, Y, Theta, Phi
    TYPE (Spline2D)     :: Spline
    CHARACTER(LEN = 50) :: FileName
  END TYPE

!> The 2D (Z,r) gas phase potential.
  TYPE CRP_GasPhase_2D
    TYPE (Spline1D)  :: Zdep, Rdep     ! The Z and R dependence of the gas phase potential
    REAL :: ZsoMin, ZsoMax ! The values of Z between which switching occurs
  END TYPE CRP_GasPhase_2D

!> The geometry of the slab.
  TYPE Slab_Geometry
    REAL          :: LatticeConstant
    INTEGER                   :: NumLayers
    LOGICAL       :: Alloced = .FALSE.
    REAL, POINTER :: InterlayerSpacings(:)
  END TYPE

!> The dataset for the 1D molecule-surface PES
  TYPE CRP_AtomSurface_PES
    CHARACTER(LEN = 50)      :: DataSet         ! The name of the data set
    REAL                     :: Mixing          ! Mixing coefficient
    TYPE (Slab_Geometry)     :: Geometry       ! The geometry of the slab
    INTEGER                  :: Symmetry        ! The symmetry of the surface
    TYPE (Spline1D)          :: CorrugationFunction1D ! The 1D corrugation function
    INTEGER                  :: NumCuts
    TYPE (PESCut3D), POINTER :: Cuts(:) ! The 1D cuts through the 3D surface
    TYPE (Spline3DPeriodic)  :: SplineFunction ! The spline function of the PES, if used (currently in C4v code)
    TYPE (Units)             :: InputUnits
    REAL                     :: Disp1, Disp2
    LOGICAL                  :: Alloced = .FALSE.
    CHARACTER( LEN=255 )     :: InfoShort = "", InfoLong = "", InfoRef = ""
  END TYPE CRP_AtomSurface_PES

!> The dataset for the 6D molecule-surface PES
  TYPE CRP_MoleculeSurface_PES
    CHARACTER(LEN = 50)        :: DataSet         ! The name of the data set
    REAL                       :: Mixing          ! Mixing coefficient
    TYPE (Slab_Geometry)       :: Geometry       ! The geometry of the slab
    INTEGER                    :: Symmetry        ! The symmetry of the surface
    REAL                       :: ccDef ! Some parameters of the PES
    TYPE (CRP_AtomSurface_PES) :: AtomSurface ! The associated AtomSurface PES
    TYPE (CRP_GasPhase_2D)     :: GasPhase     ! The gas phase potential
    INTEGER                    :: NumCuts
    TYPE (PESCut6D), POINTER   :: Cuts(:) ! The 2D cuts through the 6D surface
    LOGICAL                    :: CutsInterpolation ! Do the cuts describe the interpolation function?
    TYPE (Units)               :: InputUnits
    REAL                       :: Rmin, Rmax, Zmin, Zasy
    LOGICAL                    :: Alloced = .FALSE.
    CHARACTER( LEN=255 )       :: InfoShort = "", InfoLong = "", InfoRef = ""
  END TYPE CRP_MoleculeSurface_PES

CONTAINS

!  SUBROUTINE Initialize_CRP_General_Module()
!    IMPLICIT NONE
!  END SUBROUTINE

  SUBROUTINE Allocate_Slab_Geometry( Geometry )
    IMPLICIT NONE

    TYPE ( Slab_Geometry ) :: Geometry

    ALLOCATE( Geometry%InterlayerSpacings( Geometry%NumLayers - 1 ) )
    Geometry%Alloced = .TRUE.
  END SUBROUTINE

  SUBROUTINE Deallocate_Slab_Geometry( Geometry )
    IMPLICIT NONE

    TYPE ( Slab_Geometry ) :: Geometry

    DEALLOCATE( Geometry%InterlayerSpacings )
    Geometry%Alloced = .FALSE.
  END SUBROUTINE

  SUBROUTINE Deallocate_PESCut3D( Cut )
    IMPLICIT NONE

    TYPE ( PESCut3D ) :: Cut

    CALL Deallocate_Spline1D( Cut%Spline )
  END SUBROUTINE

  SUBROUTINE Deallocate_PESCut6D( Cut )
    IMPLICIT NONE

    TYPE ( PESCut6D ) :: Cut

    CALL Deallocate_Spline2D( Cut%Spline )
  END SUBROUTINE

  SUBROUTINE Destroy_CRP_GasPhase_PES( PES )
    IMPLICIT NONE

    TYPE ( CRP_GasPhase_2D ) :: PES

    CALL Deallocate_Spline1D( PES%Zdep )
    CALL Deallocate_Spline1D( PES%Rdep )
    PES%ZsoMin = 0.0
    PES%ZsoMax = 0.0
  END SUBROUTINE

  SUBROUTINE Destroy_CRP_AtomSurface_PES( PES )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    INTEGER :: i

    PES%DataSet = ""
    PES%Mixing = 0.0
    CALL Deallocate_Slab_Geometry( PES%Geometry )
    CALL Deallocate_Spline1D( PES%CorrugationFunction1D )
    DO i = 1, PES%NumCuts
      CALL Deallocate_PESCut3D( PES%Cuts(i) )
    END DO
    DEALLOCATE( PES%Cuts )
    IF ( PES%Symmetry .EQ. 4 ) THEN
      CALL Deallocate_Spline3DPeriodic( PES%SplineFunction )
    END IF
    PES%Symmetry = 0
    PES%Disp1 = 0.0
    PES%Disp2 = 0.0
    PES%InfoShort = ""
    PES%InfoLong = ""
    PES%InfoRef = ""
    PES%Alloced = .FALSE.
  END SUBROUTINE

  SUBROUTINE Destroy_CRP_MoleculeSurface_PES( PES )
    IMPLICIT NONE

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    INTEGER :: i

    PES%DataSet = ""
    PES%Mixing = 0.0
    CALL Deallocate_Slab_Geometry( PES%Geometry )
    PES%Symmetry = 0
    PES%ccDef = 0.0
    CALL Destroy_CRP_AtomSurface_PES( PES%AtomSurface )
    CALL Destroy_CRP_GasPhase_PES( PES%GasPhase )
    DO i = 1, PES%NumCuts
      CALL Deallocate_PESCut6D( PES%Cuts(i) )
    END DO
    DEALLOCATE( PES%Cuts )
    PES%CutsInterpolation = .FALSE.
    PES%Zmin = 0.0
    PES%Zasy = 0.0
    PES%Rmin = 0.0
    PES%Rmax = 0.0
    PES%InfoShort = ""
    PES%InfoLong = ""
    PES%InfoRef = ""
    PES%Alloced = .FALSE.
  END SUBROUTINE

!************************ C A M B C O R D ****************************
      SUBROUTINE CAMBCORD(xa,ya,za,xb,yb,zb,x,y,z,r,teta,fi,PES)

!     Calculates the coordinates X,Y,Z (referred to an origin O
!     on the internuclear axis as defined below) and r,theta,phi from
!     the nuclear coordinates (xa,ya,za,xb,yb,zb).
!     The internuclear vector points from A to B.

      IMPLICIT NONE

      TYPE (CRP_MoleculeSurface_PES) :: PES

!       CCDEF: defines the coordinate origin O used to produce the set
!              of molecular data. O is on the internuclear axis and
!              such that OA=|r_B-r_A|*ccdef and OB=|r_B-r_A|*(1-ccdef)

!      REAL rmax,zccmin,ccdef
!      COMMON/DATLIM/rmax,zccmin,ccdef

      REAL xa,ya,za,xb,yb,zb,x,y,z,r,teta,fi,argdacos,dx,dy

      r=SQRT((xb-xa)**2+(yb-ya)**2+(zb-za)**2)
      IF (r.EQ.0.0) THEN
         WRITE(*,*)'ERROR, r=0'
         STOP
      ENDIF
      x=xa*(1.0-PES%ccdef)+xb*PES%ccdef
      y=ya*(1.0-PES%ccdef)+yb*PES%ccdef
      z=za*(1.0-PES%ccdef)+zb*PES%ccdef
      argdacos=(zb-za)/r
      IF (argdacos.GT.1.0) argdacos=1.0
      teta=ACOS(argdacos)
      dx=xb-xa
      dy=yb-ya
      IF(dx.EQ.0.0.AND.dy.EQ.0.0) THEN
        fi=0.0
      ELSE
        fi=ATAN2(dy,dx)
      END IF

      END SUBROUTINE

!************************ C H E C K R ********************************

!     Replaces ZIN by an ordered set of all values of ZIN and ZC
!     (given by increasing order).
!     The first and last value must be the same in ZIN and ZC.

      SUBROUTINE CHECKR(zin,nin,zc,nc)
      IMPLICIT NONE !REAL*8 (a-h,o-z)

      REAL :: zin(:), zout(999), zc(999)
      INTEGER :: nin, nc, jmin, iout, i, j

      IF(zc(1).NE.zin(1)) THEN
        WRITE(*,*) 'Error in data'
        STOP
      END IF
      IF(zc(nc).NE.zin(nin)) THEN
        WRITE(*,*) 'Error in data'
        STOP
      END IF

      jmin=2
      iout=1
      zout(1)=zin(1)
      DO i=2,nc

        DO j=jmin,nin
          iout=iout+1
          IF(zc(i).EQ.zin(j)) THEN
            zout(iout)=zc(i)
            jmin=j+1
            GO TO 11
          ELSE IF(zc(i).LT.zin(j)) THEN
            zout(iout)=zc(i)
            GO TO 11
          ELSE
            zout(iout)=zin(j)
            jmin=j+1
          END IF
        END DO
11      CONTINUE

      END DO

      DO i=1,iout
        zin(i)=zout(i)
      END DO
      nin=iout

      END SUBROUTINE
END MODULE

!***************************************************************************************
!*                              ErrorTrap
!***************************************************************************************
!*
!*        CONTAINS:           SetupErrorTrapModule()
!*                            DisposeErrorTrapModule()
!*
!*                            ERROR( Test, Message )
!*                            WARN( Test, Message )
!*                            AbortWithError( Message )
!*                            ShowWarning( Message )
!*                            ShowError( Message )
!*
!***************************************************************************************
!*
!*        AUTHOR(S):          1st: M.F.Somers, may 2002.
!*
!***************************************************************************************

MODULE ErrorTrap

INTEGER :: ErrorTrapModuleSetupFlag = 0

CONTAINS

!***************************************************************************************
!* Setup the module ...

SUBROUTINE SetupErrorTrapModule( )
IMPLICIT NONE

    ErrorTrapModuleSetupFlag = ErrorTrapModuleSetupFlag + 1
    IF( ErrorTrapModuleSetupFlag > 1 ) RETURN

END SUBROUTINE SetupErrorTrapModule

!***************************************************************************************
!* Setup the module ...

SUBROUTINE DisposeErrorTrapModule( )
IMPLICIT NONE
    
    IF(ErrorTrapModuleSetupFlag<=0) RETURN
    ErrorTrapModuleSetupFlag = ErrorTrapModuleSetupFlag - 1
    IF( ErrorTrapModuleSetupFlag > 0 ) RETURN

END SUBROUTINE DisposeErrorTrapModule

!***************************************************************************************
!* Displays an error message to stdout...

SUBROUTINE ShowError( Message )
IMPLICIT NONE
CHARACTER(*) :: Message

    IF( ErrorTrapModuleSetupFlag <= 0 ) CALL SetupErrorTrapModule()

    PRINT *
    PRINT '(A,A)', 'ERROR: ', TRIM(Message)
    PRINT *

END SUBROUTINE ShowError

!***************************************************************************************
!* Displays a warning message to stdout...

SUBROUTINE ShowWarning( Message )
IMPLICIT NONE
CHARACTER(*) :: Message

    IF( ErrorTrapModuleSetupFlag <= 0 ) CALL SetupErrorTrapModule()

    PRINT *
    PRINT '(A,A)', 'WARNING: ', TRIM(Message)
    PRINT *

END SUBROUTINE ShowWarning

!***************************************************************************************
!* Displays a message to stdout en stops the program...

SUBROUTINE AbortwithError( String )
IMPLICIT NONE
CHARACTER(*) :: String

         IF( ErrorTrapModuleSetupFlag <= 0 ) CALL SetupErrorTrapModule()

         CALL ShowError( String )

         STOP

END SUBROUTINE AbortWithError

!***************************************************************************************
!* Test the test given and if true, error message is displayed and program aborted...

SUBROUTINE ERROR( Test, Message )
IMPLICIT NONE
LOGICAL       :: Test
CHARACTER(*)  :: Message

    IF( ErrorTrapModuleSetupFlag <= 0 ) CALL SetupErrorTrapModule()

    IF( Test ) CALL AbortWithError(Message)

END SUBROUTINE ERROR

!***************************************************************************************
!* Test the test given and if true the warning is displayed...

SUBROUTINE WARN( Test, Message )
IMPLICIT NONE
LOGICAL       :: Test
CHARACTER(*)  :: Message

    IF( ErrorTrapModuleSetupFlag <= 0 ) CALL SetupErrorTrapModule()

    IF( Test ) CALL ShowWarning(Message)

END SUBROUTINE WARN

!***************************************************************************************

END MODULE ErrorTrap

!*******************************************************************************
!*MOD* Spline
!*******************************************************************************
!> Spline interpolation library.
!*******************************************************************************
MODULE Spline

!> The dataset for a 1D spline interpolation.
  TYPE Spline1D
    LOGICAL       :: Alloced = .FALSE.
    REAL, POINTER :: X(:), F(:), Coefs(:)
    INTEGER       :: NX = 0
  END TYPE Spline1D

!> The dataset for a 2D spline interpolation.
  TYPE Spline2D
    LOGICAL       :: Alloced = .FALSE.
    REAL, POINTER :: X(:), Y(:), F(:,:), CoefsX(:,:), CoefsY(:,:), CoefsXY(:,:)
    INTEGER       :: NX = 0, NY = 0
  END TYPE

!> The dataset for a periodic 3D spline interpolation.
  TYPE Spline3DPeriodic
    LOGICAL       :: Alloced = .FALSE.
    REAL, POINTER :: X(:), Y(:), Z(:), F(:,:,:), Der1(:,:), Der2(:,:), CoefsX(:,:,:), CoefsY(:,:,:), &
                     CoefsXY(:,:,:), CoefsZ(:,:,:), CoefsZX(:,:,:), CoefsZY(:,:,:), CoefsZXY(:,:,:)
    INTEGER       :: NX = 0, NY = 0, NZ = 0
  END TYPE

  TYPE UBIType
    REAL :: ax0, bx0, cx0, dx0, ay0, by0, cy0, dy0, ax0p, bx0p, cx0p, dx0p, ay0p, by0p, cy0p, dy0p
  END TYPE

  TYPE KODSPLType
    INTEGER :: kod, k, iw, iligne
  END TYPE

!> Wrapper for computing a 1D spline.
  INTERFACE Compute_Spline1D
    MODULE PROCEDURE Compute_Spline1D_Simple, Compute_Spline1D_Advanced
  END INTERFACE

!  PRIVATE :: DPL, DSPLIN, SPLINT, TRISPL
  PRIVATE :: DPL2D, DPLCOFT, DPLP, LOCATE, SPLCOFII, SPLIN2D, SPLINII, TRICYCLE, TRIDIA !, UBICAR

CONTAINS

!*******************************************************************************
!*SUB* Initialize_Spline_Module
!*******************************************************************************
!> Initialize the Spline module. Must be called before use.
!*******************************************************************************
  SUBROUTINE Initialize_Spline_Module()
    IMPLICIT NONE

    !COMMON /KODSPL/ kod, k, iw, iligne
    !INTEGER :: kod, k, iw, iligne

    !iw = 6
    !iligne = 100
    !k = 2
  END SUBROUTINE

!*******************************************************************************
!*SUB* Allocate_Spline1D
!*******************************************************************************
!> Allocate space to store a 1D spline.
!>
!> @param Spline The dataset to allocate.
!> @param NX The number of points to allocate.
!*******************************************************************************
  SUBROUTINE Allocate_Spline1D( Spline, NX )
    IMPLICIT NONE

    TYPE (Spline1D) :: Spline
    INTEGER         :: NX

    Spline%Alloced = .TRUE.
    Spline%NX = NX
    ALLOCATE( Spline%X(NX) )
    ALLOCATE( Spline%F(NX) )
    ALLOCATE( Spline%Coefs(NX) )
  END SUBROUTINE

  SUBROUTINE Deallocate_Spline1D( Spline )
    IMPLICIT NONE

    TYPE (Spline1D) :: Spline

    Spline%Alloced = .FALSE.
    Spline%NX = 0
    DEALLOCATE( Spline%X )
    DEALLOCATE( Spline%F )
    DEALLOCATE( Spline%Coefs )
  END SUBROUTINE

!*******************************************************************************
!*SUB* Allocate_Spline2D
!*******************************************************************************
!> Allocate space to store a 2D spline.
!>
!> @param Spline The dataset to allocate.
!> @param NX The number of points in X.
!> @param NY The number of points in Y.
!*******************************************************************************
  SUBROUTINE Allocate_Spline2D( Spline, NX, NY )
    IMPLICIT NONE

    TYPE (Spline2D) :: Spline
    INTEGER         :: NX, NY

    Spline%Alloced = .TRUE.
    Spline%NX = NX
    Spline%NY = NY
    ALLOCATE( Spline%X(NX) )
    ALLOCATE( Spline%Y(NY) )
    ALLOCATE( Spline%F(NX,NY) )
    ALLOCATE( Spline%CoefsX(NX,NY) )
    ALLOCATE( Spline%CoefsY(NX,NY) )
    ALLOCATE( Spline%CoefsXY(NX,NY) )
  END SUBROUTINE

  SUBROUTINE Deallocate_Spline2D( Spline )
    IMPLICIT NONE

    TYPE (Spline2D) :: Spline

    Spline%Alloced = .FALSE.
    Spline%NX = 0
    Spline%NY = 0
    DEALLOCATE( Spline%X )
    DEALLOCATE( Spline%Y )
    DEALLOCATE( Spline%F )
    DEALLOCATE( Spline%CoefsX )
    DEALLOCATE( Spline%CoefsY )
    DEALLOCATE( Spline%CoefsXY )
  END SUBROUTINE

!*******************************************************************************
!*SUB* Allocate_Spline3DPeriodic
!*******************************************************************************
!> Allocate space to store a 3D spline with periodic conditions in X and Y.
!> 
!> @param Spline The dataset to allocate.
!> @param NX The number of points in X.
!> @param NY The number of points in Y.
!> @param NZ The number of points in Z.
!*******************************************************************************
  SUBROUTINE Allocate_Spline3DPeriodic( Spline, NX, NY, NZ )
    IMPLICIT NONE

    TYPE (Spline3DPeriodic) :: Spline
    INTEGER                 :: NX, NY, NZ

    Spline%Alloced = .TRUE.
    Spline%NX = NX
    Spline%NY = NY
    Spline%NZ = NZ
    ALLOCATE( Spline%X(NX) )
    ALLOCATE( Spline%Y(NY) )
    ALLOCATE( Spline%Z(NZ) )
    ALLOCATE( Spline%F(NX,NY,NZ) )
    ALLOCATE( Spline%Der1(NX,NY) )
    ALLOCATE( Spline%Der2(NX,NY) )
    ALLOCATE( Spline%CoefsX(NX,NY,NZ) )
    ALLOCATE( Spline%CoefsY(NX,NY,NZ) )
    ALLOCATE( Spline%CoefsXY(NX,NY,NZ) )
    ALLOCATE( Spline%CoefsZ(NX,NY,NZ) )
    ALLOCATE( Spline%CoefsZX(NX,NY,NZ) )
    ALLOCATE( Spline%CoefsZY(NX,NY,NZ) )
    ALLOCATE( Spline%CoefsZXY(NX,NY,NZ) )

  END SUBROUTINE

  SUBROUTINE Deallocate_Spline3DPeriodic( Spline )
    IMPLICIT NONE

    TYPE (Spline3DPeriodic ) :: Spline

    Spline%Alloced = .FALSE.
    Spline%NX = 0
    Spline%NY = 0
    Spline%NZ = 0
    DEALLOCATE( Spline%X )
    DEALLOCATE( Spline%Y )
    DEALLOCATE( Spline%Z )
    DEALLOCATE( Spline%F )
    DEALLOCATE( Spline%Der1 )
    DEALLOCATE( Spline%Der2 )
    DEALLOCATE( Spline%CoefsX )
    DEALLOCATE( Spline%CoefsY )
    DEALLOCATE( Spline%CoefsXY )
    DEALLOCATE( Spline%CoefsZ )
    DEALLOCATE( Spline%CoefsZX )
    DEALLOCATE( Spline%CoefsZY )
    DEALLOCATE( Spline%CoefsZXY )
  END SUBROUTINE

!*******************************************************************************
!*SUB* Compute_Spline1D_Simple
!*******************************************************************************
!> Compute a 1 dimensional spline without special boundary conditions
!>
!> @param Spline The dataset to compute.
!*******************************************************************************
  SUBROUTINE Compute_Spline1D_Simple( Spline )
    IMPLICIT NONE

    TYPE (Spline1D)               :: Spline

    CALL DSPLIN( Spline%NX, Spline%X, Spline%F, Spline%Coefs, 0.0, 0, 0.0, 0 )
  END SUBROUTINE

!*******************************************************************************
!*SUB* Compute_Spline1D_Advanced
!*******************************************************************************
!> Compute a 1 dimensional spline with boundary conditions
!>
!> @param Spline The dataset to compute.
!> @param Condition1 The boundary condition on the first point (see DSPLIN)
!> @param Der1 Derivative on the first point (see DSPLIN)
!> @param ConditionN The boundary condition on the last point (see DSPLIN)
!> @param DerN Derivative on the last point (see DSPLIN)
!*******************************************************************************
  SUBROUTINE Compute_Spline1D_Advanced( Spline, Condition1, Der1, ConditionN, DerN )
    IMPLICIT NONE

    TYPE (Spline1D)  :: Spline
    INTEGER          :: Condition1, ConditionN
    REAL :: Der1, DerN

    CALL DSPLIN( Spline%NX, Spline%X, Spline%F, Spline%Coefs, Der1, Condition1, DerN, ConditionN )
  END SUBROUTINE

!*******************************************************************************
!*FNC* Evaluate_Spline1D
!*******************************************************************************
!> Evaluate a 1 dimensional spline
!>
!> @param Spline The dataset to use.
!> @param X The point on which to do the interpolation.
!> @returns The value of the function at X.
!*******************************************************************************
  FUNCTION Evaluate_Spline1D( Spline, X ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Spline1D) :: Spline
    REAL :: X, Val

    Val = DPL( Spline%NX, Spline%X, Spline%F, Spline%Coefs, X )
  END FUNCTION

!*******************************************************************************
!*FNC* Evaluate_Spline1D_Derivative
!*******************************************************************************
!> Evaluate the derivative of a 1 dimensional spline
!>
!> @param Spline The dataset to use.
!> @param X The point on which to compute the derivative.
!> @returns The derivative of the function at X.
!*******************************************************************************
  FUNCTION Evaluate_Spline1D_Derivative( Spline, X ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Spline1D) :: Spline
    REAL :: X, Val

    Val = DPLP( Spline%NX, Spline%X, Spline%F, Spline%Coefs, X )
  END FUNCTION

!*******************************************************************************
!*SUB* Compute_Spline2D
!*******************************************************************************
!> Compute a 2 dimensional spline.
!> 
!> @param Spline The Spline2D to compute.
!*******************************************************************************
  SUBROUTINE Compute_Spline2D( Spline )
    IMPLICIT NONE

    TYPE (Spline2D) :: Spline

    CALL SPLIN2D( Spline%X, Spline%NX, Spline%Y, Spline%NY, &
                  Spline%F, Spline%CoefsX, Spline%CoefsY, Spline%CoefsXY, Spline%NX, Spline%NY)
  END SUBROUTINE

!*******************************************************************************
!*SUB* Compute_Spline3D_Periodic
!*******************************************************************************
!> Compute a 3 dimensional spline with periodic conditions in X and Y.
!> 
!> @param Spline The Spline3DPeriodic to compute.
!*******************************************************************************
  SUBROUTINE Compute_Spline3D_Periodic( Spline )
    IMPLICIT NONE

    TYPE (Spline3DPeriodic) :: Spline
    CALL SPLINE3D( Spline%X, Spline%NX, Spline%Y, Spline%NY, Spline%Z, Spline%NZ, Spline%F, Spline%Der1, 2, Spline%Der2, 2, &
                   Spline%CoefsX, Spline%CoefsY, Spline%CoefsXY, Spline%CoefsZ, Spline%CoefsZX, Spline%CoefsZY, Spline%CoefsZXY )
  END SUBROUTINE

!*******************************************************************************
!*FNC* Evaluate_Spline2D
!*******************************************************************************
!> Evaluate a 2 dimensional spline.
!> 
!> @param Spline The Spline2D to evaluate.
!> @param X The X to evaluate on.
!> @param Y The Y to evaluate on.
!> @returns The value at (X, Y).
!*******************************************************************************
  FUNCTION Evaluate_Spline2D( Spline, X, Y ) RESULT ( Val )
    IMPLICIT NONE

    TYPE (Spline2D)  :: Spline
    REAL :: X, Y, Val
    INTEGER :: i, j

    CALL DPL2D( X, i, Y, j, Spline%X, Spline%NX, Spline%Y, Spline%NY, &
                Spline%F, Spline%CoefsX, Spline%CoefsY, Spline%CoefsXY, Spline%NX, Spline%NY, Val )
  END FUNCTION

!*******************************************************************************
!*SUB* Evaluate_Spline2D_Alt
!*******************************************************************************
!> 
!> 
!> @param Spline 
!> @param X 
!> @param Y 
!> @param MyOut 
!> @param switch 
!*******************************************************************************
  SUBROUTINE Evaluate_Spline2D_Alt( Spline, X, Y, MyOut, switch )
    IMPLICIT NONE

    TYPE (Spline2D)  :: Spline
    INTEGER          :: iX, iY
    REAL :: X, Y, MyOut(3)
    LOGICAL          :: switch
    TYPE ( UBIType ) :: ubi

    CALL UBICAR( Spline%X, X, Spline%NX, iX, switch )
    IF (switch) RETURN
    CALL UBICAR( Spline%Y, Y, Spline%NY, iY, switch )
    IF (switch) RETURN
    CALL SPLCOFII( Spline%X, Spline%Y, X, Y, iX, iY, Spline%NX, Spline%NY, ubi )
    CALL SPLINII( Spline%F, Spline%CoefsX, Spline%CoefsY, Spline%CoefsXY, iX, iY, MyOut, Spline%NX, Spline%NY, ubi )
  END SUBROUTINE

!*******************************************************************************
!*SUB* Evaluate_Spline3D_Periodic
!*******************************************************************************
!> 
!> 
!> @param Spline 
!> @param X 
!> @param Y 
!> @param Z 
!> @param F 
!> @param dFdX 
!> @param dFdY 
!> @param dFdZ 
!*******************************************************************************
  SUBROUTINE Evaluate_Spline3D_Periodic( Spline, X, Y, Z, F, dFdX, dFdY, dFdZ )
    IMPLICIT NONE

    TYPE (Spline3DPeriodic) :: Spline
    REAL :: X, Y, Z, F, dFdX, dFdY, dFdZ

    CALL SPLINT3D( Spline%X, Spline%NX, Spline%Y, Spline%NY, Spline%Z, Spline%NZ, Spline%F, Spline%CoefsX, Spline%CoefsY, &
       Spline%CoefsXY, Spline%CoefsZ, Spline%CoefsZX, Spline%CoefsZY, Spline%CoefsZXY, X, Y, Z, F, dFdX, dFdY, dFdZ )
  END SUBROUTINE

!*******************************************************************************
!*SUB* DPL2D
!*******************************************************************************
!> 
!> 
!> @param ax 
!> @param im 
!> @param ay 
!> @param jn 
!> @param x 
!> @param m 
!> @param y 
!> @param n 
!> @param f 
!> @param cx 
!> @param cy 
!> @param cint 
!> @param idx 
!> @param idy 
!> @param res 
!*******************************************************************************
      SUBROUTINE DPL2D(ax,im,ay,jn,x,m,y,n,f,cx,cy,cint,idx,idy,res)
!
!     Calculate f(x,y) in 2D interpolation.
!
!       Author: A. Salin     Version: 2.0    15/01/99

!     AX, AY: point for which the interpolate is required.
!     IM, JN: localization of AX and AY in the last call
!     X,M: set of m abcissae
!     Y,N: set of n ordinates
!     F(i,j): value of functions at (x_i,y_j)
!     CX, CY, CINT: arrays of dimension (idx,idy)
!                   determined by subroutine SPL2D or SPLCYC2D
!     IDX, IDY: dimensions in calling program.
!     RES : value of interpolate.

!     Required subroutine: LOCATE

      IMPLICIT REAL (a-h,o-z)
      PARAMETER (s6=1.0/6.0)

      DIMENSION x(idx),y(idy),f(idx,idy),cx(idx,idy),cy(idx,idy),cint(idx,idy)

      CALL LOCATE(ax,im,x,m)
      CALL LOCATE(ay,jn,y,n)

      IF(im.LE.1.OR.im.GT.m) THEN
        WRITE(*,*) 'x=',ax,'outside interval in DPL2D'
        STOP
      END IF
      IF(jn.LE.1.OR.jn.GT.n) THEN
        WRITE(*,*) 'y=',ay,'outside interval in DPL2D'
        STOP
      END IF

      fx=x(im)-ax
      gx=ax-x(im-1)
      ex=fx+gx
      den=1.0/ex
      c2=-gx*fx*s6*den
      c1=c2*(fx+ex)
      c2=c2*(gx+ex)
      c3=fx*den
      c4=gx*den
!                                              Determine F(x,y_(jn-1))
      cx1=cx(im-1,jn-1)
      cx2=cx(im,jn-1)
      af1=f(im-1,jn-1)
      af2=f(im,jn-1)
      afj=c1*cx1+c2*cx2+c3*af1+c4*af2
!                                               Determine F(x,y_(jn))
      cx1=cx(im-1,jn)
      cx2=cx(im,jn)
      af1=f(im-1,jn)
      af2=f(im,jn)
      afjp=c1*cx1+c2*cx2+c3*af1+c4*af2
!                                               Determine c_(jn-1)(x)
      cx1=cint(im-1,jn-1)
      cx2=cint(im,jn-1)
      af1=cy(im-1,jn-1)
      af2=cy(im,jn-1)
      cy1=c1*cx1+c2*cx2+c3*af1+c4*af2

!                                                 Determine c_(jn)(x)
      cx1=cint(im-1,jn)
      cx2=cint(im,jn)
      af1=cy(im-1,jn)
      af2=cy(im,jn)
      cy2=c1*cx1+c2*cx2+c3*af1+c4*af2
!                                                    Determine f(x,y)
      fy=y(jn)-ay
      gy=ay-y(jn-1)
      ey=fy+gy
      res=(-gy*fy*s6*(cy1*(fy+ey)+cy2*(gy+ey))+(gy*afjp+fy*afj))/ey

      END SUBROUTINE

!*******************************************************************************
!*SUB* DPLCOFT
!*******************************************************************************
!> 
!> 
!> @param n 
!> @param x 
!> @param t 
!> @param c 
!> @param dc 
!> @param k 
!*******************************************************************************
      SUBROUTINE DPLCOFT(n,x,t,c,dc,k)

!     Calculates coefficients for the spline interpolation of a
!     function (C) and its derivative (DC) at point T. The N nodes are
!     X. K is such that t.GE.x(k-1) and t.LT.x(k).

      IMPLICIT REAL (a-h,o-z)

      DIMENSION x(n),c(4),dc(4)

      IF(k.LE.1.OR.k.GT.n) THEN
        klo=0
        khi=n+1
      ELSE

      inc=1
      klo=k-1
      IF(t.GT.x(klo)) THEN
 10     khi=klo+inc
        IF(khi.GT.n) THEN
          khi=n+1
        ELSE IF(t.GT.x(khi)) THEN
          klo=khi
          inc=inc+inc
          GO TO 10
        END IF
      ELSE
        khi=klo
 20     klo=khi-inc
        IF(klo.LT.1) THEN
          klo=0
        ELSE IF(t.LT.x(klo)) THEN
          khi=klo
          inc=inc+inc
          GO TO 20
        END IF
      END IF

      END IF

100   CONTINUE
      IF(khi-klo.GT.1) THEN
        km=(khi+klo)/2
        IF(t.GT.x(km)) THEN
          klo=km
        ELSE
          khi=km
        END IF
        GO TO 100
      END IF
        k=klo+1

      IF(t.EQ.x(1)) k=2

        f=x(k)-t
        g=t-x(k-1)
        e=f+g
        se=1.0/e
        se6=se/6.0
        h=-g*f*se6
        c(1)=h*(f+e)
        c(2)=h*(g+e)
        c(3)=f*se
        c(4)=g*se
        dc(1)=-h-(f+e)*(f-g)*se6
        dc(2)=h-(g+e)*(f-g)*se6
        dc(3)=-se
        dc(4)=se

      END SUBROUTINE

!*******************************************************************************
!*FNC* DPL
!*******************************************************************************
!> 
!> 
!> @param n 
!> @param x 
!> @param y 
!> @param m 
!> @param t 
!> @returns 
!*******************************************************************************
      REAL FUNCTION DPL(n,x,y,m,t)

!        Version 3.0  - 15/1/97       Author: A. SALIN

!        Calculation of a function by interpolation. Double precision.
!        See comments in SUBROUTINE DSPLIN

      IMPLICIT NONE !REAL (a-h,o-z)

      INTEGER          :: n
      REAL :: x(n), y(n), m(n), t
      REAL :: e, f, g
      INTEGER          :: khi, klo, km, inc, k
      LOGICAL          :: order

      !COMMON/KODSPL/kod,k,iw,iligne

    1 FORMAT(' DPL: extrapolation - ',1PE15.8,' <',E15.8)
    2 FORMAT(' DPL: extrapolation - ',1PE15.8,' >',E15.8)

      k = 2

      order=x(2).GT.x(1)
      IF(k.LE.1.OR.k.GT.n) THEN
        klo=0
        khi=n+1
        GO TO 100
      END IF

      inc=1
      klo=k-1
      IF(t.GT.x(klo).EQV.order) THEN
 10     khi=klo+inc
        IF(khi.GT.n) THEN
          khi=n+1
        ELSE IF(t.GT.x(khi).EQV.order) THEN
          klo=khi
          inc=inc+inc
          GO TO 10
        END IF
      ELSE
        khi=klo
 20     klo=khi-inc
        IF(klo.LT.1) THEN
          klo=0
        ELSE IF(t.LT.x(klo).EQV.order) THEN
          khi=klo
          inc=inc+inc
          GO TO 20
        END IF
      END IF

 100  CONTINUE
      IF(khi-klo.GT.1) THEN
        km=(khi+klo)/2
        IF(t.GT.x(km).EQV.order) THEN
          klo=km
        ELSE
          khi=km
        END IF
        GO TO 100
      END IF
        k=klo+1

      IF(t.EQ.x(1)) k=2
      IF(k.LE.1) THEN
        e=x(2)-x(1)
        DPL=((y(2)-y(1))/e-m(2)*e/6.0)*(t-x(1))+y(1)
        !kod=1
        !IF(iw.GT.0.AND.iligne.GT.0) THEN
        !  IF(order) THEN
        !    WRITE(iw,1) t,x(1)
        !  ELSE
        !    WRITE(iw,2) t,x(1)
        !  END IF
        !  iligne=iligne-1
        !END IF
      ELSE IF(k.GT.n) THEN
        e=x(n)-x(n-1)
        DPL=((y(n)-y(n-1))/e+m(n-1)*e/6.0)*(t-x(n))+y(n)
        !kod=2
        !IF(iw.GT.0.AND.iligne.GT.0) THEN
        !  IF(order) THEN
        !    WRITE(iw,2) t,x(n)
        !  ELSE
        !    WRITE(iw,1) t,x(n)
        !  END IF
        !  iligne=iligne-1
        !END IF
      ELSE
        f=x(k)-t
        g=t-x(k-1)
        e=f+g
        DPL=(-g*f*(m(k-1)*(f+e)+m(k)*(g+e))+6.0*(g*y(k)+f*y(k-1)))/(6.0*e)
        !kod=0
      END IF
      END FUNCTION

!*******************************************************************************
!*FNC* DPLP
!*******************************************************************************
!> 
!> 
!> @param n 
!> @param x 
!> @param y 
!> @param m 
!> @param t 
!> @returns 
!*******************************************************************************
      REAL FUNCTION DPLP(n,x,y,m,t)

!        Version 3.0  - 17/1/97       Author: A. SALIN

!        Calculation of the derivative of a function by interpolation.
!        Double precision. See comments in SUBROUTINE DSPLIN.
!        If t is outside the interval over which the function is
!        defined, the derivative is extrapolated linearly from its
!        value for the first two (last two) points of the interval.

      IMPLICIT NONE

      INTEGER          :: n
      REAL :: x(n), y(n), m(n), t
      REAL :: e, e2, f, g
      INTEGER          :: khi, klo, km, inc, k
      LOGICAL          :: order

      !COMMON/KODSPL/kod,k,iw,iligne

    1 FORMAT(' DPLP: extrapolation - ',1PE15.8,' <',E15.8)
    2 FORMAT(' DPLP: extrapolation - ',1PE15.8,' >',E15.8)

      k = 2

      order=x(2).GT.x(1)
      IF(k.LE.1.OR.k.GT.n) THEN
        klo=0
        khi=n+1
        GO TO 100
      END IF

      inc=1
      klo=k-1
      IF(t.GT.x(klo).EQV.order) THEN
 10     khi=klo+inc
        IF(khi.GT.n) THEN
          khi=n+1
        ELSE IF(t.GT.x(khi).EQV.order) THEN
          klo=khi
          inc=inc+inc
          GO TO 10
        END IF
      ELSE
        khi=klo
 20     klo=khi-inc
        IF(klo.LT.1) THEN
          klo=0
        ELSE IF(t.LT.x(klo).EQV.order) THEN
          khi=klo
          inc=inc+inc
          GO TO 20
        END IF
      END IF

 100  CONTINUE
      IF(khi-klo.GT.1) THEN
        km=(khi+klo)/2
        IF(t.GT.x(km).EQV.order) THEN
          klo=km
        ELSE
          khi=km
        END IF
        GO TO 100
      END IF
        k=klo+1

      IF(t.EQ.x(1)) k=2
      IF(k.LE.1) THEN
        e=x(2)-x(1)
        g=t-x(1)
        f=x(2)-t
        DPLP=(y(2)-y(1))/e+(m(2)*(2*g-f)+m(1)*(g-2*f))/6.0
        !kod=1
        !IF(iw.GT.0.AND.iligne.GT.0) THEN
        !  IF(order) THEN
        !    WRITE(iw,1) t,x(1)
        !  ELSE
        !    WRITE(iw,2) t,x(1)
        !  END IF
        !  iligne=iligne-1
        !END IF
      ELSE IF(k.GT.n) THEN
        e=x(n)-x(n-1)
        g=t-x(n-1)
        f=x(n)-t
        DPLP=(y(n)-y(n-1))/e+(m(n)*(2*g-f)+m(n-1)*(g-2*f))/6.0
        !kod=2
        !IF(iw.GT.0.AND.iligne.GT.0) THEN
        !  IF(order) THEN
        !    WRITE(iw,2) t,x(n)
        !  ELSE
        !    WRITE(iw,1) t,x(n)
        !  END IF
        !  iligne=iligne-1
        !END IF
      ELSE
        f=x(k)-t
        g=t-x(k-1)
        e=f+g
        e2=e*e
        DPLP=(-m(k-1)*(3.0*f*f-e2)+m(k)*(3.0*g*g-e2)+6.0*(y(k)-y(k-1)))/(6.0*e)
        !kod=0
      END IF
      END FUNCTION

!*******************************************************************************
!*SUB* DSPLIN
!*******************************************************************************
!> Interpolation package. Given a set of n couples x(i),y(i),
!> DSPLIN defines a cubic spline function F(x) such that:
!>   1)- F(x(i)) = y(i)
!>   2)- F(x), F'(x), F''(x) are continuous in the interval [x(1),x(n)].
!> Required subroutine: TRIDIA.
!> 
!> @param n 
!> @param x 
!> @param y 
!> @param cm 
!> @param cm1 
!> @param ic1 
!> @param cmn 
!> @param icn 
!*******************************************************************************
      SUBROUTINE DSPLIN(n,x,y,cm,cm1,ic1,cmn,icn)!,alpha,beta,b)
!
!        Author: A. Salin   Version 3.2  20/1/86 - 10/6/97
!
!     ****SUBROUTINE DSPLIN: calculates the vector F''(x(i)) which
!     defines the cubic spline function F(x).
!          N= number of pivots x(i).
!          X= array of abcissae. Should be stored by increasing or
!     decreasing order.
!          Y= array of values of Y(i).
!          CM= array of F''(x(i)) with dimension equal to that of X
!     and Y.
!          IC1,CM1,ICN,CMN: define the condition at x(1) and x(n)
!     If IC1=0, function is the same in first two intervals.
!     If IC1=1, second derivative at x(1) given in CM1
!     If IC1=2, first derivative at x(1) given in CM1
!     IF IC1>2, zero second derivative at x(1)
!          Similar definitions for ICN and CMN around x(n)
!          ALPHA, BETA, B are working arrays of dimension N at least.
!     For cyclic spline use the program TRISPL.
!
!     ****DPLCOF: the interpolated function at R is:
!       F=C(1)*CM(K-1)+C(2)*CM(K)+C(3)*Y(K-1)+C(4)*Y(K)
!       where C is obtained from:
!       CALL DPLCOF(n,x,r,c,k)
!       The vector C should be of dimension 4.
!
!     ****Functions DPL,DPLP,DPLP2: calculate respectively the function
!     F(x), its first or second derivative:
!             N= number of pivots
!             X,Y,M= same as X,Y,CM in DSPLIN.
!             T= value for which the function (or its derivative)
!     must be determined.
!     WARNING: when T is outside the interval [X(1),X(N)], F(X)
!     *******  (resp. F', F") is determined by linear extrapolation
!              using the value of F (resp. F', F") for the first two
!              (last two) points in the interval.
!
!     ****Subroutine DINITI et DINTSP: calculate the integral of the
!     function F(x) from X(1) to T. The subroutine DINITI should first
!     be called before the first CALL DINTSP concerning a given
!     function F(x). DINITI calculates the array (CI) of values of the
!     integral of F(x) from X(1) to all X(i).
!
!        Arguments of DINITI:
!             N,X,Y,CM: as in subroutine DSPLIN.
!             CI: array of dimension at least N.
!        Arguments of DINTSP:
!             N,X,Y,CM,CI: as in DINITI
!             T: value of the upper limit of the integration (X(1).LT.T.
!     LE.X(N)).
!             B: value of the integral.
!       The calculations in DINTSP are nearly as rapid as for the deter
!     mination of the function F(x) by DPL.
!
!     Parameters of COMMON/KODSPL/:
!     -----------------------------------------------------
!       -KOD= after execution of one subroutine of the package, KOD
!     takes the value:
!              *0: no error
!              *-1: values of X(i) are not stored in correct order.
!              *1: T outside the interval [X(1),X(N)]. Linear extrapo-
!     lation done using X(1) and X(2).
!              *2: T outside the interval [X(1),X(N)]. Linear extrapo-
!     lation done using X(n-1) and X(n).
!       -K= after the execution of DPL, DPLP or DPLP2, K is such that
!     T lies in the interval [X(k-1),X(k)].
!       -IW= error messages are printed on unit IW unless IW.LE.0
!     Default: 6.
!       -ILIGNE: when T is outside the interval [X(1),X(n)], DPL, DPLP
!     and DPLP2 print a message if ILIGNE.GT.0. The initial value of
!     ILIGNE (defined by DATA) is 100. For every extrapolation, the
!     value is decreased by 1.
!
!     ***************************************************************

      IMPLICIT NONE

!      REAL :: six, douze, zero
!      PARAMETER (six=6.0,douze=12.0,zero=0.0)

      INTEGER, INTENT(IN)          :: n, ic1, icn
      REAL, INTENT(IN) :: x(n), y(n), cm1, cmn
      REAL, INTENT(OUT) :: cm(n)
      REAL             :: alpha(n), beta(n), b(n)
      REAL             :: a, c, d, e, s1, sn, fab1, fabn, fac1, facn
      INTEGER                      :: i, i2

      !INTEGER :: kod, k, iw, iligne
      !COMMON /KODSPL/ kod, k, iw, iligne

   91 FORMAT('Error in the data for DSPLIN',/,'Check abcissae:',1PD15.8,1X,' and ',D15.8,/,'Program stopped')

!                                           Contour condition at X(1)
      IF(ic1.EQ.0) THEN
        s1=0.0
        fac1=(x(2)-x(1))*(1.0+(x(2)-x(1))/(x(3)-x(2)))/6.0
        fab1=-(x(2)-x(1))**2/(6.0*(x(3)-x(2)))
      ELSE IF(ic1.EQ.1) THEN
        s1=-cm1*(x(2)-x(1))/6.0
        fac1=0.0
        fab1=0.0
      ELSE IF(ic1.EQ.2) THEN
        s1=0.5*(cm1-(y(2)-y(1))/(x(2)-x(1)))
        fac1=-(x(2)-x(1))/12.0
        fab1=0.0
      ELSE
!        WRITE(iw,*) 'DSPLIN: unknown condition - use default'
        s1=0.0
        fac1=0.0
        fab1=0.0
      END IF
!                                           Contour condition at X(n)
      IF(icn.EQ.0) THEN
        sn=0.0
        facn=(x(n)-x(n-1))*(1.0+(x(n)-x(n-1))/(x(n-1)-x(n-2)))/6.0
        fabn=-(x(n)-x(n-1))**2/(6.0*(x(n-1)-x(n-2)))
      ELSE IF(icn.EQ.1) THEN
        sn=-cmn*(x(n)-x(n-1))/6.0
        facn=0.0
        fabn=0.0
      ELSE IF(icn.EQ.2) THEN
        sn=-0.5*(cmn-(y(n)-y(n-1))/(x(n)-x(n-1)))
        facn=-(x(n)-x(n-1))/12.0
        fabn=0.0
      ELSE
!        WRITE(iw,*) 'DSPLIN: unknown condition - use default'
        sn=0.0
        facn=0.0
        fabn=0.0
      END IF

      !kod=0
      c=x(2)-x(1)
      e=(y(2)-y(1))/c
      DO i=3,n
        i2=i-2
        a=c
        c=x(i)-x(i-1)
        IF(a*c.LE.0.0) THEN
          !kod=-1
          !IF(iw.GT.0) WRITE(iw,91) x(i-1),x(i)
          STOP
          END IF
        alpha(i2)=(a+c)/3.0
        beta(i2)=c/6.0
        cm(i2)=beta(i2)
        d=e
        e=(y(i)-y(i-1))/c
        b(i2)=e-d
      END DO

      b(1)=b(1)+s1
      b(n-2)=b(n-2)+sn
      alpha(1)=alpha(1)+fac1
      alpha(n-2)=alpha(n-2)+facn
      cm(n-3)=cm(n-3)+fabn
      beta(1)=beta(1)+fab1
!                                            Solve tridiagonal system
      CALL TRIDIA(alpha,cm,beta,b,cm(2),n-2)

      IF(ic1.EQ.0) THEN
        cm(1)=cm(2)*(1.0+(x(2)-x(1))/(x(3)-x(2)))-cm(3)*(x(2)-x(1))/(x(3)-x(2))
      ELSE IF(ic1.EQ.1) THEN
        cm(1)=cm1
      ELSE IF(ic1.EQ.2) THEN
        cm(1)=-6.0*s1/(x(2)-x(1))-cm(2)/2.0
      ELSE
        cm(1)=0.0
      END IF

      IF(icn.EQ.0) THEN
        cm(n)=cm(n-1)*(1.0+(x(n)-x(n-1))/(x(n-1)-x(n-2)))-cm(n-2)*(x(n)-x(n-1))/(x(n-1)-x(n-2))
      ELSE IF(icn.EQ.1) THEN
        cm(n)=cmn
      ELSE IF(icn.EQ.2) THEN
        cm(n)=-6.0*sn/(x(n)-x(n-1))-cm(n-1)/2.0
      ELSE
        cm(n)=0.0
      END IF

      !k=2
      RETURN
      END SUBROUTINE

!*******************************************************************************
!*SUB* SPLCOFII
!*******************************************************************************
!> 
!> 
!> @param x 
!> @param y 
!> @param x0 
!> @param y0 
!> @param ia 
!> @param ja 
!> @param idx 
!> @param idy 
!> @param ubi 
!*******************************************************************************
      SUBROUTINE SPLCOFII(x,y,x0,y0,ia,ja,idx,idy,ubi)

!     This routine assumes that x0 and y0 are in the correct range.
!     If not, no message is issued and the results are wrong.
!     IA and JA indicate the position of X0 and y0 in the grid. They
!     give the index corresponding to the left/bottom corner of the
!     rectangle in which the point (x0,y0) is located.

      IMPLICIT NONE

      INTEGER          :: idx, idy, ia, ja
      REAL :: x(idx), y(idy), x0, y0
      REAL :: dxia2s6, dyja2s6

      TYPE ( UBIType ) :: ubi

      !COMMON/UBI/ax0,bx0,cx0,dx0,ay0,by0,cy0,dy0,ax0p,bx0p,cx0p,dx0p,ay0p,by0p,cy0p,dy0p

      dxia2s6=(x(ia+1)-x(ia))**2/6.0
      dyja2s6=(y(ja+1)-y(ja))**2/6.0
      ubi%ax0=(x(ia+1)-x0)/(x(ia+1)-x(ia))
      ubi%bx0=1.0-ubi%ax0
      ubi%cx0=(ubi%ax0**3-ubi%ax0)*dxia2s6
      ubi%dx0=(ubi%bx0**3-ubi%bx0)*dxia2s6

      ubi%ay0=(y(ja+1)-y0)/(y(ja+1)-y(ja))
      ubi%by0=1.0-ubi%ay0
      ubi%cy0=(ubi%ay0**3-ubi%ay0)*dyja2s6
      ubi%dy0=(ubi%by0**3-ubi%by0)*dyja2s6

      ubi%ax0p=-1.0/(x(ia+1)-x(ia))
      ubi%bx0p=-ubi%ax0p
      ubi%cx0p=(3.0*ubi%ax0**2*ubi%ax0p-ubi%ax0p)*dxia2s6
      ubi%dx0p=(3.0*ubi%bx0**2*ubi%bx0p-ubi%bx0p)*dxia2s6

      ubi%ay0p=-1.0/(y(ja+1)-y(ja))
      ubi%by0p=-ubi%ay0p
      ubi%cy0p=(3.0*ubi%ay0**2*ubi%ay0p-ubi%ay0p)*dyja2s6
      ubi%dy0p=(3.0*ubi%by0**2*ubi%by0p-ubi%by0p)*dyja2s6

      END SUBROUTINE

!*******************************************************************************
!*SUB* SPLIN2D
!*******************************************************************************
!> 
!> 
!> @param x 
!> @param m 
!> @param y 
!> @param n 
!> @param f 
!> @param cx 
!> @param cy 
!> @param cint 
!> @param idx 
!> @param idy 
!*******************************************************************************
      SUBROUTINE SPLIN2D(x,m,y,n,f,cx,cy,cint,idx,idy)
!
!     Two dimensional interpolation by Spline method.
!
!       Author: A. Salin     Version: 1.1    15/04/98 - 18/1/99

!     X,M: set of m abcissae
!     Y,N: set of n ordinates
!     F(i,j): value of functions at (x_i,y_j)
!     CX, CY, CINT: arrays of dimension (idx,idy) determined by
!                      subroutine SPLIN2D
!     IDX, IDY: dimension parameters in calling program

      IMPLICIT REAL (a-h,o-z)
      PARAMETER (idn=999)

      DIMENSION x(idx),y(idy),f(idx,idy),cx(idx,idy),cy(idx,idy),cint(idx,idy)
      DIMENSION cg(idn),g(idn)

      IF(idn.LT.idx.OR.idn.LT.idy) THEN
        WRITE(*,*) 'SPLIN2D: idn too small'
        STOP
      END IF

      DO j=1,n
        CALL DSPLIN(m,x,f(1,j),cx(1,j),0.0,0,0.0,0)
      END DO

      DO i=1,m
        DO j=1,n
          g(j)=f(i,j)
        END DO
        CALL DSPLIN(n,y,g,cg,0.0,0,0.0,0)
        DO j=1,n
          cy(i,j)=cg(j)
        END DO
      END DO

      DO j=1,n
        CALL DSPLIN(m,x,cy(1,j),cint(1,j),0.0,0,0.0,0)
      END DO

      END SUBROUTINE

!*******************************************************************************
!*SUB* SPLINII
!*******************************************************************************
!> 
!> 
!> @param f 
!> @param d2fdx 
!> @param d2fdy 
!> @param d4fdydx 
!> @param ia 
!> @param ja 
!> @param vint 
!> @param idx 
!> @param idy 
!> @param ubi 
!*******************************************************************************
      SUBROUTINE SPLINII(f,d2fdx,d2fdy,d4fdydx,ia,ja,vint,idx,idy,ubi)
!     ------------------------------------------------------------------

!     IA and JA indicate the position of X0 and y0 in the grid. They
!     give the index corresponding to the left/bottom corner of the
!     rectangle in which the point (x0,y0) is located.

      IMPLICIT NONE
      INTEGER          :: ia, ja, idx, idy
      REAL :: f(idx,idy),vint(3)
      REAL :: d2fdx(idx,idy),d2fdy(idx,idy),d4fdydx(idx,idy)
      TYPE ( UBIType ) :: ubi

      !COMMON/UBI/ax0,bx0,cx0,dx0,ay0,by0,cy0,dy0,ax0p,bx0p,cx0p,dx0p,ay0p,by0p,cy0p,dy0p

      vint(1)= ubi%ax0*( ubi%ay0*f(ia,ja)+ubi%by0*f(ia,ja+1) &
                   + ubi%cy0*d2fdy(ia,ja)+ubi%dy0*d2fdy(ia,ja+1) ) &
             + ubi%bx0*( ubi%ay0*f(ia+1,ja)+ubi%by0*f(ia+1,ja+1) &
                   + ubi%cy0*d2fdy(ia+1,ja)+ubi%dy0*d2fdy(ia+1,ja+1) ) &
             + ubi%cx0*( ubi%ay0*d2fdx(ia,ja)+ubi%by0*d2fdx(ia,ja+1) &
                   + ubi%cy0*d4fdydx(ia,ja)+ubi%dy0*d4fdydx(ia,ja+1) ) &
             + ubi%dx0*( ubi%ay0*d2fdx(ia+1,ja)+ubi%by0*d2fdx(ia+1,ja+1) &
                   + ubi%cy0*d4fdydx(ia+1,ja)+ubi%dy0*d4fdydx(ia+1,ja+1) )
      vint(2)= ubi%ay0p*( ubi%ax0*f(ia,ja)+ubi%bx0*f(ia+1,ja) &
                    + ubi%cx0*d2fdx(ia,ja)+ubi%dx0*d2fdx(ia+1,ja) ) &
             + ubi%by0p*( ubi%ax0*f(ia,ja+1)+ubi%bx0*f(ia+1,ja+1) &
                    + ubi%cx0*d2fdx(ia,ja+1)+ubi%dx0*d2fdx(ia+1,ja+1) ) &
             + ubi%cy0p*( ubi%ax0*d2fdy(ia,ja)+ubi%bx0*d2fdy(ia+1,ja) &
                    + ubi%cx0*d4fdydx(ia,ja)+ubi%dx0*d4fdydx(ia+1,ja) ) &
             + ubi%dy0p*( ubi%ax0*d2fdy(ia,ja+1)+ubi%bx0*d2fdy(ia+1,ja+1) &
                    + ubi%cx0*d4fdydx(ia,ja+1)+ubi%dx0*d4fdydx(ia+1,ja+1) )
      vint(3)= ubi%ax0p*( ubi%ay0*f(ia,ja)+ubi%by0*f(ia,ja+1) &
                    + ubi%cy0*d2fdy(ia,ja)+ubi%dy0*d2fdy(ia,ja+1) ) &
             + ubi%bx0p*( ubi%ay0*f(ia+1,ja)+ubi%by0*f(ia+1,ja+1) &
                    + ubi%cy0*d2fdy(ia+1,ja)+ubi%dy0*d2fdy(ia+1,ja+1) ) &
             + ubi%cx0p*( ubi%ay0*d2fdx(ia,ja)+ubi%by0*d2fdx(ia,ja+1) &
                    + ubi%cy0*d4fdydx(ia,ja)+ubi%dy0*d4fdydx(ia,ja+1) ) &
             + ubi%dx0p*( ubi%ay0*d2fdx(ia+1,ja)+ubi%by0*d2fdx(ia+1,ja+1) &
                    + ubi%cy0*d4fdydx(ia+1,ja)+ubi%dy0*d4fdydx(ia+1,ja+1) )

      END SUBROUTINE

!*******************************************************************************
!*SUB* SPLINT
!*******************************************************************************
!> Calculates a function Y and its derivative YP at X by spline interpolation. The N data are XA (nodes) and YA
!> (function at nodes). CYA is calculated by DSPLIN.
!>
!> @param[in] xa Array with X values of spline.
!> @param[in] ya Array with Y values of spline.
!> @param[in] cya Array with spline coefficients.
!> @param[in] n Number of points.
!> @param[in] x Point at which to evaluate the spline.
!> @param[out] y Value of function at x.
!> @param[out] yp Value of derivative at x.
!*******************************************************************************
  SUBROUTINE SPLINT( xa, ya, cya, n, x, y, yp )
    IMPLICIT NONE

    INTEGER, INTENT(IN)          :: n
    REAL, INTENT(IN) :: xa(n), ya(n), cya(n), x
    REAL, INTENT(OUT) :: y, yp
    REAL :: h, a, b
    INTEGER          :: klo, khi, k

    klo = 1
    khi = n

1   CONTINUE
    IF (khi - klo .GT. 1) THEN
      k = (khi + klo) / 2
      IF (xa(k) .GT. x) THEN
        khi = k
      ELSE
        klo = k
      END IF
      GO TO 1
    END IF

    h = xa(khi) - xa(klo)
    a = (xa(khi) - x) / h
    b = (x - xa(klo)) / h
    y = a * ya(klo) + b * ya(khi) + ((a**3 - a) * cya(klo) + (b**3 - b) * cya(khi)) * (h * h) / 6.0
    yp = (ya(khi) - ya(klo)) / h + h * (cya(khi) * (3.0 * b * b - 1.0) - cya(klo) * (3.0 * a * a - 1.0)) / 6.0
  END SUBROUTINE

!*******************************************************************************
!*SUB* TRICYCLE
!*******************************************************************************
!> Solve tridiagonal cyclic system.
!
!  A. SALIN    Version 1    9/8/98
!
!> @param[in,out] alpha Main diagonal (destroyed in TRICYCLE).
!> @param[in] beta Subdiagonal.
!> @param[in] gamma Superdiagonal.
!> @param[in] cbot Element of bottom left corner of matrix.
!> @param[in] ctop Element of top right corner of matrix.
!> @param[in,out] b Right-hand side (destroyed in TRICYCLE).
!> @param[in,out] x Solution.
!> @param[in] n Dimension of system.
!*******************************************************************************
  SUBROUTINE TRICYCLE( alpha, beta, gamma, cbot, ctop, b, x, n )
    IMPLICIT NONE

    INTEGER, INTENT(IN)             :: n
    REAL, INTENT(INOUT) :: alpha(n), b(n), x(n)
    REAL, INTENT(IN)    :: beta(n), gamma(n), cbot, ctop
    REAL                :: z(n)

    REAL :: alp, fact
    INTEGER          :: i

    alp = -alpha(1)
    alpha(1) = alpha(1) - alp
    alpha(n) = alpha(n) - cbot * ctop / alp
    DO i = 1, n
      z(i) = alpha(i)
    END DO
    CALL TRIDIA( alpha, beta, gamma, b, x, n )

    DO i = 1, n
      alpha(i) = z(i)
    END DO
    b(1) = alp
    b(n) = cbot
    DO i = 2, n - 1
      b(i) = 0.0
    END DO
    CALL TRIDIA( alpha, beta, gamma, b, z, n )
    fact = (x(1) + ctop * x(n) / alp) / (1.0 + z(1) + ctop * z(n) / alp)
    DO i = 1, n
      x(i) = x(i) - fact * z(i)
    END DO
  END SUBROUTINE

!*******************************************************************************
!*SUB* TRIDIA
!*******************************************************************************
!> Solve tridiagonal system.
!>
!> @param alpha Main diagonal (destroyed in TRIDIA).
!> @param beta Subdiagonal (first element has index 1).
!> @param gamma Superdiagonal (first element has index 1).
!> @param b Right-hand side (destroyed in TRIDIA).
!> @param x Solution.
!> @param n Dimension of system.
!*******************************************************************************
  SUBROUTINE TRIDIA( alpha, beta, gamma, b, x, n )
    IMPLICIT NONE

    REAL :: rap
    INTEGER          :: i, j, n
    REAL :: alpha(n), beta(n), gamma(n), b(n), x(n)

    DO i = 2, n
      rap = beta(i - 1) / alpha(i - 1)
      alpha(i) = alpha(i) - rap * gamma(i - 1)
      b(i) = b(i) - rap * b(i - 1)
    END DO
    x(n) = b(n) / alpha(n)

    DO j = 2, n
      i = n - j + 1
      x(i) = ( b(i) - gamma(i) * x(i + 1) ) / alpha(i)
    END DO
  END SUBROUTINE

! ************************ T R I S P L ***************************
!     Spline interpolation of a periodic function with period
!     [x(n)-x(1)] - i.e. y(n)=y(1).

!     See general comments in DSPLIN.
!     The vectors ALPHA, BETA, GAMMA, B, BZ are scratch vectors of
!     dimension at list N.
!     Required subroutine: TRIDIA, TRICYCLE
!
!        Author: A. Salin   Version 1  09/06/98
! ***************************************************************
!*******************************************************************************
!*SUB* TRISPL
!*******************************************************************************
!> 
!> 
!> @param n 
!> @param x 
!> @param y 
!> @param cm 
!*******************************************************************************
  SUBROUTINE TRISPL( n, x, y, cm )
    IMPLICIT NONE

    INTEGER, INTENT(IN)             :: n
    REAL, INTENT(IN)    :: x(n), y(n)
    REAL, INTENT(INOUT) :: cm(n)
    REAL                :: alpha(n), beta(n), gamma(n), b(n)

    !INTEGER :: kod, k, iw, iligne
    !COMMON /KODSPL/ kod, k, iw, iligne

    INTEGER :: i, i2
    REAL :: a, c, d, e, cbot, ctop

91  FORMAT("Error in the data for TRISPL",/,"Check abcissae:",1PD15.8,1X," and ",D15.8,/,"Program stopped")
    !kod = 0
    c = x(2) - x(1)
    e = (y(2) - y(1)) / c
    DO i = 3, n
      i2 = i - 2
      a = c
      c = x(i) - x(i - 1)
      IF (a * c .LE. 0.0) THEN
        !kod = -1
        !IF (iw .GT. 0) WRITE(iw, 91) x(i - 1), x(i)
        STOP
      END IF
      alpha(i2) = (a + c) / 3.0
      beta(i2) = c / 6.0
      gamma(i2) = beta(i2)
      d = e
      e = (y(i) - y(i - 1)) / c
      b(i2) = e - d
    END DO

    a = c
    c = x(2) - x(1)
    alpha(n - 1) = (a + c) / 3.0
    beta(n - 1) = c / 6.0
    gamma(n - 1) = beta(n - 1)
    d = e
    e = (y(2) - y(1)) / c
    b(n - 1) = e - d
    cbot = beta(n - 1)
    ctop = cbot

!   Solve tridiagonal system
    CALL TRICYCLE( alpha, beta, gamma, cbot, ctop, b, cm(2), n - 1 )

    cm(1) = cm(n)

    !k = 2
  END SUBROUTINE

!**************************** L O C A T E ***************************
!       Author: A. Salin     Version: 1.0    15/04/98
!
!     Determines k such that t.GT.x(k-1) and t.LE.x(k)
!     (except for t=x(1) in which case k=2)
!     If k is initially in the interval [1,n], then the search starts
!     from x(k).
!********************************************************************
!*******************************************************************************
!*SUB* LOCATE
!*******************************************************************************
!> 
!> 
!> @param t 
!> @param k 
!> @param x 
!> @param n 
!*******************************************************************************
  SUBROUTINE LOCATE( t, k, x, n)
    IMPLICIT NONE

    INTEGER :: k, n, inc, klo, khi, km
    REAL    :: t, x(n)
    LOGICAL :: order

    order = x(2) .GT. x(1)
    IF (k .LE. 1 .OR. k .GT. n) THEN
      klo = 0
      khi = n + 1
      GO TO 100
    END IF

    inc = 1
    klo = k - 1
    IF (t .GT. x(klo) .EQV. order) THEN
 10   khi = klo + inc
      IF (khi .GT. n) THEN
        khi = n + 1
      ELSE IF (t .GT. x(khi) .EQV. order) THEN
        klo = khi
        inc = inc + inc
        GO TO 10
      END IF
    ELSE
      khi = klo
 20   klo = khi - inc
      IF (klo .LT. 1) THEN
        klo = 0
      ELSE IF (t .LT. x(klo) .EQV. order) THEN
        khi = klo
        inc = inc + inc
        GO TO 20
      END IF
    END IF

100 CONTINUE
    IF (khi - klo .GT. 1) THEN
      km = (khi + klo) / 2
      IF (t .GT. x(km) .EQV. order) THEN
        klo = km
      ELSE
        khi = km
      END IF
      GO TO 100
    END IF

    k = klo + 1

    IF (t .EQ. x(1)) k = 2
  END SUBROUTINE

!************************ U B I C A R ********************************
!   Determine KLO such that X is .GE.XA(KLO) and .LT.XA(KLO+1)
!   If X is outside the interval [XA(1),XA(N)], the logical
!   variable PARO takes the value .TRUE.
!*********************************************************************
!*******************************************************************************
!*SUB* UBICAR
!*******************************************************************************
!> 
!> 
!> @param XA 
!> @param X 
!> @param N 
!> @param KLO 
!> @param PARO 
!*******************************************************************************
  SUBROUTINE UBICAR( XA, X, N, KLO, PARO )
    IMPLICIT NONE

    INTEGER :: n, klo, khi, k
    REAL    :: x, xa(N)
    LOGICAL :: paro

    paro = .FALSE.
    IF (x .LT. xa(1) .OR. x .GT. xa(n)) THEN
      PARO = .TRUE.
      RETURN
    END IF
    klo = 1
    khi = n
1   CONTINUE
    IF (khi - klo .GT. 1) THEN
      k = (khi + klo) / 2
      IF (xa(k) .GT. x) THEN
        khi = k
      ELSE
        klo = k
      END IF
      GO TO 1
    END IF
  END SUBROUTINE










!*******************************************************************************
!*SUB* int_PES6CuSPL2DPER
!*******************************************************************************
!> 
!> 
!> @param X 
!> @param L 
!> @param Y 
!> @param M 
!> @param F 
!> @param DFDX 
!> @param DFDY 
!> @param DFDXDY 
!*******************************************************************************
      SUBROUTINE int_PES6CuSPL2DPER(X,L,Y,M,F,DFDX,DFDY,DFDXDY)
      IMPLICIT REAL(A-H,O-Z)
!C     ------------------------------------------------------------------
!C     This routine computes the derivatives needed for a 2D spline
!C     interpolation with periodic boundary conditions in x and y.
!C     Input: X,Y arrays of L,M components contaning the x,y grid.
!C            L,M
!C            F the values of the function on the grid points
!C     ------------------------------------------------------------------
      DIMENSION X(L),Y(M)
      DIMENSION F(L,M),DFDX(L,M),DFDY(L,M),DFDXDY(L,M)
      DIMENSION F1(L),DF1(L),F2(L),DF2(L)
!C     --------------------------------------------
!C     Calculo de la derivada segunda respecto de y
      DO I=1,L
         DO J=1,M
            F1(J)=F(I,J)
         ENDDO
         CALL TRISPL(M,Y,F1,DF1)
         DO J=1,M
            DFDY(I,J)=DF1(J)
         ENDDO
      ENDDO
!C     --------------------------------------------
!C     Calculo de la derivada segunda respecto de x
      DO J=1,M
         DO I=1,L
            F2(I)=F(I,J)
         ENDDO
         CALL TRISPL(L,X,F2,DF2)
         DO I=1,L
            DFDX(I,J)=DF2(I)
         ENDDO
      ENDDO
!C     -----------------------------------------------------------
!C     Calculo de la derivada segunda respecto de x de la derivada
!C     segunda respecto de y
      DO J=1,M
         DO I=1,L
            F2(I)=DFDY(I,J)
         ENDDO
         CALL TRISPL(L,X,F2,DF2)
         DO I=1,L
            DFDXDY(I,J)=DF2(I)
         ENDDO
      ENDDO
      RETURN
      END SUBROUTINE int_PES6CuSPL2DPER
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!*******************************************************************************
!*SUB* SPLINE3D
!*******************************************************************************
!> 
!> 
!> @param X 
!> @param L 
!> @param Y 
!> @param M 
!> @param Z 
!> @param N 
!> @param F 
!> @param CM1 
!> @param IC1 
!> @param CMN 
!> @param ICN 
!> @param DFDX 
!> @param DFDY 
!> @param DFDXDY 
!> @param DFDZ 
!> @param DFDZDX 
!> @param DFDZDY 
!> @param DFDZDXDY 
!*******************************************************************************
      SUBROUTINE SPLINE3D(X,L,Y,M,Z,N,F,CM1,IC1,CMN,ICN, &
                DFDX,DFDY,DFDXDY,DFDZ,DFDZDX,DFDZDY,DFDZDXDY)
!C     ------------------------------------------------------------------
!C     This routine computes the derivatives needed for a 3D spline
!C     interpolation with periodic boundary conditions in x and y and
!C     the especified boundary conditiond in z (see dsplin).
!C     Input: X,Y,Z arrays of L,M,N components contaning the x,y,z grid.
!C            L,M,M
!C            F the values of the function on the grid points
!C     If IC1=0, function in Z is the same in first two intervals.
!C     If IC1=1, second derivative at x(1) given in CM1
!C     If IC1=2, first derivative at x(1) given in CM1
!C     IF IC1>2, zero second derivative at x(1)
!C          Similar definitions for ICN and CMN around x(n)
!C     ------------------------------------------------------------------
      IMPLICIT REAL(A-H,O-Z)
      DIMENSION X(L),Y(M),Z(N)
      DIMENSION F(L,M,N),DFDX(L,M,N),DFDY(L,M,N), &
              DFDXDY(L,M,N),DFDZ(L,M,N),DFDZDX(L,M,N), &
              DFDZDY(L,M,N),DFDZDXDY(L,M,N)
      DIMENSION CM1(L,M),CMN(L,M)
      DIMENSION V1(N),V2(N)
      DIMENSION V3(L,M),V4(L,M),V5(L,M),V6(L,M), &
            V7(L,M),V8(L,M),V9(L,M),V10(L,M)
!C     ------------------------------------------------------------------
      DO I=1,L
         DO J=1,M
            DO K=1,N
               V1(K)=F(I,J,K)
               IF (K.EQ.1) DER1=CM1(I,J)
               IF (K.EQ.N) DER2=CMN(I,J)
            ENDDO
            CALL DSPLIN(N,Z,V1,V2,DER1,IC1,DER2,ICN)
            DO K=1,N
               DFDZ(I,J,K)=V2(K)
            ENDDO
         ENDDO
      ENDDO
      DO K=1,N
         DO I=1,L
            DO J=1,M
               V3(I,J)=F(I,J,K)
               V4(I,J)=DFDZ(I,J,K)
            ENDDO
         ENDDO
         CALL int_PES6CuSPL2DPER(X,L,Y,M,V3,V5,V6,V7)
         CALL int_PES6CuSPL2DPER(X,L,Y,M,V4,V8,V9,V10)
         DO I=1,L
            DO J=1,M
               DFDX(I,J,K)=V5(I,J)
               DFDY(I,J,K)=V6(I,J)
               DFDXDY(I,J,K)=V7(I,J)
               DFDZDX(I,J,K)=V8(I,J)
               DFDZDY(I,J,K)=V9(I,J)
               DFDZDXDY(I,J,K)=V10(I,J)
            ENDDO
         ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!*******************************************************************************
!*SUB* SPLINT3D
!*******************************************************************************
!> 
!> 
!> @param X 
!> @param L 
!> @param Y 
!> @param M 
!> @param Z 
!> @param N 
!> @param F 
!> @param DFDX 
!> @param DFDY 
!> @param DFDXDY 
!> @param DFDZ 
!> @param DFDZDX 
!> @param DFDZDY 
!> @param DFDZDXDY 
!> @param X0 
!> @param Y0 
!> @param Z0 
!> @param F0 
!> @param DX 
!> @param DY 
!> @param DZ 
!*******************************************************************************
      SUBROUTINE SPLINT3D(X,L,Y,M,Z,N,F,DFDX,DFDY,DFDXDY,DFDZ,DFDZDX, &
                           DFDZDY,DFDZDXDY,X0,Y0,Z0,F0,DX,DY,DZ)
      IMPLICIT REAL(A-H,O-Z)
      DIMENSION X(L),Y(M),Z(N)
      DIMENSION F(L,M,N),DFDX(L,M,N),DFDY(L,M,N), &
               DFDXDY(L,M,N),DFDZ(L,M,N),DFDZDX(L,M,N), &
                 DFDZDY(L,M,N),DFDZDXDY(L,M,N)
      LOGICAL PARO

      CALL UBICAR(X,X0,L,IA,PARO)

!c      write(*,*)'IA=',IA
!c      write(*,*)'PARO=',PARO

      DEX=X(IA+1)-X(IA)
      IF (PARO) THEN
         WRITE(*,*)'ERROR: X0 out of range'
         STOP
      ENDIF
!c      WRITE(*,*)'IA=',IA

      CALL UBICAR(Y,Y0,M,JA,PARO)
      DEY=Y(JA+1)-Y(JA)
      IF (PARO) THEN
         WRITE(*,*)'ERROR: Y0 out of range'
         STOP
      ENDIF
!c      WRITE(*,*)'JA=',JA

      CALL UBICAR(Z,Z0,N,KA,PARO)
      DEZ=Z(KA+1)-Z(KA)
      IF (PARO) THEN
         WRITE(*,*)'ERROR: Z0 out of range'
         STOP
      ENDIF
!C     ----------------------------------
      AX0=(X(IA+1)-X0)/DEX
      BX0=1.0-AX0
      CX0=(AX0**3.0-AX0)/6.0*DEX**2.0
      DX0=(BX0**3.0-BX0)/6.0*DEX**2.0

      AY0=(Y(JA+1)-Y0)/DEY
      BY0=1.0-AY0
      CY0=(AY0**3.0-AY0)/6.0*DEY**2.0
      DY0=(BY0**3.0-BY0)/6.0*DEY**2.0

      AZ0=(Z(KA+1)-Z0)/DEZ
      BZ0=1.0-AZ0
      CZ0=(AZ0**3.0-AZ0)/6.0*DEZ**2.0
      DZ0=(BZ0**3.0-BZ0)/6.0*DEZ**2.0

!C     -----------------------------------------------------------
      ATERM=AY0*(AX0*F(IA,JA,KA)+BX0*F(IA+1,JA,KA)+ &
                CX0*DFDX(IA,JA,KA)+DX0*DFDX(IA+1,JA,KA))+ &
           BY0*(AX0*F(IA,JA+1,KA)+BX0*F(IA+1,JA+1,KA)+ &
                CX0*DFDX(IA,JA+1,KA)+DX0*DFDX(IA+1,JA+1,KA))+ &
           CY0*(AX0*DFDY(IA,JA,KA)+BX0*DFDY(IA+1,JA,KA)+ &
                CX0*DFDXDY(IA,JA,KA)+DX0*DFDXDY(IA+1,JA,KA))+ &
           DY0*(AX0*DFDY(IA,JA+1,KA)+BX0*DFDY(IA+1,JA+1,KA)+ &
                CX0*DFDXDY(IA,JA+1,KA)+DX0*DFDXDY(IA+1,JA+1,KA))
      BTERM=AY0*(AX0*F(IA,JA,KA+1)+BX0*F(IA+1,JA,KA+1)+ &
                CX0*DFDX(IA,JA,KA+1)+DX0*DFDX(IA+1,JA,KA+1))+ &
           BY0*(AX0*F(IA,JA+1,KA+1)+BX0*F(IA+1,JA+1,KA+1)+ &
                CX0*DFDX(IA,JA+1,KA+1)+DX0*DFDX(IA+1,JA+1,KA+1))+ &
           CY0*(AX0*DFDY(IA,JA,KA+1)+BX0*DFDY(IA+1,JA,KA+1)+ &
                CX0*DFDXDY(IA,JA,KA+1)+DX0*DFDXDY(IA+1,JA,KA+1))+ &
           DY0*(AX0*DFDY(IA,JA+1,KA+1)+BX0*DFDY(IA+1,JA+1,KA+1)+ &
                CX0*DFDXDY(IA,JA+1,KA+1)+DX0*DFDXDY(IA+1,JA+1,KA+1))
      CTERM=AY0*(AX0*DFDZ(IA,JA,KA)+BX0*DFDZ(IA+1,JA,KA)+ &
                CX0*DFDZDX(IA,JA,KA)+DX0*DFDZDX(IA+1,JA,KA))+ &
           BY0*(AX0*DFDZ(IA,JA+1,KA)+BX0*DFDZ(IA+1,JA+1,KA)+ &
                CX0*DFDZDX(IA,JA+1,KA)+DX0*DFDZDX(IA+1,JA+1,KA))+ &
           CY0*(AX0*DFDZDY(IA,JA,KA)+BX0*DFDZDY(IA+1,JA,KA)+ &
                CX0*DFDZDXDY(IA,JA,KA)+DX0*DFDZDXDY(IA+1,JA,KA))+ &
           DY0*(AX0*DFDZDY(IA,JA+1,KA)+BX0*DFDZDY(IA+1,JA+1,KA)+ &
                CX0*DFDZDXDY(IA,JA+1,KA)+DX0*DFDZDXDY(IA+1,JA+1,KA))
      DTERM=AY0*(AX0*DFDZ(IA,JA,KA+1)+BX0*DFDZ(IA+1,JA,KA+1)+ &
                CX0*DFDZDX(IA,JA,KA+1)+DX0*DFDZDX(IA+1,JA,KA+1))+ &
           BY0*(AX0*DFDZ(IA,JA+1,KA+1)+BX0*DFDZ(IA+1,JA+1,KA+1)+ &
                CX0*DFDZDX(IA,JA+1,KA+1)+DX0*DFDZDX(IA+1,JA+1,KA+1))+ &
           CY0*(AX0*DFDZDY(IA,JA,KA+1)+BX0*DFDZDY(IA+1,JA,KA+1)+ &
                CX0*DFDZDXDY(IA,JA,KA+1)+DX0*DFDZDXDY(IA+1,JA,KA+1))+ &
           DY0*(AX0*DFDZDY(IA,JA+1,KA+1)+BX0*DFDZDY(IA+1,JA+1,KA+1)+ &
              CX0*DFDZDXDY(IA,JA+1,KA+1)+DX0*DFDZDXDY(IA+1,JA+1,KA+1))

      F0=AZ0*ATERM+BZ0*BTERM+CZ0*CTERM+DZ0*DTERM
!C     ----------------------------------------------
      AX0P=-1.0/DEX
      BX0P=-AX0P
      CX0P=(3.0*AX0**2.0*AX0P-AX0P)/6.0*DEX**2.0
      DX0P=(3.0*BX0**2.0*BX0P-BX0P)/6.0*DEX**2.0

      ATERMX=AY0*(AX0P*F(IA,JA,KA)+BX0P*F(IA+1,JA,KA)+ &
                CX0P*DFDX(IA,JA,KA)+DX0P*DFDX(IA+1,JA,KA))+ &
           BY0*(AX0P*F(IA,JA+1,KA)+BX0P*F(IA+1,JA+1,KA)+ &
                CX0P*DFDX(IA,JA+1,KA)+DX0P*DFDX(IA+1,JA+1,KA))+ &
           CY0*(AX0P*DFDY(IA,JA,KA)+BX0P*DFDY(IA+1,JA,KA)+ &
                CX0P*DFDXDY(IA,JA,KA)+DX0P*DFDXDY(IA+1,JA,KA))+ &
           DY0*(AX0P*DFDY(IA,JA+1,KA)+BX0P*DFDY(IA+1,JA+1,KA)+ &
                CX0P*DFDXDY(IA,JA+1,KA)+DX0P*DFDXDY(IA+1,JA+1,KA))
      BTERMX=AY0*(AX0P*F(IA,JA,KA+1)+BX0P*F(IA+1,JA,KA+1)+ &
                CX0P*DFDX(IA,JA,KA+1)+DX0P*DFDX(IA+1,JA,KA+1))+ &
           BY0*(AX0P*F(IA,JA+1,KA+1)+BX0P*F(IA+1,JA+1,KA+1)+ &
                CX0P*DFDX(IA,JA+1,KA+1)+DX0P*DFDX(IA+1,JA+1,KA+1))+ &
           CY0*(AX0P*DFDY(IA,JA,KA+1)+BX0P*DFDY(IA+1,JA,KA+1)+ &
                CX0P*DFDXDY(IA,JA,KA+1)+DX0P*DFDXDY(IA+1,JA,KA+1))+ &
           DY0*(AX0P*DFDY(IA,JA+1,KA+1)+BX0P*DFDY(IA+1,JA+1,KA+1)+ &
                CX0P*DFDXDY(IA,JA+1,KA+1)+DX0P*DFDXDY(IA+1,JA+1,KA+1))
      CTERMX=AY0*(AX0P*DFDZ(IA,JA,KA)+BX0P*DFDZ(IA+1,JA,KA)+ &
                CX0P*DFDZDX(IA,JA,KA)+DX0P*DFDZDX(IA+1,JA,KA))+ &
           BY0*(AX0P*DFDZ(IA,JA+1,KA)+BX0P*DFDZ(IA+1,JA+1,KA)+ &
                CX0P*DFDZDX(IA,JA+1,KA)+DX0P*DFDZDX(IA+1,JA+1,KA))+ &
           CY0*(AX0P*DFDZDY(IA,JA,KA)+BX0P*DFDZDY(IA+1,JA,KA)+ &
                CX0P*DFDZDXDY(IA,JA,KA)+DX0P*DFDZDXDY(IA+1,JA,KA))+ &
           DY0*(AX0P*DFDZDY(IA,JA+1,KA)+BX0P*DFDZDY(IA+1,JA+1,KA)+ &
                CX0P*DFDZDXDY(IA,JA+1,KA)+DX0P*DFDZDXDY(IA+1,JA+1,KA))

      DTERMX=AY0*(AX0P*DFDZ(IA,JA,KA+1)+BX0P*DFDZ(IA+1,JA,KA+1)+ &
                CX0P*DFDZDX(IA,JA,KA+1)+DX0P*DFDZDX(IA+1,JA,KA+1))+ &
           BY0*(AX0P*DFDZ(IA,JA+1,KA+1)+BX0P*DFDZ(IA+1,JA+1,KA+1)+ &
                CX0P*DFDZDX(IA,JA+1,KA+1)+DX0P*DFDZDX(IA+1,JA+1,KA+1))+ &
           CY0*(AX0P*DFDZDY(IA,JA,KA+1)+BX0P*DFDZDY(IA+1,JA,KA+1)+ &
                CX0P*DFDZDXDY(IA,JA,KA+1)+DX0P*DFDZDXDY(IA+1,JA,KA+1))+ &
           DY0*(AX0P*DFDZDY(IA,JA+1,KA+1)+BX0P*DFDZDY(IA+1,JA+1,KA+1)+ &
             CX0P*DFDZDXDY(IA,JA+1,KA+1)+DX0P*DFDZDXDY(IA+1,JA+1,KA+1))


      DX=AZ0*ATERMX+BZ0*BTERMX+CZ0*CTERMX+DZ0*DTERMX
!C     ----------------------------------------------
      AY0P=-1.0/DEY
      BY0P=-AY0P
      CY0P=(3.0*AY0**2.0*AY0P-AY0P)/6.0*DEY**2.0
      DY0P=(3.0*BY0**2.0*BY0P-BY0P)/6.0*DEY**2.0
!C     -----------------------------------------------------------
      ATERMY=AY0P*(AX0*F(IA,JA,KA)+BX0*F(IA+1,JA,KA)+ &
                CX0*DFDX(IA,JA,KA)+DX0*DFDX(IA+1,JA,KA))+ &
           BY0P*(AX0*F(IA,JA+1,KA)+BX0*F(IA+1,JA+1,KA)+ &
                CX0*DFDX(IA,JA+1,KA)+DX0*DFDX(IA+1,JA+1,KA))+ &
           CY0P*(AX0*DFDY(IA,JA,KA)+BX0*DFDY(IA+1,JA,KA)+ &
                CX0*DFDXDY(IA,JA,KA)+DX0*DFDXDY(IA+1,JA,KA))+ &
           DY0P*(AX0*DFDY(IA,JA+1,KA)+BX0*DFDY(IA+1,JA+1,KA)+ &
                CX0*DFDXDY(IA,JA+1,KA)+DX0*DFDXDY(IA+1,JA+1,KA))
      BTERMY=AY0P*(AX0*F(IA,JA,KA+1)+BX0*F(IA+1,JA,KA+1)+ &
                CX0*DFDX(IA,JA,KA+1)+DX0*DFDX(IA+1,JA,KA+1))+ &
           BY0P*(AX0*F(IA,JA+1,KA+1)+BX0*F(IA+1,JA+1,KA+1)+ &
                CX0*DFDX(IA,JA+1,KA+1)+DX0*DFDX(IA+1,JA+1,KA+1))+ &
           CY0P*(AX0*DFDY(IA,JA,KA+1)+BX0*DFDY(IA+1,JA,KA+1)+ &
                CX0*DFDXDY(IA,JA,KA+1)+DX0*DFDXDY(IA+1,JA,KA+1))+ &
           DY0P*(AX0*DFDY(IA,JA+1,KA+1)+BX0*DFDY(IA+1,JA+1,KA+1)+ &
                CX0*DFDXDY(IA,JA+1,KA+1)+DX0*DFDXDY(IA+1,JA+1,KA+1))
      CTERMY=AY0P*(AX0*DFDZ(IA,JA,KA)+BX0*DFDZ(IA+1,JA,KA)+ &
                CX0*DFDZDX(IA,JA,KA)+DX0*DFDZDX(IA+1,JA,KA))+ &
           BY0P*(AX0*DFDZ(IA,JA+1,KA)+BX0*DFDZ(IA+1,JA+1,KA)+ &
                CX0*DFDZDX(IA,JA+1,KA)+DX0*DFDZDX(IA+1,JA+1,KA))+ &
           CY0P*(AX0*DFDZDY(IA,JA,KA)+BX0*DFDZDY(IA+1,JA,KA)+ &
                CX0*DFDZDXDY(IA,JA,KA)+DX0*DFDZDXDY(IA+1,JA,KA))+ &
           DY0P*(AX0*DFDZDY(IA,JA+1,KA)+BX0*DFDZDY(IA+1,JA+1,KA)+ &
                CX0*DFDZDXDY(IA,JA+1,KA)+DX0*DFDZDXDY(IA+1,JA+1,KA))
      DTERMY=AY0P*(AX0*DFDZ(IA,JA,KA+1)+BX0*DFDZ(IA+1,JA,KA+1)+ &
              CX0*DFDZDX(IA,JA,KA+1)+DX0*DFDZDX(IA+1,JA,KA+1))+ &
           BY0P*(AX0*DFDZ(IA,JA+1,KA+1)+BX0*DFDZ(IA+1,JA+1,KA+1)+ &
                CX0*DFDZDX(IA,JA+1,KA+1)+DX0*DFDZDX(IA+1,JA+1,KA+1))+ &
           CY0P*(AX0*DFDZDY(IA,JA,KA+1)+BX0*DFDZDY(IA+1,JA,KA+1)+ &
                CX0*DFDZDXDY(IA,JA,KA+1)+DX0*DFDZDXDY(IA+1,JA,KA+1))+ &
           DY0P*(AX0*DFDZDY(IA,JA+1,KA+1)+BX0*DFDZDY(IA+1,JA+1,KA+1)+ &
              CX0*DFDZDXDY(IA,JA+1,KA+1)+DX0*DFDZDXDY(IA+1,JA+1,KA+1))


      DY=AZ0*ATERMY+BZ0*BTERMY+CZ0*CTERMY+DZ0*DTERMY
!C     ----------------------------------------------
      AZ0P=-1.0/DEZ
      BZ0P=-AZ0P
      CZ0P=(3.0*AZ0**2.0*AZ0P-AZ0P)/6.0*DEZ**2.0
      DZ0P=(3.0*BZ0**2.0*BZ0P-BZ0P)/6.0*DEZ**2.0

      DZ=AZ0P*ATERM+BZ0P*BTERM+CZ0P*CTERM+DZ0P*DTERM
!C     ----------------------------------------------
      RETURN
      END SUBROUTINE
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************
!****************************************************************************************************


!     *********************** T R I D I A ***************************
!*******************************************************************************
!*SUB* int_PES6CuTRIDIA
!*******************************************************************************
!> 
!> 
!> @param alpha 
!> @param beta 
!> @param gamma 
!> @param b 
!> @param x 
!> @param n 
!*******************************************************************************
      SUBROUTINE int_PES6CuTRIDIA(alpha,beta,gamma,b,x,n)
!
!        Solution of tridiagonal systems
!
!     ALPHA: main diagonal (destroyed in TRIDIA).
!     BETA: subdiagonal (first element has index 1).
!     GAMMA: superdiagonal (first element has index 1).
!     B: right-hand side (destroyed in TRIDIA).
!     X: solution.
!     N: dimension of system.
!
      IMPLICIT REAL (a-h,o-z)
      DIMENSION alpha(n),beta(n),gamma(n),b(n),x(n)
!
      DO i=2,n
        rap = beta(i-1) / alpha(i-1)
        alpha(i) = alpha(i) - rap*gamma(i-1)
        b(i) = b(i) - rap*b(i-1)
      END DO
      x(n) = b(n) / alpha(n)

      DO j=2,n
        i = n-j+1
        x(i) = ( b(i) - gamma(i)*x(i+1) ) / alpha(i)
      END DO

      END SUBROUTINE int_PES6CuTRIDIA
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!     *********************** T R I ! Y ! L E ***********************
!*******************************************************************************
!*SUB* int_PES6CuTRICYCLE
!*******************************************************************************
!> 
!> 
!> @param alpha 
!> @param beta 
!> @param gamma 
!> @param cbot 
!> @param ctop 
!> @param b 
!> @param x 
!> @param n 
!> @param z 
!*******************************************************************************
      SUBROUTINE int_PES6CuTRICYCLE(alpha,beta,gamma,cbot,ctop,b,x,n,z)
!
!     Solution of tridiagonal cyclic system
!     Required subroutine: TRIDIA
!
!         A. SALIN    Version 1    9/8/98
!
!     ALPHA: main diagonal (destroyed in TRICYCLE)
!     BETA: subdiagonal
!     GAMMA: superdiagonal
!     CBOT: element of bottom left corner of matrix
!     CTOP: element of top right corner of matrix
!     B: righthand side (destroyed in TRICYCLE)
!     X: solution
!     N: dimension of system
!     Z: scratch vector of dimension N at least

      IMPLICIT REAL (a-h,o-z)
      DIMENSION alpha(n),beta(n),gamma(n),b(n),x(n),z(n)
!
      alp=-alpha(1)
      alpha(1)=alpha(1)-alp
      alpha(n)=alpha(n)-cbot*ctop/alp
      DO i=1,n
        z(i)=alpha(i)
      END DO
      CALL int_PES6CuTRIDIA(alpha,beta,gamma,b,x,n)
!
      DO i=1,n
        alpha(i)=z(i)
      END DO
      b(1)=alp
      b(n)=cbot
      DO i=2,n-1
        b(i)=0.0
      END DO
      CALL int_PES6CuTRIDIA(alpha,beta,gamma,b,z,n)
      fact=(x(1)+ctop*x(n)/alp)/(1.0+z(1)+ctop*z(n)/alp)
      DO i=1,n
        x(i)=x(i)-fact*z(i)
      END DO

      END SUBROUTINE int_PES6CuTRICYCLE
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*******************************************************************************
!*SUB* int_PES6CuSPLINT2
!*******************************************************************************
!> 
!> 
!> @param X 
!> @param Y 
!> @param N 
!> @param M 
!> @param F 
!> @param D2FDX 
!> @param D2FDY 
!> @param D4FDYDX 
!> @param X0 
!> @param Y0 
!> @param IA 
!> @param JA 
!> @param FX0Y0 
!> @param DFDX 
!> @param DFDY 
!> @param idx 
!> @param idy 
!*******************************************************************************
      SUBROUTINE int_PES6CuSPLINT2(X,Y,N,M,F,D2FDX,D2FDY,D4FDYDX,X0,Y0,IA,JA, &
                            FX0Y0,DFDX,DFDY,idx,idy)
!C     ------------------------------------------------------------------
!C     Esta rutina supone que ya se verifico que X0 e Y0 estan dentro
!C     del rango de interpolacion correcto. Si este no es el caso, el
!C     resultado obtenido sera incorrecto y NO se emitira ningun mensaje
!C     indicador!!!
!C     IA y JA indican la posicion de X0 e Y0 en la grilla dando los
!C     indices correspondientes al vertice inferior izquierdo del
!C     rectangulo donde se encuentra el punto (X0,Y0).
      IMPLICIT REAL(A-H,O-Z)
      DIMENSION X(idx),Y(idy),F(idx,idy)
      DIMENSION D2FDX(idx,idy),D2FDY(idx,idy),D4FDYDX(idx,idy)
!C     ------------------------------------------------------------------
      AX0=(X(IA+1)-X0)/(X(IA+1)-X(IA))
      BX0=1.0-AX0
      CX0=1.0/6.0*(AX0**3.0-AX0)*(X(IA+1)-X(IA))**2.0
      DX0=1.0/6.0*(BX0**3.0-BX0)*(X(IA+1)-X(IA))**2.0

      AY0=(Y(JA+1)-Y0)/(Y(JA+1)-Y(JA))
      BY0=1.0-AY0
      CY0=1.0/6.0*(AY0**3.0-AY0)*(Y(JA+1)-Y(JA))**2.0
      DY0=1.0/6.0*(BY0**3.0-BY0)*(Y(JA+1)-Y(JA))**2.0

      AX0P=-1.0/(X(IA+1)-X(IA))
      BX0P=-AX0P
      CX0P=1.0/6.0*(3.0*AX0**2.0*AX0P-AX0P)*(X(IA+1)-X(IA))**2.0
      DX0P=1.0/6.0*(3.0*BX0**2.0*BX0P-BX0P)*(X(IA+1)-X(IA))**2.0

      AY0P=-1.0/(Y(JA+1)-Y(JA))
      BY0P=-AY0P
      CY0P=1.0/6.0*(3.0*AY0**2.0*AY0P-AY0P)*(Y(JA+1)-Y(JA))**2.0
      DY0P=1.0/6.0*(3.0*BY0**2.0*BY0P-BY0P)*(Y(JA+1)-Y(JA))**2.0

      CY0PP=AY0*AY0P**2.0*(Y(JA+1)-Y(JA))**2.0
      DY0PP=BY0*BY0P**2.0*(Y(JA+1)-Y(JA))**2.0

      FX0Y0=AX0*(AY0*F(IA,JA)+BY0*F(IA,JA+1)+ &
                CY0*D2FDY(IA,JA)+DY0*D2FDY(IA,JA+1))+ &
           BX0*(AY0*F(IA+1,JA)+BY0*F(IA+1,JA+1)+ &
                CY0*D2FDY(IA+1,JA)+DY0*D2FDY(IA+1,JA+1))+ &
           CX0*(AY0*D2FDX(IA,JA)+BY0*D2FDX(IA,JA+1)+ &
                CY0*D4FDYDX(IA,JA)+DY0*D4FDYDX(IA,JA+1))+ &
           DX0*(AY0*D2FDX(IA+1,JA)+BY0*D2FDX(IA+1,JA+1)+ &
                CY0*D4FDYDX(IA+1,JA)+DY0*D4FDYDX(IA+1,JA+1))
      DFDX=AX0P*(AY0*F(IA,JA)+BY0*F(IA,JA+1)+ &
               CY0*D2FDY(IA,JA)+DY0*D2FDY(IA,JA+1))+ &
          BX0P*(AY0*F(IA+1,JA)+BY0*F(IA+1,JA+1)+ &
               CY0*D2FDY(IA+1,JA)+DY0*D2FDY(IA+1,JA+1))+ &
          CX0P*(AY0*D2FDX(IA,JA)+BY0*D2FDX(IA,JA+1)+ &
               CY0*D4FDYDX(IA,JA)+DY0*D4FDYDX(IA,JA+1))+ &
          DX0P*(AY0*D2FDX(IA+1,JA)+BY0*D2FDX(IA+1,JA+1)+ &
               CY0*D4FDYDX(IA+1,JA)+DY0*D4FDYDX(IA+1,JA+1))
      DFDY=AY0P*(AX0*F(IA,JA)+BX0*F(IA+1,JA)+ &
                CX0*D2FDX(IA,JA)+DX0*D2FDX(IA+1,JA))+ &
          BY0P*(AX0*F(IA,JA+1)+BX0*F(IA+1,JA+1)+ &
                CX0*D2FDX(IA,JA+1)+DX0*D2FDX(IA+1,JA+1))+ &
          CY0P*(AX0*D2FDY(IA,JA)+BX0*D2FDY(IA+1,JA)+ &
                CX0*D4FDYDX(IA,JA)+DX0*D4FDYDX(IA+1,JA))+ &
          DY0P*(AX0*D2FDY(IA,JA+1)+BX0*D2FDY(IA+1,JA+1)+ &
                CX0*D4FDYDX(IA,JA+1)+DX0*D4FDYDX(IA+1,JA+1))
      RETURN
      END SUBROUTINE int_PES6CuSPLINT2
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*******************************************************************************
!*SUB* int_PES6CuSPLINE2
!*******************************************************************************
!> 
!> 
!> @param X 
!> @param Y 
!> @param N 
!> @param M 
!> @param F 
!> @param D2FDX 
!> @param D2FDY 
!> @param D4FDYDX 
!> @param idx 
!> @param idy 
!*******************************************************************************
      SUBROUTINE int_PES6CuSPLINE2(X,Y,N,M,F,D2FDX,D2FDY,D4FDYDX,idx,idy)
      IMPLICIT REAL(A-H,O-Z)
      INTEGER, PARAMETER :: ndimmax = 16
      DIMENSION X(idx),Y(idy),F(idx,idy)
      DIMENSION FAUX1(idx),FAUX2(idy),FAUX3(idy),Y2(idx),Y2P(idy),Y2PP(idy)
      DIMENSION D2FDX(idx,idy),D2FDY(idx,idy),D4FDYDX(idx,idy)
      DIMENSION a(NDIMMAX),aa(NDIMMAX),aaa(NDIMMAX)
      DIMENSION b(NDIMMAX),bb(NDIMMAX),bbb(NDIMMAX)

      DO 300 J=1,M
         DO 400 I=1,N
            FAUX1(I)=F(I,J)
 400     CONTINUE
         CALL DSPLIN(N,X,FAUX1,Y2,0.0,0,0.0,0)
         DO 500 I=1,N
            D2FDX(I,J)=Y2(I)
 500     CONTINUE
 300  CONTINUE
      DO 600 I=1,N
         DO 700 J=1,M
            FAUX2(J)=F(I,J)
            FAUX3(J)=D2FDX(I,J)
 700     CONTINUE
         CALL DSPLIN(M,Y,FAUX2,Y2P,0.0,0,0.0,0)
         CALL DSPLIN(M,Y,FAUX3,Y2PP,0.0,0,0.0,0)
         DO 800 J=1,M
            D2FDY(I,J)=Y2P(J)
            D4FDYDX(I,J)=Y2PP(J)
 800     CONTINUE
 600  CONTINUE
      RETURN
      END SUBROUTINE int_PES6CuSPLINE2
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************







END MODULE

MODULE CRP_Constants
  IMPLICIT NONE

  REAL, PARAMETER :: CRP_Constants_PI    = 3.1415926535897932384626433832795028841971    ! accurate enough for most CPU's...
  REAL, PARAMETER :: CRP_Constants_eV2Ha = 0.036749308286
END MODULE

MODULE CRP_Python_Wrapper

  USE CRP_General
  USE CRP_Wrapper
  USE PotentialData
  USE UnitConversion

  IMPLICIT NONE

  TYPE ( CRP_MoleculeSurface_PES ), SAVE :: PES
  TYPE ( Units ), SAVE :: FriendlyUnits

  INTEGER :: ModuleSetUp = 0

  PRIVATE :: ModuleSetUp

CONTAINS

  SUBROUTINE Initialize( )
    IMPLICIT NONE

    CALL Initialize_CRP_Wrapper_Module()
    IF ( ModuleSetUp .LT. 1 ) THEN
      CALL Standard_Potential_Data_Folders()
      ModuleSetUp = ModuleSetUp + 1
    END IF

    FriendlyUnits%LengthUnit = UNITS_ANGSTROM
    FriendlyUnits%EnergyUnit = UNITS_EV
    FriendlyUnits%MassUnit   = UNITS_MELEC
    FriendlyUnits%TimeUnit   = UNITS_PS
  END SUBROUTINE

  SUBROUTINE SetUp_CRP_Potential( DataSet )
    IMPLICIT NONE

    CHARACTER( LEN=* ), INTENT(IN) :: DataSet

    CALL SetUp_CRP_MoleculeSurface_PES( DataSet, PES )
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_Potential( R, V, F )
    IMPLICIT NONE

    REAL, INTENT(IN) :: R(6)
    REAL, INTENT(OUT) :: V, F(6)

    CALL Calculate_CRP_MoleculeSurface_PES( PES, R, V, F, FriendlyUnits )
  END SUBROUTINE

  SUBROUTINE Destroy_CRP_Potential( )
    IMPLICIT NONE

    CALL Destroy_CRP_MoleculeSurface_PES( PES )
  END SUBROUTINE

  SUBROUTINE Get_Potential_Info( LatticeConstantX, LatticeConstantY, SkewingAngle )
    IMPLICIT NONE

    REAL, INTENT(OUT) :: LatticeConstantX, LatticeConstantY, SkewingAngle

    IF ( PES%Symmetry .EQ. 4 ) THEN
      LatticeConstantX = Convert_Length_Units( PES%Geometry%LatticeConstant, InternalUnits, FriendlyUnits )
      LatticeConstantY = Convert_Length_Units( PES%Geometry%LatticeConstant, InternalUnits, FriendlyUnits )
      SkewingAngle = 90
    ELSE IF ( PES%Symmetry .EQ. 3 .OR. PES%Symmetry .EQ. 6 ) THEN
      LatticeConstantX = Convert_Length_Units( PES%Geometry%LatticeConstant, InternalUnits, FriendlyUnits )
      LatticeConstantY = Convert_Length_Units( PES%Geometry%LatticeConstant, InternalUnits, FriendlyUnits )
      SkewingAngle = 60
    END IF
  END SUBROUTINE

END MODULE

MODULE CRP_C3v_MoleculeSurface
  USE CRP_Constants
  USE CRP_GasPhase
  USE CRP_General
  USE CRP_C3v_AtomSurface
  USE Spline
  USE UnitConversion

  PRIVATE
  PUBLIC :: Initialize_CRP_C3v_MoleculeSurface_Module, &
            Initialize_CRP_C3v_MoleculeSurface_PES, &
            Calculate_CRP_C3v_MoleculeSurface_PES

  INTEGER, PARAMETER :: idf6 = 12, ids = 6
  REAL   :: fouri6D(idf6,idf6)

  INTEGER :: CRP_C3v_MoleculeSurface_Module_SetUp = 0

  INTERFACE Calculate_CRP_C3v_MoleculeSurface_PES
    MODULE PROCEDURE Calculate_CRP_C3v_MoleculeSurface_PES_Scalar, &
                     Calculate_CRP_C3v_MoleculeSurface_PES_Array
  END INTERFACE

CONTAINS

  SUBROUTINE Initialize_CRP_C3v_MoleculeSurface_Module()
    IMPLICIT NONE

    IF ( CRP_C3v_MoleculeSurface_Module_SetUp .LT. 1 ) THEN
      CRP_C3v_MoleculeSurface_Module_SetUp = 1
      CALL FOUR6D()
    END IF
  END SUBROUTINE

  SUBROUTINE Initialize_CRP_C3v_MoleculeSurface_PES( PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    PES%ccDef = 0.500

    CALL Read_PES_Info( PES )
    CALL Read_MoleculeSurface_Data( PES )
  END SUBROUTINE

  ! Read_PES_Info
  !   Read information about the PES from disk.
  SUBROUTINE Read_PES_Info( PES )
    IMPLICIT NONE

    INTEGER                          :: i, N
    TYPE ( CRP_MoleculeSurface_PES ) :: PES

    OPEN(87, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/CRPData.6D", STATUS="OLD")
    READ(87, *) N, PES%CutsInterpolation
    ALLOCATE( PES%Cuts(N) )
    PES%Alloced = .TRUE.
    PES%NumCuts = N
    DO i = 1, N
      READ(87, *) PES%Cuts(i)%X, PES%Cuts(i)%Y, PES%Cuts(i)%Theta, PES%Cuts(i)%Phi, PES%Cuts(i)%FileName
    END DO
    CLOSE(87)
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C3v_MoleculeSurface_PES_Scalar( PES, Xa, Ya, Za, Xb, Yb, Zb, V, Fxa, Fya, Fza, Fxb, Fyb, Fzb, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    REAL                 :: Xa, Ya, Za, Xb, Yb, Zb, V, Fxa, Fya, Fza, Fxb, Fyb, Fzb
    TYPE ( Units )                   :: OutUnits
    LOGICAL                          :: switch

    Za = Convert_Length_Units( Za, OutUnits, InternalUnits )
    Xa = Convert_Length_Units( Xa, OutUnits, InternalUnits )
    Ya = Convert_Length_Units( Ya, OutUnits, InternalUnits )
    Zb = Convert_Length_Units( Zb, OutUnits, InternalUnits )
    Xb = Convert_Length_Units( Xb, OutUnits, InternalUnits )
    Yb = Convert_Length_Units( Yb, OutUnits, InternalUnits )
    CALL POT6D( (/ Za, Xa, Ya, Zb, Xb, Yb /), V, Fxa, Fya, Fza, Fxb, Fyb, Fzb, switch, PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    Fxa = Convert_Force_Units( Fxa, InternalUnits, OutUnits )
    Fya = Convert_Force_Units( Fya, InternalUnits, OutUnits )
    Fza = Convert_Force_Units( Fza, InternalUnits, OutUnits )
    Fxb = Convert_Force_Units( Fxb, InternalUnits, OutUnits )
    Fyb = Convert_Force_Units( Fyb, InternalUnits, OutUnits )
    Fzb = Convert_Force_Units( Fzb, InternalUnits, OutUnits )
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C3v_MoleculeSurface_PES_Array( PES, R, V, F, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    REAL                 :: R(6), MyR(6), V, F(6)
    LOGICAL                          :: switch
    TYPE ( Units )                   :: OutUnits
    INTEGER                          :: i

    DO i = 1, 6
      MyR(i) = Convert_Length_Units( R(i), OutUnits, InternalUnits )
    END DO
    CALL POT6D( MyR, V, F(1), F(2), F(3), F(4), F(5), F(6), switch, PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    DO i = 1, 6
      F(i) = Convert_Force_Units( F(i), InternalUnits, OutUnits )
    END DO
  END SUBROUTINE

!************************ L E C T M O L 2 ****************************
!     READS the Interpolation Function from the file TOUT.DAT prepared
!     by PREPMOL.
!     LECTMOL2 defines the following values:
!       RMAX: maximum internuclear distance for which the potential can
!             be calculated (Angstroems). .
!       ZCCMIN: minimum distance from center of charge to surface
!               in molecular data (Ang.)
!*********************************************************************
  SUBROUTINE Read_MoleculeSurface_Data( PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES
    INTEGER :: i, j, k
    REAL :: ucm, vcm, xcm, ycm, zcm, r, theta, phi, rab(6), dX, dY, dZ, Va, Vb
    REAL :: Rmin = 0.0, Rmax = 100.0, Zmin = -100.0
    LOGICAL :: lexists

    OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/extrapol.dat", STATUS="OLD")
    READ(10, *) PES%GasPhase%ZsoMin
    READ(10, *) PES%GasPhase%ZsoMax
    PES%GasPhase%ZsoMin = Convert_Length_Units( PES%GasPhase%ZsoMin, PES%InputUnits, InternalUnits )
    PES%GasPhase%ZsoMax = Convert_Length_Units( PES%GasPhase%ZsoMax, PES%InputUnits, InternalUnits )
    READ(10, *) PES%GasPhase%Zdep%NX
    CALL Allocate_Spline1D( PES%GasPhase%Zdep, PES%GasPhase%Zdep%NX )
    DO i = 1, PES%GasPhase%Zdep%NX
      READ(10, *) PES%GasPhase%Zdep%X(i),PES%GasPhase%Zdep%F(i)
      PES%GasPhase%Zdep%X(i) = Convert_Length_Units( PES%GasPhase%Zdep%X(i), PES%InputUnits, InternalUnits )
      PES%GasPhase%Zdep%F(i) = Convert_Energy_Units( PES%GasPhase%Zdep%F(i), PES%InputUnits, InternalUnits )
    END DO
    PES%Zasy = PES%GasPhase%Zdep%X(PES%GasPhase%Zdep%NX)
    CLOSE(10)
    CALL Compute_Spline1D( PES%GasPhase%Zdep, 0, 0.00, 2, 0.00 )

    OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/VH2.dat", STATUS="OLD")
    READ(10, *) PES%GasPhase%Rdep%NX
    CALL Allocate_Spline1D( PES%GasPhase%Rdep, PES%GasPhase%Rdep%NX )
    DO i = 1, PES%GasPhase%Rdep%NX
      READ(10, *) PES%GasPhase%Rdep%X(i), PES%GasPhase%Rdep%F(i)
      PES%GasPhase%Rdep%X(i) = Convert_Length_Units( PES%GasPhase%Rdep%X(i), PES%InputUnits, InternalUnits )
      PES%GasPhase%Rdep%F(i) = Convert_Energy_Units( PES%GasPhase%Rdep%F(i), PES%InputUnits, InternalUnits )
    END DO
    CLOSE(10)
    CALL Compute_Spline1D( PES%GasPhase%Rdep )

    DO k = 1, SIZE( PES%Cuts )
      INQUIRE( FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/" // TRIM(ADJUSTL(PES%Cuts(k)%FileName)), EXIST=lexists )
      IF ( lexists ) THEN
      OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/" // TRIM(ADJUSTL(PES%Cuts(k)%FileName)), STATUS="OLD")
      READ(10, *) PES%Cuts(k)%Spline%NX
      READ(10, *) PES%Cuts(k)%Spline%NY
      CALL Allocate_Spline2D( PES%Cuts(k)%Spline, PES%Cuts(k)%Spline%NX, PES%Cuts(k)%Spline%NY )
      DO j = 1, PES%Cuts(k)%Spline%NY
        DO i = 1, PES%Cuts(k)%Spline%NX
          READ(10, *) PES%Cuts(k)%Spline%Y(j), PES%Cuts(k)%Spline%X(i), PES%Cuts(k)%Spline%F(i, j)
          PES%Cuts(k)%Spline%Y(j) = Convert_Length_Units( PES%Cuts(k)%Spline%Y(j), PES%InputUnits, InternalUnits )
          PES%Cuts(k)%Spline%X(i) = Convert_Length_Units( PES%Cuts(k)%Spline%X(i), PES%InputUnits, InternalUnits )
          PES%Cuts(k)%Spline%F(i, j) = Convert_Energy_Units( PES%Cuts(k)%Spline%F(i, j), PES%InputUnits, InternalUnits )
          IF (.NOT. PES%CutsInterpolation) THEN
            ucm = PES%Cuts(k)%X * PES%Geometry%LatticeConstant
            vcm = PES%Cuts(k)%Y * PES%Geometry%LatticeConstant
            xcm = ucm + vcm / 2.0
            ycm = SQRT(3.0) * vcm / 2.0
            zcm = PES%Cuts(k)%Spline%Y(j)
            r = PES%Cuts(k)%Spline%X(i)
            theta = PES%Cuts(k)%Theta * CRP_Constants_PI / 180.0
            phi = PES%Cuts(k)%Phi * CRP_Constants_PI / 180.0
            rab(1) = zcm - 0.5 * r * COS(theta)
            rab(4) = zcm + 0.5 * r * COS(theta)
            rab(2) = xcm - 0.5 * r * SIN(theta) * COS(phi)
            rab(5) = xcm + 0.5 * r * SIN(theta) * COS(phi)
            rab(3) = ycm - 0.5 * r * SIN(theta) * SIN(phi)
            rab(6) = ycm + 0.5 * r * SIN(theta) * SIN(phi)
            CALL Calculate_CRP_C3v_AtomSurface_PES( PES%AtomSurface, rab(2), rab(3), rab(1), Va, dX, dY, dZ, InternalUnits )
            CALL Calculate_CRP_C3v_AtomSurface_PES( PES%AtomSurface, rab(5), rab(6), rab(4), Vb, dX, dY, dZ, InternalUnits )
            PES%Cuts(k)%Spline%F(i, j) = PES%Cuts(k)%Spline%F(i, j) - Va - Vb
          END IF
        END DO
      END DO
      IF ( Rmin .LT. PES%Cuts(k)%Spline%X(1) ) THEN
        Rmin = PES%Cuts(k)%Spline%X(1)
      END IF
      IF ( Rmax .GT. PES%Cuts(k)%Spline%X(PES%Cuts(k)%Spline%NX) ) THEN
        Rmax = PES%Cuts(k)%Spline%X(PES%Cuts(k)%Spline%NX)
      END IF
      IF ( Zmin .LT. PES%Cuts(k)%Spline%Y(1) ) THEN
        Zmin = PES%Cuts(k)%Spline%Y(1)
      END IF
      CLOSE(10)
      CALL Compute_Spline2D( PES%Cuts(k)%Spline )
      END IF
    END DO

    PES%Rmin = Rmin
    PES%Rmax = Rmax
    PES%Zmin = Zmin

!   Here the length units of the input data is Angstroems!!!!
!   BEWARE !!!!!!!! rmax and zccmin MUST be given in Angstroems.
!    PES%Rmax = rn(nrn)
!    PES%ZccMin = zn(1)
!   If the PES programs use a.u., we MUST replace the 2 lines above by
!   rmax=rn(nrn)*0.52917724900
!   zccmin=zn(1)*0.52917724900
  END SUBROUTINE

!************************ F O U R 6 D ********************************
!     Matrix allowing to calculate the coefficients of the Fourier
!     interpolation for the 6D Interpolation Function.
!*********************************************************************
!  SUBROUTINE FOUR6D
!    IMPLICIT NONE
!
!    REAL, PARAMETER :: zer = 0.00, un = 1.00, mun = -un, deu = 2.00, mdeu = -deu
!    REAL, PARAMETER :: r1 = 1.00 / 12.00, sq3 = 1.732050807568877293500, r2 = sq3 * r1
!    REAL :: tour(idf6,idf6)
!    INTEGER :: i, j
!
!    DATA tour/12*un, &
!              deu, mdeu, deu, mdeu, mun, un, mun, un, mun, 2*un, mun, &
!              2*deu, 2*mdeu, mun, 2*un, mun, 2*un, 2*mun, &
!              deu, 2*mdeu, deu, 2*mun, 3*un, mun, un, mun, &
!              4*zer, 2*un, mun, 2*un, 3*mun, &
!              4*zer, 3*un, 3*mun, un, mun, &
!              4*zer, mun, un, 2*mun, un, mun, 2*un, &
!              2*un, 2*mun, un, 2*mun, un, 2*mun, 2*un, &
!              un, mun, un, mun, un, mun, un, mun, un, 2*mun, un, &
!              un, 2*mun, 3*un, 3*mun, un, mun, un, &
!              4*deu, 8*mun, &
!              4*zer, mun, 3*un, 3*mun, un/
!
!    DO i = 1, idf6
!      DO j = 1, 4
!        fouri6D(i, j) = r1 * tour(i, j)
!      END DO
!      DO j = 5, 7
!        fouri6D(i, j) = r2 * tour(i, j)
!      END DO
!      DO j = 8, 11
!        fouri6D(i, j) = r1 * tour(i, j)
!      END DO
!      DO j = 12, 12
!        fouri6D(i, j) = r2 * tour(i, j)
!      END DO
!    END DO
!  END SUBROUTINE

  SUBROUTINE FOUR6D
    IMPLICIT NONE

    REAL, PARAMETER :: zer = 0.00, un = 1.00, mun = -un, deu = 2.00, mdeu = -deu
    REAL, PARAMETER :: sq3 = 1.732050807568877293500, usq3 = 1.0 / sq3, r1 = usq3 / 4.00, r2 = 1.00 / 36.00
    REAL :: tour(idf6,idf6)
    INTEGER :: i, j

    DATA tour/12*un,                                                  &
         deu, mdeu, mun, un, mdeu, deu, mun, un, mun, un, mun, un,    &
         2*deu, mun, un, 2*mdeu, un, 2*mun, 2*un, mun,                &
         deu, mdeu, 2*mun, deu, mdeu, 2*un, 2*mun, 2*un,              &
         2*zer, 2*un, 2*zer, mun, un, 2*mun, un, mun,                 &
         2*zer, 2*un, 2*zer, un, 4*mun, un,                           &
         2*zer, mun, un, 2*zer, 2*mun, un, mun, 2*un,                 &
         3*un, 4*mun, 2*un, 2*mun, un,                                &
         un, mun, un, 2*mun, 2*un, mun, un, mun, un, mun,             &
         un, mun, 3*un, 3*mun, 2*un, 2*mun,                           &
         2*deu, 2*mun, 2*deu, 6*mun,                                  &
         2*zer, un, mun, 2*zer, 3*mun, 3*un/

    DO i = 1, idf6
      DO j = 1, 4
        fouri6D(i, j) = 3.0 * r2 * tour(i, j)
      END DO
      DO j = 5, 7
        fouri6D(i, j) = r1 * tour(i, j)
      END DO
      DO j = 8, 10
        fouri6D(i, j) = 3.0 * r2 * tour(i, j)
      END DO
      fouri6D(i, 11) = r2 * tour(i, 11)
      fouri6D(i, 12) = r1 / 3.0 * tour(i, 12)
    END DO
  END SUBROUTINE

!************************ R R I N T I I ******************************
  SUBROUTINE RRINTII( xa, ya, za, xb, yb, zb, Xcc, Ycc, Zcc, r, Theta, Phi, V, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, &
                      switch, PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    REAL :: Xa, Ya, Za, Xb, Yb, Zb, Xcc, Ycc, Zcc, r, Theta, Phi, V, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, &
                        dPhiXa, dPhiXb, dPhiYa, dPhiYb, dFso, dFsodZa, dFsodZb, drXa, drXb, drYa, drYb, drZa, drZb, &
                        dThetaXa, dThetaXb, dThetaYa, dThetaYb, dThetaZa, dThetaZb
    REAL, PARAMETER :: pis3 = CRP_Constants_PI / 3.00, pi2s3 = 2.00 * pis3
    INTEGER :: i
    LOGICAL :: switch

    REAL :: Vint(3, ids), Psite(5, idf6), Vinter(7)
    REAL :: dV2DinfR, dV2DinfZ, dXa, dXb, dYa, dYb, dZa, dZb, Fso, rho, rho2, va, vb, v2d

    switch = .FALSE.

    IF (Zcc .LT. PES%GasPhase%ZsoMax) THEN
!     Potential on top
      DO i = 1, 3
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnTop( Theta, Phi, Vint, Psite(1, 1) )

!     Potential on bridge
      DO i = 4, 7
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 3), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnBridge( Theta, Phi, Vint, Psite(1, 2) )
      CALL InterpolateOnBridge( Theta, Phi - pis3, Vint, Psite(1, 6) )!3) ) !!!!!!!!!!!!!!!!!BUG fixed 09/03/2012 !!!!!!!!!!!!!!!!!!
      CALL InterpolateOnBridge( Theta, Phi + pis3, Vint, Psite(1, 5) )!4) ) !!!!!!!!!!!!!!!!!BUG fixed 09/03/2012 !!!!!!!!!!!!!!!!!!

!     Potential on hcp
      DO i = 8, 12
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 7), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnHCP( Theta, Phi, Vint, Psite(1, 3) )!5) )

!     Potential on t2h
      DO i = 13, 18
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 12), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnT2H( Theta, Phi, Vint, Psite(1, 4) )!6) )
      CALL InterpolateOnT2H( Theta, Phi - pi2s3, Vint, Psite(1, 7) )
      CALL InterpolateOnT2H( Theta, Phi + pi2s3, Vint, Psite(1, 8) )

!     Potential on t2f
      DO i = 19, 24
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 18), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnT2F( Theta, Phi, Vint, Psite(1, 11) )!9) )
      CALL InterpolateOnT2F( Theta, Phi + pi2s3, Vint, Psite(1, 10) )!10) )
      CALL InterpolateOnT2F( Theta, Phi - pi2s3, Vint, Psite(1, 12) )!11) )

!     Potential on fcc
      DO i = 25, 29
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 24), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnHCP( Theta, Phi, Vint, Psite(1, 9) )!12) )

!     Now do the interpolation over X and Y
      CALL SISII( Xcc, Ycc, Psite, Vinter, PES )

!     Transformation from (X, Y, Z, r, Theta, Phi) to atomic coordinates
      drXa = -(Xb - Xa) / r
      drXb = -drXa
      drYa = -(Yb - Ya) / r
      drYb = -drYa
      drZa = -(Zb - Za) / r
      drZb = -drZa
      rho2 = (Xb - Xa)**2 + (Yb - Ya)**2
      rho = SQRT(rho2)
      IF (rho2 .GT. 0.00) THEN
        dThetaXa = -(Zb - Za) * (Xb - Xa) / (r * r * rho)
        dThetaYa = -(Zb - Za) * (Yb - Ya) / (r * r * rho)
        dPhiXa = (Yb - Ya) / rho2
        dPhiYa = -(Xb - Xa) / rho2
      ELSE
        dThetaXa = 0.00
        dThetaYa = 0.00
        dPhiXa = 0.00
        dPhiYa = 0.00
      END IF
      dThetaZa = rho / (r * r)
      dThetaXb = -dThetaXa
      dThetaYb = -dThetaYa
      dThetaZb = -dThetaZa
      dPhiXb = -dPhiXa
      dPhiYb = -dPhiYa

      CALL Calculate_CRP_C3v_AtomSurface_PES( PES%AtomSurface, Xa, Ya, Za, Va, dXa, dYa, dZa, InternalUnits )
      CALL Calculate_CRP_C3v_AtomSurface_PES( PES%AtomSurface, Xb, Yb, Zb, Vb, dXb, dYb, dZb, InternalUnits )

      IF (Zcc .LE. PES%GasPhase%ZsoMin) THEN
        V = Va + Vb + Vinter(1)
!        V = Va 
!EWF
!EWF
!        OPEN( 100, FILE="pot.dat", STATUS="unknown" )
!        WRITE(100, *) Xcc, Ycc, Zcc, r, Theta, Phi, V, Va, Vb, Vinter(1)
!        CLOSE( 100 )
!        PRINT *,"pot", Xcc, Ycc, Zcc, r, Theta, Phi, V, Va, Vb, Vinter(1)
!        PRINT *, "Z= ", Za, Zb, "Zcc=", Zcc, "r=", r

        dVdXa = dXa + 0.500 * Vinter(6) + drXa * Vinter(3) + dThetaXa * Vinter(5) + dPhiXa * Vinter(4)
        dVdXb = dXb + 0.500 * Vinter(6) + drXb * Vinter(3) + dThetaXb * Vinter(5) + dPhiXb * Vinter(4)
        dVdYa = dYa + 0.500 * Vinter(7) + drYa * Vinter(3) + dThetaYa * Vinter(5) + dPhiYa * Vinter(4)
        dVdYb = dYb + 0.500 * Vinter(7) + drYb * Vinter(3) + dThetaYb * Vinter(5) + dPhiYb * Vinter(4)
        dVdZa = dZa + 0.500 * Vinter(2) + drZa * Vinter(3) + dThetaZa * Vinter(5)
        dVdZb = dZb + 0.500 * Vinter(2) + drZb * Vinter(3) + dThetaZb * Vinter(5)
      ELSE
        CALL Switch_Function( Zcc, Fso, dFso, PES%GasPhase )
        CALL Calculate_CRP_GasPhase_Potential( Zcc, r, V2D, dV2DinfZ, dV2DinfR, PES%GasPhase )
        V = (Va + Vb + Vinter(1)) * Fso + (1.00 - Fso) * V2D
        dFsodZa = 0.500 * dFso
        dFsodZb = 0.500 * dFso
        dVdXa = (dXa + 0.500 * Vinter(6) + drXa * Vinter(3) + dThetaXa * Vinter(5) + &
                 dPhiXa * Vinter(4)) * Fso + (1.00 - Fso) * dV2Dinfr * drXa
        dVdXb = (dXb + 0.500 * Vinter(6) + drXb * Vinter(3) + dThetaXb * Vinter(5) + &
                 dPhiXb * Vinter(4)) * Fso + (1.00 - Fso) * dV2Dinfr * drXb
        dVdYa = (dYa + 0.500 * Vinter(7) + drYa * Vinter(3) + dThetaYa * Vinter(5) + &
                 dPhiYa * Vinter(4)) * Fso + (1.00 - Fso) * dV2Dinfr * drYa
        dVdYb = (dYb + 0.500 * Vinter(7) + drYb * Vinter(3) + dThetaYb * Vinter(5) + &
                 dPhiYb * Vinter(4)) * Fso + (1.00 - Fso) * dV2Dinfr * drYb
        dVdZa = (dZa + 0.500 * Vinter(2) + drZa * Vinter(3) + dThetaZa * Vinter(5)) &
                 * Fso + (Va + Vb + Vinter(1)) * dFsodZa - dFsodZa * V2D + &
                  (1.00 - Fso) * (dV2DinfZ * 0.500 + drZa * dV2DinfR)
        dVdZb = (dZb + 0.500 * Vinter(2) + drZb * Vinter(3) + dThetaZb * Vinter(5)) &
                 * Fso + (Va + Vb + Vinter(1)) * dFsodZb - dFsodZb * V2D + &
                  (1.00 - Fso) * (dV2DinfZ * 0.500 + drZb * dV2DinfR)
      END IF
    ELSE
      IF (r .LT. PES%GasPhase%Rdep%X(1) .OR. r .GT. PES%GasPhase%Rdep%X(PES%GasPhase%Rdep%NX)) THEN
        switch = .TRUE.
        RETURN
      END IF

      CALL Calculate_CRP_GasPhase_Potential( Zcc, r, V, dV2DinfZ, dV2DinfR, PES%GasPhase )
      drXa = -(Xb - Xa) / r
      drXb = -drXa
      drYa = -(Yb - Ya) / r
      drYb = -drYa
      drZa = -(Zb - Za) / r
      drZb = -drZa
      dVdXa = drXa * dV2Dinfr
      dVdXb = drXb * dV2Dinfr
      dVdYa = drYa * dV2Dinfr
      dVdYb = drYb * dV2Dinfr
      dVdZa = 0.500 * dV2DinfZ + drZa * dV2DinfR
      dVdZb = 0.500 * dV2DinfZ + drZb * dV2DinfR
    END IF
  END SUBROUTINE

!************************ S I S I I **********************************
!     Calculation of the 6D interpolation function as well as its
!     first and second derivatives using the Fourier series expansion.
!     The position the molecule center of charge is xcc,ycc.
!     PSITE: input. Contains the function and its derivatives with
!            respect to r,Z,phi and theta (first index up to 5, see
!            below for definition) for various sites labelled with
!            the second index.
!     FOURI6D: comes from the solution of the linear system associated
!              with the Fourier expansion and reference sites. It is
!              calculated in FOUR6D which must be called once before
!              the first call to SISII
!     VINTER is the output.
!     The index corresponds to: 1: function, 2: d/dr, 3: d/dZ,
!     4: d/d(phi), 5: d/d(theta), 6: d/dX, 7: d/dY.
!       Based on SIS12x12 by H.F. Busnengo
!       Version 1.0     A. Salin             07/02/02
!*********************************************************************
  SUBROUTINE SISII( Xcc, Ycc, Psite, Vinter, PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    REAL :: a(idf6), Psite(5,idf6), Fxy(idf6), dFdX(idf6), dFdY(idf6)
    REAL :: Vinter(7)
    REAL :: Xcc, Ycc
    INTEGER          :: i, j, ksit

    CALL FOUR6II( Xcc, Ycc, Fxy, dFdX, dFdY, PES )

!   Calculate the potential energy and the first derivatives with respect to X and Y
    Vinter(1) = 0.00
    Vinter(6) = 0.00
    Vinter(7) = 0.00

    DO j = 1, idf6
      a(j) = 0.00
      DO ksit = 1, idf6
        a(j) = a(j) + fouri6D(ksit, j) * Psite(1, ksit)
      END DO

      Vinter(1) = Vinter(1) + a(j) * Fxy(j)
      Vinter(6) = Vinter(6) + a(j) * dFdX(j)
      Vinter(7) = Vinter(7) + a(j) * dFdY(j)
    END DO

!   First order derivatives with respect to r, Z, phi, theta
    DO i = 2, 5
      Vinter(i) = 0.00
      DO j = 1, idf6
        a(j) = 0.00
        DO ksit = 1, idf6
          a(j) = a(j) + fouri6D(ksit, j) * Psite(i, ksit)
        END DO
        Vinter(i) = Vinter(i) + a(j) * Fxy(j)
      END DO
    END DO
  END SUBROUTINE

!************************ F O U R 6 I I ******************************
!     Calculates the basis functions of the Fourier expansion and
!     their derivatives with respect to X and Y.
!*********************************************************************
  SUBROUTINE FOUR6II( Xcc, Ycc, Fxy, dFdX, dFdY, PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    REAL :: sq3, usq3
    PARAMETER(sq3=1.732050807568877293500,usq3=1.00/sq3)

    REAL :: Fxy(idf6), dFdX(idf6), dFdY(idf6)
    REAL :: Xcc, Ycc, BigX, BigY, fBigX, fBigY, fac, c2x, c2y, c2xy, s2x, s2y, s2xy
    INTEGER :: i

!   WARNING: check carefully units for delta (interatomic distance)
!   ========

    fac = 2.00 * CRP_Constants_PI / PES%Geometry%LatticeConstant
    BigX = Xcc - Ycc * usq3
    BigY = 2.00 * Ycc * usq3
    fBigX = fac * BigX
    fBigY = fac * BigY

    c2x = COS(2.00 * fBigX)
    c2y = COS(2.00 * fBigY)
    c2xy = COS(2.00 * (fBigX + fBigY))
    s2x = SIN(2.00 * fBigX)
    s2y = SIN(2.00 * fBigY)
    s2xy = SIN(2.00 * (fBigX + fBigY))

!   Basis functions
    Fxy(1) = 1.00
    Fxy(2) = COS(fBigX)
    Fxy(3) = COS(fBigY)
    Fxy(4) = COS(fBigX + fBigY)
    Fxy(5) = SIN(fBigX)
    Fxy(6) = SIN(fBigY)
    Fxy(7) = SIN(fBigX + fBigY)
    Fxy(8) = COS(2.00 * fBigX + fBigY)
    Fxy(9) = COS(fBigX + 2.00 * fBigY)
    Fxy(10) = COS(fBigX - fBigY)
    Fxy(11) = c2x + c2y + c2xy ! was: c2x
    Fxy(12) = -s2x - s2y + s2xy ! was: s2x

!   Derivatives with respect to crystal coordinates
    dFdX(1) = 0.00
    dFdX(2) = -fac * Fxy(5)
    dFdX(3) = 0.00
    dFdX(4) = -fac * Fxy(7)
    dFdX(5) = fac * Fxy(2)
    dFdX(6) = 0.00
    dFdX(7) = fac * Fxy(4)
    dFdX(8) = -2.00 * fac * SIN(2.00 * fBigX + fbigY)
    dFdX(9) = -fac * SIN(fBigX + 2.00 * fBigY)
    dFdX(10) = -fac * SIN(fBigX - fBigY)
    dFdX(11) = -2.0 * fac * (s2x + s2xy) ! was: -2.00 * fac * s2x
    dFdX(12) = 2.0 * fac * (-c2x + c2xy) ! was: 2.00 * fac * c2x

    dFdY(1) = 0.00
    dFdY(2) = 0.00
    dFdY(3) = -fac * Fxy(6)
    dFdY(4) = -fac * Fxy(7)
    dFdY(5) = 0.00
    dFdY(6) = fac * Fxy(3)
    dFdY(7) = fac * Fxy(4)
    dFdY(8) = 0.500 * dFdX(8)
    dFdY(9) = 2.00 * dFdX(9)
    dFdY(10) = -dFdX(10)
    dFdY(11) = -2.0 * fac * (s2y + s2xy) ! was: 0.00
    dFdY(12) = 2.0 * fac * (-c2y + c2xy) ! was: 0.00

!   Derivatives with respect to cartesian coordinates
    DO i = 1, 12
      dFdY(i) = (-dFdX(i) + 2.00 * dFdY(i)) * usq3
    END DO
  END SUBROUTINE

!************************ V T O P I I ********************************
!     VINT: first index= pot, d/dr, d/dZ.
!           second index= top site geometry (teta=0; teta=90,fi=0;
!            theta=90,fi=30)
!     On output, PSITE contains potential and derivatives for
!     the given value of TETA and FI.
!     The index corresponds to: 1: function, 2: d/dr, 3: d/dZ,
!     4: d/d(phi), 5: d/d(theta).
!*********************************************************************
  SUBROUTINE InterpolateOnTop( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL :: Theta, Phi
    REAL :: Vint(3, 3), Psite(5)
    REAL :: Cos6Phi, Sin6Phi, Cos2The, Sin2The
    REAL :: V0, V90, dV90dPhi
    INTEGER          :: i

    Cos6Phi = COS(6.00 * Phi)
    Sin6Phi = SIN(6.00 * Phi)
    Cos2The = COS(2.00 * Theta)
    Sin2The = SIN(2.00 * Theta)

    DO i = 1, 3
      V0 = Vint(i, 1)
      V90 = 0.500 * ((Vint(i, 2) + Vint(i, 3)) + (Vint(i, 2) - Vint(i, 3)) * Cos6Phi )

      ! Potential and first derivatives over r and Z
      Psite(i) = 0.500 * ((V0 + V90) + (V0 - V90) * Cos2The)

      ! First derivatives over phi and theta
      IF (i .EQ. 1) THEN
        dV90dPhi = -3.00 * (Vint(1, 2) - Vint(1, 3)) * Sin6Phi
        Psite(4) = 0.500 * dV90dPhi * (1.00 - Cos2The)
        Psite(5) = -(V0 - V90) * Sin2The
      END IF
    END DO
  END SUBROUTINE

!********************** V B R I I I **********************************
!     VINT: first index= pot, d/dr, d/dZ.
!        second index= bridge site geometry (theta=0; theta=pi/2,fi=0;
!                      theta=pi/2,fi=pi/3; theta=pi/2,fi=pi/2)
!     On output, PSITE contains potential and derivatives for
!     the given value of TETA and FI.
!     The index corresponds to: 1: function, 2: d/dr, 3: d/dZ,
!     4: d/d(phi), 5: d/d(theta).
!*********************************************************************
  SUBROUTINE InterpolateOnBridge( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL, PARAMETER :: u3 = 1.00 / 3.00

    REAL :: Theta, Phi
    REAL :: Vint(3, 4), Psite(5)
    REAL :: Cos2Phi, Sin2Phi, Cos4Phi, Sin4Phi, Cos2The, Sin2The
    REAL :: V0, V90, dV90dPhi
    INTEGER          :: i

    Cos2Phi = COS(2.00 * Phi)
    Sin2Phi = SIN(2.00 * Phi)
    Cos4Phi = COS(4.00 * Phi)
    Sin4Phi = SIN(4.00 * Phi)
    Cos2The = COS(2.00 * Theta)
    Sin2The = SIN(2.00 * Theta)

    DO i = 1, 3
      V0 = Vint(i, 1)
      V90 = (Vint(i, 2) + 2.00 * Vint(i, 3)) * u3 - 0.500 * (Vint(i, 4) - Vint(i, 2)) * Cos2Phi + &
            (0.500 * (Vint(i, 4) - Vint(i, 2)) - 2.00 * (Vint(i, 3) - Vint(i, 2)) * u3) * Cos4Phi

      ! Potential and first derivatives over r and Z
      Psite(i) = 0.500 * (V0 * (1.00 + Cos2The) + V90 * (1.00 - Cos2The))

      ! First derivatives over phi and theta
      IF (i .EQ. 1) THEN
        dV90dPhi = (Vint(1, 4) - Vint(1, 2)) * Sin2Phi - (2.00 * (Vint(1, 4) - Vint(1,2)) - &
                   8.00 * (Vint(1, 3) - Vint(1, 2)) * u3) * Sin4Phi
        Psite(4) = 0.500 * dV90dPhi * (1.00 - Cos2The)
        Psite(5) = (V90 - V0) * Sin2The
      END IF
    END DO
  END SUBROUTINE
!************************ V H C P I I ********************************
!     vint: first index= pot, d/dr, d/dZ.
!           second index= fcc site geometry (theta=0; theta=90,fi=0;
!           theta=90,fi=30; theta=45,phi=30;
!           theta=45,phi=210))
!     On output, PSITE contains potential and derivatives for
!     the given value of TETA and FI.
!     The index corresponds to: 1: function, 2: d/dr, 3: d/dZ,
!     4: d/d(phi), 5: d/d(theta).
!*********************************************************************
  SUBROUTINE InterpolateOnHCP( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL :: Theta, Phi
    REAL :: Vint(3, 5), Psite(5)
    REAL :: Cos3Phi, Sin3Phi, Cos6Phi, Sin6Phi, Cos2The, Sin2The, Cos4The, Sin4The
    REAL :: V0, V45, V90, V135, dV45dPhi, dV90dPhi
    INTEGER          :: i

    Cos3Phi = COS(3.00 * Phi)
    Sin3Phi = SIN(3.00 * Phi)
    Cos6Phi = COS(6.00 * Phi)
    Sin6Phi = SIN(6.00 * Phi)
    Cos2The = COS(2.00 * Theta)
    Sin2The = SIN(2.00 * Theta)
    Cos4The = COS(4.00 * Theta)
    Sin4The = SIN(4.00 * Theta)

    DO i = 1, 3
      V0 = Vint(i, 1)
      V45 = 0.500 * ((Vint(i, 4) + Vint(i, 5)) + (Vint(i, 4) - Vint(i, 5)) * Sin3Phi)
      V135 = 0.500 * ((Vint(i, 4) + Vint(i, 5)) - (Vint(i, 4) - Vint(i, 5)) * Sin3Phi)
      V90 = 0.500 * ((Vint(i, 2) + Vint(i, 3)) + (Vint(i, 2) - Vint(i, 3)) * Cos6Phi)

      ! Potential and first derivatives over r and Z
      Psite(i) = 0.2500 * ((V0 + V45 + V90 + V135) + (V0 + V90 - V45 - V135) * Cos4The ) + &
                 0.500 * ((V0 - V90) * Cos2The + (V45 - V135) * Sin2The)

      ! First derivatives over phi and theta
      IF (i .EQ. 1) THEN
        dV45dPhi = 1.500 * (Vint(i, 4) - Vint(i, 5)) * Cos3Phi
        dV90dPhi = -3.00 * (Vint(i, 2) - Vint(i, 3)) * Sin6Phi
        Psite(4) = dV90dPhi * (0.2500 * (1.00 + Cos4The) - 0.500 * Cos2The) + dV45dPhi * Sin2The
        Psite(5) = -(V0 - V90) * Sin2The + (V45 - V135) * Cos2The - (V0 + V90 - V45 - V135) * Sin4The
      END IF
    END DO
  END SUBROUTINE

!*********************** V T 2 H I I *********************************
!     VINT: first index= pot, d/dr, d/dZ.
!       second index= t2h site geometry (theta=0; theta=pi/2,fi=2pi/3;
!        theta=pi/2,fi=2pi/3; theta=45,fi=30; theta=45,fi=120;
!        theta=45,fi=210)
!     On output, PSITE contains potential and derivatives for
!     the given value of TETA and FI.
!     The index corresponds to: 1: function, 2: d/dr, 3: d/dZ,
!     4: d/d(phi), 5: d/d(theta).
!*********************************************************************
  SUBROUTINE InterpolateOnT2H( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL, PARAMETER :: pis6 = CRP_Constants_PI / 6.00

    REAL :: Theta, Phi
    REAL :: Vint(3, 6), Psite(5)
    REAL :: Phip6, CosPhi, SinPhi, Cos2Phi, Sin2Phi, Cos2The, Sin2The, Cos4The, Sin4The
    REAL :: V0, V45, V90, V135, dV90dPhi, dV45dPhi, dV135dPhi
    INTEGER          :: i

    Phip6 = Phi - pis6
    CosPhi = COS(Phip6)
    SinPhi = SIN(Phip6)
    Cos2Phi = COS(2.00 * Phip6)
    Sin2Phi = SIN(2.00 * Phip6)
    Cos2The = COS(2.00 * Theta)
    Sin2The = SIN(2.00 * Theta)
    Cos4The = COS(4.00 * Theta)
    Sin4The = SIN(4.00 * Theta)

    DO i = 1, 3
      V0 = Vint(i, 1)
      V45 = 0.2500 * ((Vint(i, 4) + 2.00 * Vint(i, 5) + Vint(i, 6)) &
                  + (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Cos2Phi ) &
                  + 0.500 * (Vint(i, 4) - Vint(i, 6)) * CosPhi
      V135 = 0.2500 * ((Vint(i, 4) + 2.00 * Vint(i, 5) + Vint(i, 6)) &
                  + (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Cos2Phi ) &
                  - 0.500 * (Vint(i, 4) - Vint(i, 6)) * CosPhi
      V90 = 0.500 * ((Vint(i, 2) + Vint(i, 3)) + (Vint(i, 2) - Vint(i, 3)) * Cos2Phi )

      ! Potential and first derivatives over r and Z
      Psite(i) = 0.2500 * ((V0 + V45 + V90 + V135) + (V0 + V90 - V45 - V135) * Cos4The ) + &
                 0.500 * ((V0 - V90) * Cos2The + (V45 - V135) * Sin2The)

      ! First derivatives over phi and theta
      IF (i .EQ. 1) THEN
        dV45dPhi = -0.500 * ((Vint(i, 4) - Vint(i, 6)) * SinPhi + (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Sin2Phi)
        dV135dPhi = 0.500 * ((Vint(i, 4) - Vint(i, 6)) * SinPhi - (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Sin2Phi)
        dV90dPhi = -(Vint(i, 2) - Vint(i, 3)) * Sin2Phi
        Psite(4) = 0.2500 * ((dV45dPhi + dV90dPhi + dV135dPhi) + (dV90dPhi - dV45dPhi - dV135dPhi) * Cos4The) + &
                   0.500 * ((-dV90dPhi) * Cos2The + (dV45dPhi - dV135dPhi) * Sin2The)
        Psite(5) = -(V0 - V90) * Sin2The + (V45 - V135) * Cos2The - (V0 + V90 - V45 - V135) * Sin4The
      END IF
    END DO
  END SUBROUTINE

!*********************** V T 2 F I I *********************************
!     VINT: first index= pot, d/dr, d/dZ.
!       second index= t2f site geometry (theta=0; theta=90,fi=240;
!        theta=90,fi=330; theta=45,fi=150; theta=45,fi=240;
!        theta=45,fi=330)
!     On output, PSITE contains potential and derivatives for
!     the given value of TETA and FI.
!     The index corresponds to: 1: function, 2: d/dr, 3: d/dZ,
!     4: d/d(phi), 5: d/d(theta).
!*********************************************************************
  SUBROUTINE InterpolateOnT2F( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL, PARAMETER :: pis6 = CRP_Constants_PI / 6.00

    REAL :: Theta, Phi
    REAL :: Vint(3, 6), Psite(5)
    REAL :: Phip6, CosPhi, SinPhi, Cos2Phi, Sin2Phi, Cos2The, Sin2The, Cos4The, Sin4The
    REAL :: V0, V45, V90, V135, dV45dPhi, dV90dPhi, dV135dPhi
    INTEGER          :: i

    Phip6 = Phi - 11.00 * pis6
    CosPhi = COS(Phip6)
    SinPhi = SIN(Phip6)
    Cos2Phi = COS(2.00 * Phip6)
    Sin2Phi = SIN(2.00 * Phip6)
    Cos2The = COS(2.00 * Theta)
    Sin2The = SIN(2.00 * Theta)
    Cos4The = COS(4.00 * Theta)
    Sin4The = SIN(4.00 * Theta)

    DO i = 1, 3
      V0 = Vint(i, 1)
      V45 = 0.2500 * ((Vint(i, 4) + 2.00 * Vint(i, 5) + Vint(i, 6)) &
                  + (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Cos2Phi) &
                  + 0.500 * (-Vint(i, 4) + Vint(i, 6)) * CosPhi
      V135 = 0.2500 * ((Vint(i, 4) + 2.00 * Vint(i, 5) + Vint(i, 6)) &
                  + (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Cos2Phi) &
                  - 0.500 * (-Vint(i, 4) + Vint(i, 6)) * CosPhi
      V90 = 0.500 * ((Vint(i, 2) + Vint(i, 3)) + (-Vint(i, 2) + Vint(i, 3)) * Cos2Phi)

!     Potential and first derivatives over r and Z
      psite(i)= 0.2500 * ((V0 + V45 + V90 + V135) + (V0 + V90 - V45 - V135) * Cos4The) + &
                0.500 * ((V0 - V90) * Cos2The + (V45 - V135) * Sin2The)

!     First derivatives over phi and theta
      IF (i .EQ. 1) THEN
        dv45dPhi = -0.500 * ((-Vint(i, 4) + Vint(i, 6)) * SinPhi + (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Sin2Phi)
        dv135dPhi = 0.500 * ((-Vint(i, 4) + Vint(i, 6)) * SinPhi - (Vint(i, 4) - 2.00 * Vint(i, 5) + Vint(i, 6)) * Sin2Phi)
        dv90dPhi = -(-Vint(i, 2) + Vint(i, 3)) * Sin2Phi
        Psite(4) = 0.2500 * ((dV45dPhi + dV90dPhi + dV135dPhi) + (dV90dPhi - dV45dPhi - dV135dPhi) * Cos4The) + &
                   0.500 * ((-dV90dPhi) * Cos2The + (dV45dPhi - dV135dPhi) * Sin2The)
        Psite(5) = -(V0 - V90) * Sin2The + (V45 - V135) * Cos2The - (V0 + V90 - V45 - V135) * Sin4The
      END IF
    END DO
  END SUBROUTINE

!************************ P O T 6 D ***********************************
!     This routine computes the 6D potential and the corresponding
!     derivatives of the interaction potential of a diatomic homonuclear
!     molecule interacting with the 111 surface of a FCC cristal.
!     The method employed is the interpolation of ab initio data obtained
!     on different 2D (Z,r) regular grids corresponding to various
!     molecular configurations.
!
!     Configurations employed (29)
!
!     The interpolation method uses the Corrugation Reducing Procedure (CRP).
!
!     Before calling this routine, it is necessary to call
!     the routine LECTURE where all input data are read.
!
!     The meaning of the components of RAB is:
!     RAB(1)=Z_A, RAB(2)=X_A, RAB(3)=Y_A,
!     RAB(4)=Z_B, RAB(5)=X_B, RAB(6)=Y_B

!---------------------------------------------------------------------
!     Units
!---------------------------------------------------------------------
!     Calculations in RRINTII are done in Angstroems for distances and
!     eV for energies.

!     IUNIT fixes the units used for the input to POT6D and for the
!     output (potential an derivatives) to the calling program.

!     IUNIT=1
!     RAB is given in Angstroems on input to POT6D. The output is given
!     in Angstroems for distances and eV for energies.

!     IUNIT=2:
!     RAB is given in atomic units on input to POT6D. The output is
!     given in atomic units (energies and distances)

!     Beware that the unit for DELTA is given independently.

!---------------------------------------------------------------------
!
!     In this routine it is supposed that the cartesian coordinate system
!     used by the main program is the following:
!
!          y^
!           |
!           |
!         * | *
!       *   *---*--->
!         *   *     x
!
!     The logical variable SWITCH is used to indicate (on OUTPUT)
!     possible problems in the interpolation.
!     SWITCH=.FALSE.: everything is OK.
!     SWITCH=.TRUE. means that the potential cannot be computed for the
!     given value of RAB. This happens, e.g., when RAB is outside the
!     range in which the interpolation is defined.
!     ------------------------------------------------------------------
  SUBROUTINE POT6D( Rab, PotV, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, switch, PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    LOGICAL          :: switch
    REAL :: Rab(6), PotV, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, ro, Theta, Phi
    REAL :: Xa, Xb, Ya, Yb, Za, Zb, Xcc, Ycc, Zcc

    switch = .FALSE.

    PotV = 0.00
    dVdXa = 0.00
    dVdYa = 0.00
    dVdZa = 0.00
    dVdXb = 0.00
    dVdYb = 0.00
    dVdZb = 0.00

    Za = Rab(1)
    Zb = Rab(4)
    Xa = Rab(2)
    Ya = Rab(3)
    Xb = Rab(5)
    Yb = Rab(6)

    CALL CAMBCORD( Xa, Ya, Za, Xb, Yb, Zb, Xcc, Ycc, Zcc, ro, Theta, Phi,PES )
    CALL RRINTII( Xa, Ya, Za, Xb, Yb, Zb, Xcc, Ycc, Zcc, ro, Theta, Phi, &
                  PotV, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, switch, PES )

!     The potential provided by this routine
!     for the molecule far from the surface and for the H_2 equilibrium
!     distance in the vacuum (r=0.75 Angstroems) is equal to zero.
  END SUBROUTINE
END MODULE

MODULE CRP_C4v_MoleculeSurface
  USE CRP_Constants
  USE CRP_GasPhase
  USE CRP_General
  USE CRP_C4v_AtomSurface
  USE Spline
  USE UnitConversion

  PRIVATE
  PUBLIC :: Initialize_CRP_C4v_MoleculeSurface_Module, &
            Initialize_CRP_C4v_MoleculeSurface_PES, &
            Calculate_CRP_C4v_MoleculeSurface_PES

  INTEGER :: CRP_C4v_MoleculeSurface_Module_SetUp = 0

  INTERFACE Calculate_CRP_C4v_MoleculeSurface_PES
    MODULE PROCEDURE Calculate_CRP_C4v_MoleculeSurface_PES_Scalar, &
                     Calculate_CRP_C4v_MoleculeSurface_PES_Array
  END INTERFACE

CONTAINS

  SUBROUTINE Initialize_CRP_C4v_MoleculeSurface_Module()
    IMPLICIT NONE

    IF ( CRP_C4v_MoleculeSurface_Module_SetUp .LT. 1 ) THEN
      CRP_C4v_MoleculeSurface_Module_SetUp = 1
    END IF
  END SUBROUTINE

  SUBROUTINE Initialize_CRP_C4v_MoleculeSurface_PES( PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    PES%ccDef = 0.5

    CALL Read_PES_Info( PES )
    CALL Read_MoleculeSurface_Data( PES )
  END SUBROUTINE

  ! Read_PES_Info
  !   Read information about the PES from disk.
  SUBROUTINE Read_PES_Info( PES )
    IMPLICIT NONE

    INTEGER                          :: i, N
    TYPE ( CRP_MoleculeSurface_PES ) :: PES

    OPEN(87, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/CRPData.6D", STATUS="OLD")
    READ(87, *) N, PES%CutsInterpolation
    PES%NumCuts = N
    ALLOCATE( PES%Cuts(N) )
    PES%Alloced = .TRUE.
    DO i = 1, N
      READ(87, *) PES%Cuts(i)%X, PES%Cuts(i)%Y, PES%Cuts(i)%Theta, PES%Cuts(i)%Phi, PES%Cuts(i)%FileName
    END DO
    CLOSE(87)
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C4v_MoleculeSurface_PES_Scalar( PES, Xa, Ya, Za, Xb, Yb, Zb, V, Fxa, Fya, Fza, Fxb, Fyb, Fzb, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    REAL                             :: Xa, Ya, Za, Xb, Yb, Zb, V, Fxa, Fya, Fza, Fxb, Fyb, Fzb
    TYPE ( Units )                   :: OutUnits
    LOGICAL                          :: switch

    Za = Convert_Length_Units( Za, OutUnits, InternalUnits )
    Xa = Convert_Length_Units( Xa, OutUnits, InternalUnits )
    Ya = Convert_Length_Units( Ya, OutUnits, InternalUnits )
    Zb = Convert_Length_Units( Zb, OutUnits, InternalUnits )
    Xb = Convert_Length_Units( Xb, OutUnits, InternalUnits )
    Yb = Convert_Length_Units( Yb, OutUnits, InternalUnits )
    CALL POT6D( (/ Za, Xa, Ya, Zb, Xb, Yb /), V, Fxa, Fya, Fza, Fxb, Fyb, Fzb, switch, PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    Fxa = Convert_Force_Units( Fxa, InternalUnits, OutUnits )
    Fya = Convert_Force_Units( Fya, InternalUnits, OutUnits )
    Fza = Convert_Force_Units( Fza, InternalUnits, OutUnits )
    Fxb = Convert_Force_Units( Fxb, InternalUnits, OutUnits )
    Fyb = Convert_Force_Units( Fyb, InternalUnits, OutUnits )
    Fzb = Convert_Force_Units( Fzb, InternalUnits, OutUnits )
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C4v_MoleculeSurface_PES_Array( PES, R, V, F, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
    REAL                             :: R(6), MyR(6), V, F(6)
    LOGICAL                          :: switch
    TYPE ( Units )                   :: OutUnits
    INTEGER                          :: i

    DO i = 1, 6
      MyR(i) = Convert_Length_Units( R(i), OutUnits, InternalUnits )
    END DO
    CALL POT6D( MyR, V, F(1), F(2), F(3), F(4), F(5), F(6), switch, PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    DO i = 1, 6
      F(i) = Convert_Force_Units( F(i), InternalUnits, OutUnits )
    END DO
  END SUBROUTINE

  SUBROUTINE Read_MoleculeSurface_Data( PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES
    INTEGER :: i, j, k
    REAL :: xcm, ycm, zcm, r, theta, phi, rab(6), dX, dY, dZ, Va, Vb
    REAL :: Rmin = 0.0, Rmax = 100.0, Zmin = -100.0
    LOGICAL :: lexists

    OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/extrapol.dat", STATUS="OLD")
    READ(10, *) PES%GasPhase%ZsoMin
    READ(10, *) PES%GasPhase%ZsoMax
    PES%GasPhase%ZsoMin = Convert_Length_Units( PES%GasPhase%ZsoMin, PES%InputUnits, InternalUnits )
    PES%GasPhase%ZsoMax = Convert_Length_Units( PES%GasPhase%ZsoMax, PES%InputUnits, InternalUnits )
    READ(10, *) PES%GasPhase%Zdep%NX
    CALL Allocate_Spline1D( PES%GasPhase%Zdep, PES%GasPhase%Zdep%NX )
    DO i = 1, PES%GasPhase%Zdep%NX
      READ(10, *) PES%GasPhase%Zdep%X(i),PES%GasPhase%Zdep%F(i)
      PES%GasPhase%Zdep%X(i) = Convert_Length_Units( PES%GasPhase%Zdep%X(i), PES%InputUnits, InternalUnits )
      PES%GasPhase%Zdep%F(i) = Convert_Energy_Units( PES%GasPhase%Zdep%F(i), PES%InputUnits, InternalUnits )
    END DO
    PES%Zasy = PES%GasPhase%Zdep%X(PES%GasPhase%Zdep%NX)
    CLOSE(10)
    CALL Compute_Spline1D( PES%GasPhase%Zdep, 0, 0.0, 2, 0.0 )

    OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/VH2.dat", STATUS="OLD")
    READ(10, *) PES%GasPhase%Rdep%NX
    CALL Allocate_Spline1D( PES%GasPhase%Rdep, PES%GasPhase%Rdep%NX )
    DO i = 1, PES%GasPhase%Rdep%NX
      READ(10, *) PES%GasPhase%Rdep%X(i), PES%GasPhase%Rdep%F(i)
      PES%GasPhase%Rdep%X(i) = Convert_Length_Units( PES%GasPhase%Rdep%X(i), PES%InputUnits, InternalUnits )
      PES%GasPhase%Rdep%F(i) = Convert_Energy_Units( PES%GasPhase%Rdep%F(i), PES%InputUnits, InternalUnits )
    END DO
    CLOSE(10)
    CALL Compute_Spline1D( PES%GasPhase%Rdep )

    DO k = 1, SIZE( PES%Cuts )
      INQUIRE( FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/" // TRIM(ADJUSTL(PES%Cuts(k)%FileName)), EXIST=lexists )
      IF ( lexists ) THEN
      OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Molecule/" // TRIM(ADJUSTL(PES%Cuts(k)%FileName)), STATUS="OLD")
      READ(10, *) PES%Cuts(k)%Spline%NX
      READ(10, *) PES%Cuts(k)%Spline%NY
      CALL Allocate_Spline2D( PES%Cuts(k)%Spline, PES%Cuts(k)%Spline%NX, PES%Cuts(k)%Spline%NY )
      DO j = 1, PES%Cuts(k)%Spline%NY
        DO i = 1, PES%Cuts(k)%Spline%NX
          READ(10, *) PES%Cuts(k)%Spline%Y(j), PES%Cuts(k)%Spline%X(i), PES%Cuts(k)%Spline%F(i, j)
          PES%Cuts(k)%Spline%Y(j) = Convert_Length_Units( PES%Cuts(k)%Spline%Y(j), PES%InputUnits, InternalUnits )
          PES%Cuts(k)%Spline%X(i) = Convert_Length_Units( PES%Cuts(k)%Spline%X(i), PES%InputUnits, InternalUnits )
          PES%Cuts(k)%Spline%F(i, j) = Convert_Energy_Units( PES%Cuts(k)%Spline%F(i, j), PES%InputUnits, InternalUnits )
          IF (.NOT. PES%CutsInterpolation) THEN
            xcm = PES%Cuts(k)%X * PES%Geometry%LatticeConstant
            ycm = PES%Cuts(k)%Y * PES%Geometry%LatticeConstant
            zcm = PES%Cuts(k)%Spline%Y(j)
            r = PES%Cuts(k)%Spline%X(i)
            theta = PES%Cuts(k)%Theta * CRP_Constants_PI / 180.0
            phi = PES%Cuts(k)%Phi * CRP_Constants_PI / 180.0
            rab(1) = zcm - 0.5 * r * COS(theta)
            rab(4) = zcm + 0.5 * r * COS(theta)
            rab(2) = xcm - 0.5 * r * SIN(theta) * COS(phi)
            rab(5) = xcm + 0.5 * r * SIN(theta) * COS(phi)
            rab(3) = ycm - 0.5 * r * SIN(theta) * SIN(phi)
            rab(6) = ycm + 0.5 * r * SIN(theta) * SIN(phi)
            CALL Calculate_CRP_C4v_AtomSurface_PES( PES%AtomSurface, rab(2), rab(3), rab(1), Va, dX, dY, dZ, InternalUnits )
            CALL Calculate_CRP_C4v_AtomSurface_PES( PES%AtomSurface, rab(5), rab(6), rab(4), Vb, dX, dY, dZ, InternalUnits )
            PES%Cuts(k)%Spline%F(i, j) = PES%Cuts(k)%Spline%F(i, j) - Va - Vb
          END IF
        END DO
      END DO
      IF ( Rmin .LT. PES%Cuts(k)%Spline%X(1) ) THEN
        Rmin = PES%Cuts(k)%Spline%X(1)
      END IF
      IF ( Rmax .GT. PES%Cuts(k)%Spline%X(PES%Cuts(k)%Spline%NX) ) THEN
        Rmax = PES%Cuts(k)%Spline%X(PES%Cuts(k)%Spline%NX)
      END IF
      IF ( Zmin .LT. PES%Cuts(k)%Spline%Y(1) ) THEN
        Zmin = PES%Cuts(k)%Spline%Y(1)
      END IF
      CLOSE(10)
      CALL Compute_Spline2D( PES%Cuts(k)%Spline )
      END IF
    END DO

    PES%Rmin = Rmin
    PES%Rmax = Rmax
    PES%Zmin = Zmin

!   Here the length units of the input data is Angstroems!!!!
!   BEWARE !!!!!!!! rmax and zccmin MUST be given in Angstroems.
!    PES%Rmax = rn(nrn)
!    PES%ZccMin = zn(1)
!   If the PES programs use a.u., we MUST replace the 2 lines above by
!   rmax=rn(nrn)*0.529177249
!   zccmin=zn(1)*0.529177249
  END SUBROUTINE

  SUBROUTINE InterpolateOnTop( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL    :: Theta, Phi
    REAL    :: V0, V90, dV0dPhi, dV90dPhi
    REAL    :: Vint(3, 3)
    REAL    :: Psite(5)
    INTEGER :: i

    DO i = 1, 3
      V0 = Vint(i, 1)
      V90 = 0.5 * (Vint(i, 2) + Vint(i, 3)) + 0.5 * (Vint(i, 2) - Vint(i, 3)) * COS(4.0 * Phi)
      Psite(i) = 0.5 * (V0 + V90) + 0.5 * (V0 - V90) * COS(2.0 * Theta)
      IF ( i .EQ. 1 ) THEN
        dV0dPhi = 0.0
        dV90dPhi = -4.0 * 0.5 * (Vint(1, 2) - Vint(1, 3)) * SIN(4.0 * Phi)
        Psite(4) = 0.5 * (dV0dPhi + dV90dPhi) + 0.5 * (dV0dPhi - dV90dPhi) * COS(2.0 * Theta)
        Psite(5) = -2.0 * 0.5 * (V0 - V90) * SIN(2.0 * Theta)
      END IF
    END DO
  END SUBROUTINE

  SUBROUTINE InterpolateOnBridge( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL    :: Theta, Phi
    REAL    :: V0, V90, dV0dPhi, dV90dPhi
    REAL    :: Vint(3, 4)
    REAL    :: Psite(5)
    INTEGER :: i

    DO i = 1, 3
      V0 = Vint(i, 1)
      V90 = (0.25 * Vint(i, 2) + 0.5 * Vint(i, 3) + 0.25 * Vint(i, 4)) + &
             0.5 * (Vint(i, 2) - Vint(i, 4)) * COS(2.0 * Phi) + &
            (0.25 * Vint(i, 2) - 0.5 * Vint(i, 3) + 0.25 * Vint(i, 4)) * COS(4.0 * Phi)
      Psite(i) = 0.5 * (V0 + V90) + 0.5 * (V0 - V90) * COS(2.0 * Theta)
      IF ( i .EQ. 1 ) THEN
        dV0dPhi = 0.0
        dV90dPhi = -2.0 * 0.5 * (Vint(1, 2) - Vint(1, 4)) * SIN(2.0 * Phi) - &
                    4.0 * (0.25 * Vint(1, 2) - 0.5 * Vint(1, 3) + &
                    0.25 * Vint(1, 4)) * SIN(4.0 * Phi)
        Psite(4) = 0.5 * (dV0dPhi + dV90dPhi) + &
                    0.5 * (dV0dPhi - dV90dPhi) * COS(2.0 * Theta)
        Psite(5) = -2.0 * 0.5 * (V0 - V90) * SIN(2.0 * Theta)
      ENDIF
    END DO
  END SUBROUTINE

  SUBROUTINE InterpolateOnHollow( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL    :: Theta, Phi
    REAL    :: V0, V90, dV0dPhi, dV90dPhi
    REAL    :: Vint(3, 3)
    REAL    :: Psite(5)
    INTEGER :: i

    DO i = 1, 3
      V0 = Vint(i, 1)
      V90 = 0.5 * (Vint(i, 2) + Vint(i, 3)) + 0.5 * (Vint(i, 2) - Vint(i, 3)) * COS(4.0 * Phi)
      Psite(i) = 0.5 * (V0 + V90) + 0.5 * (V0 - V90) * COS(2.0 * Theta)
      IF ( i .EQ. 1 ) THEN
        dV0dPhi = 0.0
        dV90dPhi = -4.0 * 0.5 * (Vint(1, 2) - Vint(1, 3)) * SIN(4.0 * Phi)
        Psite(4) = 0.5 * (dV0dPhi + dV90dPhi) + 0.5 * (dV0dPhi - dV90dPhi) * COS(2.0 * Theta)
        Psite(5) = -2.0 * 0.5 * (V0 - V90) * SIN(2.0 * Theta)
      END IF
    END DO
  END SUBROUTINE

  SUBROUTINE InterpolateOnT2H( Theta, Phi, Vint, Psite )
    IMPLICIT NONE

    REAL    :: Theta, Phi
    REAL    :: V0, V45, V90, V135, dV0dPhi, dV45dPhi, dV90dPhi, dV135dPhi
    REAL    :: Vint(3, 6)
    REAL    :: Psite(5)
    REAL    :: a0, b0, c0
    INTEGER :: i

    DO i = 1, 3
      V0 = Vint(i, 1)
      c0 = 0.25 * (Vint(i, 2) + Vint(i, 3) - 2.0 * Vint(i, 6))
      b0 = -Vint(i, 6) + Vint(i, 3) - 2.0 * c0
      a0 = Vint(i, 3) - b0 - c0
      V45 = a0 + b0 * COS(Phi - CRP_Constants_PI / 4.0) + c0 * COS(2.0 * (Phi - CRP_Constants_PI / 4.0))
      V135 = a0 + b0 * COS(Phi + CRP_Constants_PI - CRP_Constants_PI / 4.0) + &
             c0 * COS(2.0 * (Phi + CRP_Constants_PI - CRP_Constants_PI/4.0))
      V90 = 0.5 * (Vint(i, 4) + Vint(i, 5)) + 0.5 * (Vint(i, 4) - Vint(i, 5)) * COS(2.0 * (Phi - CRP_Constants_PI / 4.0))
      Psite(i) = 0.25 * (V0 + V45 + V90 + V135) + 0.5 * (V0 - V90) * COS(2.0 * Theta) + &
                  0.5 * (V45 - V135) * SIN(2.0 * Theta) + 0.25 * (V0 + V90 - V45 - V135) * COS(4.0 * Theta)
      IF ( i .EQ. 1 ) THEN
        dV0dPhi = 0.0
        dV45dPhi = -b0 * SIN(Phi - CRP_Constants_PI / 4.0) - 2.0 * c0 * SIN(2.0 * (Phi - CRP_Constants_PI / 4.0))
        dV135dPhi = -b0 * SIN(Phi + CRP_Constants_PI - CRP_Constants_PI / 4.0) - &
                    2.0 * c0 * SIN(2.0 * (Phi + CRP_Constants_PI - CRP_Constants_PI / 4.0))
        dV90dPhi = -2.0 * 0.5 * (Vint(1, 4) - Vint(1, 5)) * SIN(2.0 * (Phi - CRP_Constants_PI / 4.0))
        Psite(4) = 0.25 * (dV0dPhi + dV45dPhi + dV90dPhi + dV135dPhi) + 0.5 * (dV0dPhi - dV90dPhi) * COS(2.0 * Theta) + &
                    0.5 * (dV45dPhi - dV135dPhi) * SIN(2.0 * Theta) + 0.25 * (dV0dPhi + dV90dPhi - dV45dPhi - dV135dPhi) * &
                    COS(4.0 * Theta)
        Psite(5) = -2.0 * 0.5 * (V0 - V90) * SIN(2.0 * Theta) + 2.0 * 0.5 * (V45 - V135) * COS(2.0 * Theta) - &
                    4.0 * 0.25 * (V0 + V90 - V45 - V135) * SIN(4.0 * Theta)
      END IF
    END DO
  END SUBROUTINE

!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!*********************************************************************************************
!     ------------------------------------------------------------------
!     Esta subrutina calcula el valor del potencial 6D y sus 6 derivadas
!     parciales para el caso de una molecula diatomica homonuclear sobre
!     una superficie (100) de un cristal FCC con una distancia entre
!     atomos primeros vecinos en la superficie igual a DELTA.
!     El metodo utilizado es la interpolacion de resultados ab-initio
!     obtenidos para ciertas orientaciones particulares de la molecula:
!     I) 3 configuraciones sobre sitio TOP:
!        a) perpendicular a la superficie
!        b) paralela a la superficie con FI=0
!        c) paralela a la superficie con FI=45
!     II) 4 configuraciones sobre sitio BRIDGE:
!        a) perpendicular a la superficie
!C        b) paralela a la superficie con FI=0
!C        c) paralela a la superficie con FI=45
!C        d) paralela a la superficie con FI=90
!C     III) 3 configuraciones sobre sitio HOLLOW:
!C        a) perpendicular a la superficie
!C        b) paralela a la superficie con FI=0
!C        c) paralela a la superficie con FI=45
!C     IV) 6 configuraciones sobre sitio T2H(punto medio entre top y hollow):
!C        a) theta=0
!C        b) theta=3*pi/4; phi=pi/4
!C        c) theta=3*pi/4; phi=pi/4
!C        d) theta=pi/2; phi=pi/4
!C        e) theta=pi/2; phi=3*pi/4
!C        f) theta=pi/4; phi=3*pi/4
!C
!C     y teniendo en cuenta el potencial de cada atomo independientemente
!C     sobre la superficie.
!C     El potencial de atomo-superficie tambien se obtiene por interpolacion
!C     a partir de resultados ab-initio correspondientes a ciertas
!C     configuraciones (ver detalles y comentarios en la subrutina AT100).
!C
!C     Antes de llamar a la subrutina VH2CU100 se deben haber llamado las
!C     subrutinas: LECTATOM (necesario para la subrutina AT100) y LECTMOL.
!C     El vector RAB (variable de entrada de 12 componentes) tiene sus 6
!C     primeras componentes que dan las coordenadas de los dos atomos del
!C     siguiente modo:
!C     RAB(1)=ZA, RAB(2)=XA, RAB(3)=YA, RAB(4)=ZB, RAB(5)=XB, RAB(6)=YB
!C     Las restantes 6 componentes del vector RAB no son utilizadas en esta
!C     subrutina y sus valores de entrada no son alterados
!C
!C     En la presente subrutina se supone que el sistema de ejes coordenados
!C     utilizado por el programa que llama a esta subrutina es el siguiente:
!C
!C          y^
!C           |
!C           *      *
!C           |
!C           |
!C           *------*--->
!C                     x
!C
!C     La variable logica SWITCH sirve para saber a la salida si la
!C     interpolacion pudo realizarse o si no fue posible por encontrar
!C     las coordenadas del punto a calcular, fuera de rango.
!C     Si SWITCH=.TRUE. -> No se pudo interpolar.
!C
!C     La variable IUNIT indica en que unidades esta expresada la variable
!C     de entrada RAB.
!C     IUNIT=1 => RAB enters in a.u. and all the results are given in a.u.
!C     ------------------------------------------------------------------
!C     ------------------------------------------------------------------
  SUBROUTINE POT6D( Rab, PotV, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, switch, PES )
    IMPLICIT NONE

    TYPE (CRP_MoleculeSurface_PES) :: PES

    LOGICAL          :: switch
    REAL :: Rab(6), PotV, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, ro, Theta, Phi
    REAL :: Xa, Xb, Ya, Yb, Za, Zb, Xcc, Ycc, Zcc

    switch = .FALSE.

    PotV = 0.0
    dVdXa = 0.0
    dVdYa = 0.0
    dVdZa = 0.0
    dVdXb = 0.0
    dVdYb = 0.0
    dVdZb = 0.0

    Za = Rab(1)
    Zb = Rab(4)
    Xa = Rab(2)
    Ya = Rab(3)
    Xb = Rab(5)
    Yb = Rab(6)

    CALL CAMBCORD( Xa, Ya, Za, Xb, Yb, Zb, Xcc, Ycc, Zcc, ro, Theta, Phi,PES )
    CALL RRINT( Xa, Ya, Za, Xb, Yb, Zb, Xcc, Ycc, Zcc, ro, Theta, Phi, &
                  PotV, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, switch, PES )
  END SUBROUTINE

  SUBROUTINE RRINT( xa, ya, za, xb, yb, zb, Xcc, Ycc, Zcc, r, Theta, Phi, V, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, &
                    switch, PES )
    IMPLICIT NONE

    REAL :: Xa, Ya, Za, Xb, Yb, Zb, Xcc, Ycc, Zcc, r, Theta, Phi, V, dVdXa, dVdYa, dVdZa, dVdXb, dVdYb, dVdZb, &
            dPhiXa, dPhiXb, dPhiYa, dPhiYb, dFso, dFsodZa, dFsodZb, drXa, drXb, drYa, drYb, drZa, drZb, &
            dThetaXa, dThetaXb, dThetaYa, dThetaYb, dThetaZa, dThetaZb
    INTEGER :: i
    LOGICAL :: switch

    REAL    :: Vint( 3, 6 ), Psite( 5, 8 )
    !REAL    :: Vint1(3), Vint2(3), Vint3(3), Vint4(3), Vint5(3), Vint6(3)
    REAL    :: Vinter(7)
    !REAL    :: Psite1(5), Psite2(5), Psite3(5), Psite4(5), Psite5(5), Psite6(5), Psite7(5), Psite8(5)
    REAL    :: dV2DinfR, dV2DinfZ, dXa, dXb, dYa, dYb, dZa, dZb, Fso, rho, rho2, Va, Vb, V2D

    TYPE ( CRP_MoleculeSurface_PES ) :: PES
!C     ------------------------------------------------------------------
!      INTEGER, PARAMETER :: idm = 16
!      COMMON/PES6CuVERT1/ZVT(IDM),RVT(IDM),VVT(IDM,IDM),DVVTZ(IDM,IDM),DVVTR(IDM,IDM),DVVTZR(IDM,IDM), &
!                   NRTV,NZTV
!      COMMON/PES6CuVERT2/ZVB(IDM),RVB(IDM),VVB(IDM,IDM),DVVBZ(IDM,IDM),DVVBR(IDM,IDM),DVVBZR(IDM,IDM), &
!                   NRBV,NZBV
!      COMMON/PES6CuVERT3/ZVH(IDM),RVH(IDM),VVH(IDM,IDM),DVVHZ(IDM,IDM),DVVHR(IDM,IDM),DVVHZR(IDM,IDM), &
!                   NRHV,NZHV
!      COMMON/PES6CuHOR10/Z10(IDM),R10(IDM),V10(IDM,IDM),DV10R(IDM,IDM),DV10Z(IDM,IDM),DV10ZR(IDM,IDM), &
!                   NR10,NZ10
!      COMMON/PES6CuHOR145/Z145(IDM),R145(IDM),V145(IDM,IDM),DV145R(IDM,IDM),DV145Z(IDM,IDM), &
!                   DV145ZR(IDM,IDM),NR145,NZ145
!      COMMON/PES6CuHOR20/Z20(IDM),R20(IDM),V20(IDM,IDM),DV20R(IDM,IDM),DV20Z(IDM,IDM), &
!                   DV20ZR(IDM,IDM),NR20,NZ20
!      COMMON/PES6CuHOR245/Z245(IDM),R245(IDM),V245(IDM,IDM),DV245R(IDM,IDM),DV245Z(IDM,IDM), &
!                   DV245ZR(IDM,IDM),NR245,NZ245
!      COMMON/PES6CuHOR290/Z290(IDM),R290(IDM),V290(IDM,IDM),DV290R(IDM,IDM),DV290Z(IDM,IDM), &
!                   DV290ZR(IDM,IDM),NR290,NZ290
!      COMMON/PES6CuHOR30/Z30(IDM),R30(IDM),V30(IDM,IDM),DV30R(IDM,IDM),DV30Z(IDM,IDM), &
!                   DV30ZR(IDM,IDM),NR30,NZ30
!      COMMON/PES6CuHOR345/Z345(IDM),R345(IDM),V345(IDM,IDM),DV345R(IDM,IDM),DV345Z(IDM,IDM), &
!                   DV345ZR(IDM,IDM),NR345,NZ345
!!C     ------------------------------------------------------------------
!      COMMON/PES6CuDAT11/Z11(IDM),R11(IDM),V11(IDM,IDM), DV11R(IDM,IDM),DV11Z(IDM,IDM), &
!                      DV11ZR(IDM,IDM),NR11,NZ11
!      COMMON/PES6CuDAT12/Z12(IDM),R12(IDM),V12(IDM,IDM),DV12R(IDM,IDM),DV12Z(IDM,IDM), &
!                             DV12ZR(IDM,IDM),NR12,NZ12
!      COMMON/PES6CuDAT13/Z13(IDM),R13(IDM),V13(IDM,IDM),  DV13R(IDM,IDM),DV13Z(IDM,IDM), &
!                 DV13ZR(IDM,IDM),NR13,NZ13
!      COMMON/PES6CuDAT14/Z14(IDM),R14(IDM),V14(IDM,IDM),DV14R(IDM,IDM),DV14Z(IDM,IDM), &
!                 DV14ZR(IDM,IDM),NR14,NZ14
!      COMMON/PES6CuDAT15/Z15(IDM),R15(IDM),V15(IDM,IDM), DV15R(IDM,IDM),DV15Z(IDM,IDM), &
!          DV15ZR(IDM,IDM),NR15,NZ15
!      COMMON/PES6CuDAT16/Z16(IDM),R16(IDM),V16(IDM,IDM), DV16R(IDM,IDM),DV16Z(IDM,IDM), &
!         DV16ZR(IDM,IDM),NR16,NZ16
!!C     ------------------------------------------------------------------
!!C     Datos para el switch off del potencial
!      COMMON/PES6CuSWOFF/ZSOMIN,ZSOMAX
!      COMMON/PES6CuH2INFI/RH2(IDM),VH2INFI(IDM),VH2INFI2(IDM),NDATH2

!      INTEGER :: ndath2
!      INTEGER :: nztv, nzbv, nzhv, nz10, nz145, nz20, nz245, nz290, nz30, nz345, nz11, nz12, nz13, nz14, nz15, nz16
!      INTEGER :: nrtv, nrbv, nrhv, nr10, nr145, nr20, nr245, nr290, nr30, nr345, nr11, nr12, nr13, nr14, nr15, nr16

!      INTEGER :: ia, ja

    switch = .FALSE.
    V = 0.0
    Va = 0.0
    Vb = 0.0
    dVdXa = 0.0
    dVdYa = 0.0
    dVdZa = 0.0
    dVdXb = 0.0
    dVdYb = 0.0
    dVdZb = 0.0

    IF (Zcc .LT. PES%GasPhase%ZsoMax) THEN
         !CALL UBICAR(RVT,RO,NRTV,IA,SWITCH)
         !IF (SWITCH) RETURN
         !CALL UBICAR(ZVT,ZCM,NZTV,JA,SWITCH)
         !IF (SWITCH) RETURN
         !     Potential on top
      DO i = 1, 3
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnTop( Theta, Phi, Vint, Psite(1, 1) )
!!C     ------------------------------------------------------------------
!!C     Siempre la primera componente es el potencial, luego las derivadas
!!C     respecto a Z, RO, FI, X, Y, TETA en ese orden ! ! ! !
!!C     ------------------------------------------------------------------
!!C     Potential on TOP
!!C      --------------------
!!C     Top theta=0
!      CALL int_PES6CuSPLINT2(RVT,ZVT,NRTV,NZTV,VVT,DVVTR,DVVTZ,DVVTZR,RO,ZCM, &
!             IA,JA,VINT1(1),VINT1(3),VINT1(2),IDM,IDM)
!!C     -----------------------------------------
!!C     Top theta=90;phi=0
!      CALL int_PES6CuSPLINT2(R10,Z10,NR10,NZ10,V10,DV10R,DV10Z,DV10ZR,RO,ZCM, &
!               IA,JA,VINT2(1),VINT2(3),VINT2(2),IDM,IDM)
!!C     -----------------------------------------
!!C     Top theta=90;phi=45
!      CALL int_PES6CuSPLINT2(R145,Z145,NR145,NZ145,V145,DV145R,DV145Z,DV145ZR, &
!           RO,ZCM,IA,JA,VINT3(1),VINT3(3),VINT3(2),IDM,IDM)
!!C     -----------------------------------------
!      CALL InterpolateOnTop(TETA,FI,VINT1,VINT2,VINT3,PSITE1)
!!C     ------------------------------------------------------------------
!C     Interpolacion on BRIDGE
!C     -------------------------------
!C     -------------------------------
!     Potential on bridge
      DO i = 4, 7
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 3), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnBridge( Theta, Phi, Vint, Psite(1, 2) )
      CALL InterpolateOnBridge( Theta, Phi + CRP_Constants_PI / 2.0, Vint, Psite(1, 5) )

!!C     Potential on Bridge and theta=0
!      CALL int_PES6CuSPLINT2(RVB,ZVB,NRBV,NZBV,VVB,DVVBR,DVVBZ,DVVBZR,RO,ZCM, &
!              IA,JA,VINT1(1),VINT1(3),VINT1(2),IDM,IDM)
!!C     -----------------------
!!C     Bridge theta=90;phi=0
!      CALL int_PES6CuSPLINT2(R20,Z20,NR20,NZ20,V20,DV20R,DV20Z,DV20ZR,RO,ZCM, &
!             IA,JA,VINT2(1),VINT2(3),VINT2(2),IDM,IDM)
!!C     -----------------------
!!C     Bridge theta=90;phi=45
!      CALL int_PES6CuSPLINT2(R245,Z245,NR245,NZ245,V245,DV245R,DV245Z,DV245ZR, &
!         RO,ZCM,IA,JA,VINT3(1),VINT3(3),VINT3(2),IDM,IDM)
!!C     -----------------------
!!C     Bridge theta=90;phi=90
!      CALL int_PES6CuSPLINT2(R290,Z290,NR290,NZ290,V290,DV290R,DV290Z,DV290ZR, &
!                  RO,ZCM,IA,JA,VINT4(1),VINT4(3),VINT4(2),IDM,IDM)
!!C     -------------------------------------------
!      CALL InterpolateOnBridge(TETA,FI,VINT1,VINT2,VINT3,VINT4,PSITE2)
!!C     EL potencial en el punto 2', equivalente a 2! (lo llamo sitio5)
!      CALL InterpolateOnBridge(TETA,FI+CRP_Constants_PI/2.0,VINT1,VINT2,VINT3,VINT4,PSITE5)
!!C     ------------------------------------------------------------------
!C     Interpolacion on HOLLOW
!C     -----------------------
      DO i = 8, 10
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 7), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnHollow( Theta, Phi, Vint, Psite(1, 3) )

!!C     Hollow theta=0
!      CALL int_PES6CuSPLINT2(RVH,ZVH,NRHV,NZHV,VVH,DVVHR,DVVHZ,DVVHZR,RO,ZCM, &
!              IA,JA,VINT1(1),VINT1(3),VINT1(2),IDM,IDM)
!!C     -----------------------------------------
!!C     Hollow theta=90, phi=0
!      CALL int_PES6CuSPLINT2(R30,Z30,NR30,NZ30,V30,DV30R,DV30Z,DV30ZR,RO,ZCM, &
!                  IA,JA,VINT2(1),VINT2(3),VINT2(2),IDM,IDM)
!!C     -----------------------------------------
!!C     Hollow theta=90, phi=45
!      CALL int_PES6CuSPLINT2(R345,Z345,NR345,NZ345,V345,DV345R,DV345Z, &
!                 DV345ZR,RO,ZCM,IA,JA,VINT3(1),VINT3(3),VINT3(2),IDM,IDM)
!!C     ---------------------------------------------
!      CALL InterpolateOnHollow(TETA,FI,VINT1,VINT2,VINT3,PSITE3)
!!C     ---------------------------------------------------------------
!C     Interpolacion on T2H
!C     ---------------------------------------
      DO i = 11, 16
        CALL Evaluate_Spline2D_Alt( PES%Cuts(i)%Spline, r, Zcc, Vint(1, i - 10), switch )
        IF (switch) RETURN
      END DO
      CALL InterpolateOnT2H( Theta, Phi, Vint, Psite(1, 4) )
      CALL InterpolateOnT2H( Theta, Phi - CRP_Constants_PI / 2.0, Vint, Psite(1, 6) )
      CALL InterpolateOnT2H( Theta, Phi - CRP_Constants_PI, Vint, Psite(1, 7) )
      CALL InterpolateOnT2H( Theta, Phi + CRP_Constants_PI / 2.0, Vint, Psite(1, 8) )

!C     T2H theta=0
!      CALL int_PES6CuSPLINT2(R11,Z11,NR11,NZ11,V11,DV11R,DV11Z,DV11ZR,RO,ZCM, &
!               IA,JA,VINT1(1),VINT1(3),VINT1(2),IDM,IDM)
!!C     -----------------------------------------
!!C     T2H theta=45; phi=225
!      CALL int_PES6CuSPLINT2(R12,Z12,NR12,NZ12,V12,DV12R,DV12Z,DV12ZR,RO,ZCM, &
!             IA,JA,VINT2(1),VINT2(3),VINT2(2),IDM,IDM)
!!C     -----------------------------------------
!!C     T2H theta=45; phi=45
!      CALL int_PES6CuSPLINT2(R13,Z13,NR13,NZ13,V13,DV13R,DV13Z,DV13ZR,RO,ZCM, &
!            IA,JA,VINT3(1),VINT3(3),VINT3(2),IDM,IDM)
!!C     -----------------------------------------
!!C     T2H theta=90; phi=45
!      CALL int_PES6CuSPLINT2(R14,Z14,NR14,NZ14,V14,DV14R,DV14Z,DV14ZR,RO,ZCM, &
!            IA,JA,VINT4(1),VINT4(3),VINT4(2),IDM,IDM)
!!C     ---------------------------------------
!!C     T2H theta=90; phi=135
!      CALL int_PES6CuSPLINT2(R15,Z15,NR15,NZ15,V15,DV15R,DV15Z,DV15ZR,RO,ZCM, &
!             IA,JA,VINT5(1),VINT5(3),VINT5(2),IDM,IDM)
!!C     ---------------------------------------
!!C     T2H theta=45; phi=135
!      CALL int_PES6CuSPLINT2(R16,Z16,NR16,NZ16,V16,DV16R,DV16Z,DV16ZR,RO,ZCM, &
!              IA,JA,VINT6(1),VINT6(3),VINT6(2),IDM,IDM)
!!C     ---------------------------------------
!      CALL InterpolateOnT2H(TETA,FI,VINT1,VINT2,VINT3,VINT4,VINT5,VINT6,PSITE4)
!!C     Los potenciales en el punto 4', 4'' y 4''',
!!C     equivalentes a 4 (los llamo sitio6,7,8 respectivamente)
!      CALL InterpolateOnT2H(TETA,FI-CRP_Constants_PI/2.0,VINT1,VINT2,VINT3,VINT4,VINT5, &
!               VINT6,PSITE6)
!      CALL InterpolateOnT2H(TETA,FI-CRP_Constants_PI,VINT1,VINT2,VINT3,VINT4,VINT5,VINT6,PSITE7)
!      CALL InterpolateOnT2H(TETA,FI+CRP_Constants_PI/2.0,VINT1,VINT2,VINT3,VINT4,VINT5, &
!             VINT6,PSITE8)
!C     ---------------------------------------------------------------
      CALL SIS8x8( Xcc, Ycc, Psite, Vinter, PES )
!C      WRITE(*,*)'Func. de interpolacion (eV)=',VINTER(1)
!C     ------------------------------------------------------------------
!C     Transformacion de coordenadas para pasar de (X,Y,Z,RO,TETA,FI),
!C     las cuales fueron utilizadas en la interpolacion horizontal, a
!C     (XA,YA,ZA,XB,YB,ZB)

      drXa = -(Xb - Xa) / r
      drXb = -drXa
      drYa = -(Yb - Ya) / r
      drYb = -drYa
      drZa = -(Zb - Za) / r
      drZb = -drZa
      IF ( (Xb - Xa)**2.0 + (Yb - Ya)**2.0 .GT. 0.0 ) THEN
         dThetaXa = -(Zb - Za) * (Xb - Xa) / r**2.0 / SQRT((Xb - Xa)**2.0 + (Yb - Ya)**2.0)
         dThetaYa = -(Zb - Za) * (Yb - Ya) / r**2.0 / SQRT((Xb - Xa)**2.0 + (Yb - Ya)**2.0)
         dPhiXa = (YB-YA)/((XB-XA)**2.0+(YB-YA)**2.0)
         dPhiYa = -(XB-XA)/((XB-XA)**2.0+(YB-YA)**2.0)
      ELSE
         dThetaXa = 0.0
         dThetaYa = 0.0
         dPhiXa = 0.0
         dPhiYa = 0.0
      END IF
      dThetaZa = SQRT((Xb - Xa)**2.0 + (Yb - Ya)**2.0) / r**2.0
      dThetaXb = -dThetaXa
      dThetaYb = -dThetaYa
      dThetaZb = -dThetaZa
      dPhiXb = -dPhiXa
      dPhiYb = -dPhiYa
!C     -----------------------------------------------------------------
      CALL Calculate_CRP_C4v_AtomSurface_PES( PES%AtomSurface, XA, YA, ZA, VA, DXA, DYA, DZA, InternalUnits)
      CALL Calculate_CRP_C4v_AtomSurface_PES( PES%AtomSurface, XB, YB, ZB, VB, DXB, DYB, DZB, InternalUnits)
!C      WRITE(*,*)'--------------------------'
!C      WRITE(*,*)'V atomo A (eV)=',VA
!C      WRITE(*,*)'dV/dX atomo A (eV/au)=',DXA
!C      WRITE(*,*)'dV/dY atomo A (eV/au)=',DYA
!C      WRITE(*,*)'dV/dZ atomo A (eV/au)=',DZA
!C      WRITE(*,*)'V atomo B (eV)=',VB
!C      WRITE(*,*)'dV/dX atomo B (eV/au)=',DXB
!C      WRITE(*,*)'dV/dY atomo B (eV/au)=',DYB
!C      WRITE(*,*)'dV/dZ atomo B (eV/au)=',DZB
!C      WRITE(*,*)'V atomico (eV)=',VA+VB
!C      WRITE(*,*)'--------------------------'
!C     ------------------------------------------------------------------
      IF ( Zcc .LE. PES%GasPhase%ZsoMin ) THEN
        V = Va + Vb + Vinter(1)
        dVdXa = dXa + 0.5 * Vinter(6) + drXa * Vinter(3) + dThetaXa * Vinter(5) + dPhiXa * Vinter(4)
        dVdXb = dXb + 0.5 * Vinter(6) + drXb * Vinter(3) + dThetaXb * Vinter(5) + dPhiXb * Vinter(4)
        dVdYa = dYa + 0.5 * Vinter(7) + drYa * Vinter(3) + dThetaYa * Vinter(5) + dPhiYa * Vinter(4)
        dVdYb = dYb + 0.5 * Vinter(7) + drYb * Vinter(3) + dThetaYb * Vinter(5) + dPhiYb * Vinter(4)
        dVdZa = dZa + 0.5 * Vinter(2) + drZa * Vinter(3) + dThetaZa * Vinter(5)
        dVdZb = dZb + 0.5 * Vinter(2) + drZb * Vinter(3) + dThetaZb * Vinter(5)
      ELSE
        CALL Switch_Function( Zcc, Fso, dFso, PES%GasPhase )
        CALL Calculate_CRP_GasPhase_Potential( Zcc, r, V2D, dV2DinfZ, dV2DinfR, PES%GasPhase )
        V = (Va + Vb + Vinter(1)) * Fso + (1.0 - Fso) * V2D
        dFsodZa = 0.5 * dFso
        dFsodZb = 0.5 * dFso
        dVdXa = (dXa + 0.5 * Vinter(6) + drXa * Vinter(3) + dThetaXa * Vinter(5) + &
                 dPhiXa * Vinter(4)) * Fso + (1.0 - Fso) * dV2Dinfr * drXa
        dVdXb = (dXb + 0.5 * Vinter(6) + drXb * Vinter(3) + dThetaXb * Vinter(5) + &
                 dPhiXb * Vinter(4)) * Fso + (1.0 - Fso) * dV2Dinfr * drXb
        dVdYa = (dYa + 0.5 * Vinter(7) + drYa * Vinter(3) + dThetaYa * Vinter(5) + &
                 dPhiYa * Vinter(4)) * Fso + (1.0 - Fso) * dV2Dinfr * drYa
        dVdYb = (dYb + 0.5 * Vinter(7) + drYb * Vinter(3) + dThetaYb * Vinter(5) + &
                 dPhiYb * Vinter(4)) * Fso + (1.0 - Fso) * dV2Dinfr * drYb
        dVdZa = (dZa + 0.5 * Vinter(2) + drZa * Vinter(3) + dThetaZa * Vinter(5)) &
                 * Fso + (Va + Vb + Vinter(1)) * dFsodZa - dFsodZa * V2D + &
                  (1.0 - Fso) * (dV2DinfZ * 0.5 + drZa * dV2DinfR)
        dVdZb = (dZb + 0.5 * Vinter(2) + drZb * Vinter(3) + dThetaZb * Vinter(5)) &
                 * Fso + (Va + Vb + Vinter(1)) * dFsodZb - dFsodZb * V2D + &
                  (1.0 - Fso) * (dV2DinfZ * 0.5 + drZb * dV2DinfR)
      END IF
    ELSE
      IF (r .LT. PES%GasPhase%Rdep%X(1) .OR. r .GT. PES%GasPhase%Rdep%X(PES%GasPhase%Rdep%NX)) THEN
        switch = .TRUE.
        RETURN
      END IF

      CALL Calculate_CRP_GasPhase_Potential( Zcc, r, V, dV2DinfZ, dV2DinfR, PES%GasPhase )
      drXa = -(Xb - Xa) / r
      drXb = -drXa
      drYa = -(Yb - Ya) / r
      drYb = -drYa
      drZa = -(Zb - Za) / r
      drZb = -drZa
      dVdXa = drXa * dV2Dinfr
      dVdXb = drXb * dV2Dinfr
      dVdYa = drYa * dV2Dinfr
      dVdYb = drYb * dV2Dinfr
      dVdZa = 0.5 * dV2DinfZ + drZa * dV2DinfR
      dVdZb = 0.5 * dV2DinfZ + drZb * dV2DinfR
    END IF
  END SUBROUTINE

  SUBROUTINE SIS8x8( Xcm, Ycm, Psite, Vinter, PES )
    IMPLICIT NONE

    REAL :: Xcm, Ycm, Psite(5, 8), Vinter(7)
    REAL :: Fac, F1XY, F2XY, F3XY, F4XY, F5XY, F6XY, F7XY, F8XY, A1, A2, A3, A4, A5, A6, A7, A8
    REAL :: dF1dX, dF1dY, dF2dX, dF2dY, dF3dX, dF3dY, dF4dX, dF4dY, dF5dX, dF5dY, dF6dX, dF6dY, dF7dX, dF7dY, dF8dX, dF8dY
    TYPE (CRP_MoleculeSurface_PES) :: PES
    INTEGER :: i

!   Interpolation with respect to X and Y
    Fac = 2.0 * CRP_Constants_PI / PES%Geometry%LatticeConstant
    F1XY = 1.0
    F2XY = COS(Fac * Xcm)
    F3XY = COS(Fac * Ycm)
    F4XY = SIN(Fac * Xcm)
    F5XY = SIN(Fac * Ycm)
    F6XY = COS(Fac * (Xcm + Ycm))
    F7XY = COS(Fac * (Xcm - Ycm))
    F8XY = COS(Fac * (2.0 * Xcm)) + COS(Fac * (2.0 * Ycm))

    dF1dX = 0.0
    dF1dY = 0.0
    dF2dX = -Fac * SIN(Fac * Xcm)
    dF2dY = 0.0
    dF3dX = 0.0
    dF3dY = -Fac * SIN(Fac * Ycm)
    dF4dX = Fac * COS(Fac * Xcm)
    dF4dY = 0.0
    dF5dX = 0.0
    dF5dY = Fac * COS(Fac * Ycm)
    dF6dX = -Fac * SIN(Fac * (Xcm + Ycm))
    dF6dY = -Fac * SIN(Fac * (Xcm + Ycm))
    dF7dX = -Fac * SIN(Fac * (Xcm - Ycm))
    dF7dY = Fac * SIN(Fac * (Xcm - Ycm))
    dF8dX = -2.0 * Fac * SIN(Fac * (2.0 * Xcm))
    dF8dY = -2.0 * Fac * SIN(Fac * (2.0 * Ycm))

    DO i = 1, 5
      A1 = 1.0 / 8.0 * (Psite(i, 1) + Psite(i, 2) + Psite(i, 5) + Psite(i, 3) + &
                        Psite(i, 4) + Psite(i, 6) + Psite(i, 7) + Psite(i, 8))
      A2 = 1.0 / 4.0 * (Psite(i, 1) - Psite(i, 2) + Psite(i, 5) - Psite(i, 3))
      A3 = 1.0 / 4.0 * (Psite(i, 1) + Psite(i, 2) - Psite(i, 5) - Psite(i, 3))
      A4 = 1.0 / 4.0 * (Psite(i, 4) - Psite(i, 6) - Psite(i, 7) + Psite(i, 8))
      A5 = 1.0 / 4.0 * (Psite(i, 4) + Psite(i, 6) - Psite(i, 7) - Psite(i, 8))
      A6 = 1.0 / 8.0 * (Psite(i, 1) - Psite(i, 2) - Psite(i, 5) + Psite(i, 3) - &
                        Psite(i, 4) + Psite(i, 6) - Psite(i, 7) + Psite(i, 8))
      A7 = 1.0 / 8.0 * (Psite(i, 1) - Psite(i, 2) - Psite(i, 5) + Psite(i, 3) + &
                        Psite(i, 4) - Psite(i, 6) + Psite(i, 7) - Psite(i, 8))
      A8 = 1.0 / 16.0 * (Psite(i, 1) + Psite(i, 2) + Psite(i, 5) + Psite(i, 3) - &
                         Psite(i, 4) - Psite(i, 6) - Psite(i, 7) - Psite(i, 8))

      Vinter(i) = A1 * F1XY + A2 * F2XY + A3 * F3XY + A4 * F4XY + A5 * F5XY + A6 * F6XY + A7 * F7XY + A8 * F8XY
      IF ( i .EQ. 1 ) THEN
        Vinter(6) = A1 * dF1dX + A2 * dF2dX + A3 * dF3dX + A4 * dF4dX + A5 * dF5dX + A6 * dF6dX + A7 * dF7dX + A8 * dF8dX
        Vinter(7) = A1 * dF1dY + A2 * dF2dY + A3 * dF3dY + A4 * dF4dY + A5 * dF5dY + A6 * dF6dY + A7 * dF7dY + A8 * dF8dY
      END IF
    END DO
  END SUBROUTINE
END MODULE

MODULE CRP_C4v_AtomSurface
  USE CRP_Constants
  USE CRP_General
  USE Spline

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: Initialize_CRP_C4v_AtomSurface_Module, &
            Initialize_CRP_C4v_AtomSurface_PES, &
            Calculate_CRP_C4v_AtomSurface_PES

  INTERFACE Calculate_CRP_C4v_AtomSurface_PES
    MODULE PROCEDURE Calculate_CRP_C4v_AtomSurface_PES_Scalar, &
                     Calculate_CRP_C4v_AtomSurface_PES_Array
  END INTERFACE

CONTAINS

  ! Initialize_CRP_C4v_AtomSurface_Module
  !   Initialize this module. Call before use.
  SUBROUTINE Initialize_CRP_C4v_AtomSurface_Module()
    IMPLICIT NONE
  END SUBROUTINE

  ! Initialize_CRP_C4v_AtomSurface_PES
  !   Initialize a PES.
  SUBROUTINE Initialize_CRP_C4v_AtomSurface_PES( PES )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    CALL Read_PES_Info( PES )
    CALL Read_AtomSurface_Data( PES )
  END SUBROUTINE

  ! Read_PES_Info
  !   Read information about the PES from disk.
  SUBROUTINE Read_PES_Info( PES )
    IMPLICIT NONE

    INTEGER                      :: i, N
    TYPE ( CRP_AtomSurface_PES ) :: PES

    OPEN(87, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/CRPData.3D", STATUS="OLD")
    READ(87, *) N
    PES%NumCuts = N
    ALLOCATE( PES%Cuts(N) )
    PES%Alloced = .TRUE.
    DO i = 1, N
      READ(87, *) PES%Cuts(i)%X, PES%Cuts(i)%Y, PES%Cuts(i)%FileName
    END DO
    CLOSE(87)
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C4v_AtomSurface_PES_Scalar( PES, X, Y, Z, V, Fx, Fy, Fz, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    TYPE ( Units )               :: OutUnits
    REAL             :: X, Y, Z, V, Fx, Fy, Fz
    REAL             :: MyX, MyY, MyZ

    MyX = Convert_Length_Units( X, OutUnits, InternalUnits )
    MyY = Convert_Length_Units( Y, OutUnits, InternalUnits )
    MyZ = Convert_Length_Units( Z, OutUnits, InternalUnits )
    CALL int_PES6CuHATOMCu100( MyX, MyY, MyZ, V, Fx, Fy, Fz, PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    Fx = Convert_Force_Units( Fx, InternalUnits, OutUnits )
    Fy = Convert_Force_Units( Fy, InternalUnits, OutUnits )
    Fz = Convert_Force_Units( Fz, InternalUnits, OutUnits )
  END SUBROUTINE

  SUBROUTINE Calculate_CRP_C4v_AtomSurface_PES_Array( PES, R, V, F, OutUnits )
    IMPLICIT NONE

    TYPE ( CRP_AtomSurface_PES ) :: PES
    TYPE ( Units )               :: OutUnits
    REAL             :: R(3), V, F(3)
    INTEGER                      :: i
    REAL             :: MyR(3)

    DO i = 1, 3
      MyR(i) = Convert_Length_Units( R(i), OutUnits, InternalUnits )
    END DO
    CALL int_PES6CuHATOMCu100( MyR(1), MyR(2), MyR(3), V, F(1), F(2), F(3), PES )
    V = Convert_Energy_Units( V, InternalUnits, OutUnits )
    DO i = 1, 3
      F(i) = Convert_Force_Units( F(i), InternalUnits, OutUnits )
    END DO
  END SUBROUTINE

  SUBROUTINE ORIGEN( X, Y, Delta, BigX, BigY )
    IMPLICIT NONE

    REAL    :: X, Y, BigX, BigY, Delta, Ori(2)
    INTEGER :: i, Ind(2)

    Ori(1) = X / Delta
    Ori(2) = Y / Delta
    DO i = 1, 2
      IF ( Ori(i) .GE. 0.0 ) THEN
        Ind(i) = Ori(i)
      ELSE
        Ind(i) = Ori(i) - 1
      END IF
    END DO
    BigX = X - Ind(1) * Delta
    BigY = Y - Ind(2) * Delta
  END SUBROUTINE

  SUBROUTINE REGION( BigX0, BigY0, Delta, IRegion )
    IMPLICIT NONE

    REAL    :: BigX0, BigY0, Delta, Aux
    INTEGER :: IRegion
!C
!C     Let us approximately plot the regions here:
!C
!C     XXXXXXXXXXXXXXX
!C     X X    X    X X
!C     X  X 7 X 8 X  X
!C     X   X  X  X   X
!C     X 5  X X X  6 X
!C     X     XXX     X
!C     XXXXXXXXXXXXXXX
!C     X     XXX     X
!C     X 3  X X X  4 X
!C     X   X  X  X   X
!C     X  X 1 X 2 X  X
!C     X X    X    X X
!C     XXXXXXXXXXXXXXX
!C
!C
!C
!C     Lower half of the unit cell
!C
    IF ( BigY0 .LE. Delta / 2.0 ) THEN
      IF ( BigX0 .LE. Delta / 2.0 ) THEN
        IF ( BigX0 .GE. BigY0) THEN
          IRegion = 1
          RETURN
        ELSE
          IRegion = 3
          Aux = BigX0
          BigX0 = BigY0
          BigY0 = Aux
          RETURN
        END IF
      ELSE
        IF ( BigY0 .GE. (Delta - BigX0) ) THEN
          IRegion = 4
          Aux = BigX0
          BigX0 = BigY0
          BigY0 = Delta - Aux
          RETURN
        ELSE
          IRegion = 2
          BigX0 = Delta - BigX0
          RETURN
        END IF
      END IF
!C
!C     Lower half of the unit cell
!C
    ELSE
      IF ( BigX0 .LE. Delta / 2.0 ) THEN
        IF ( BigY0 .GT. (Delta - BigX0) ) THEN
          IRegion = 7
          BigY0 = Delta - BigY0
          RETURN
        ELSE
          IRegion = 5
          Aux = BigX0
          BigX0 = Delta - BigY0
          BigY0 = Aux
          RETURN
        END IF
      ELSE
        IF ( BigX0 .GT. BigY0 ) THEN
          IRegion = 6
          Aux = BigX0
          BigX0 = Delta - BigY0
          BigY0 = Delta - Aux
          RETURN
        ELSE
          IRegion = 8
          BigX0 = Delta - BigX0
          BigY0 = Delta - BigY0
          RETURN
        END IF
      END IF
    END IF
!C
!C     If we arrive here is that there was some error in the coordinates
!C
    WRITE (*,*) 'ERROR IN REGION'
    STOP
  END SUBROUTINE

  SUBROUTINE TRANSF( IRegion, dVdX, dVdY )
    IMPLICIT NONE

    INTEGER :: IRegion
    REAL    :: dVdX, dVdY, Aux

!C     Aqui se transforman las derivadas segun la ubicacion
    IF ( IRegion .EQ. 1 ) THEN
      RETURN
    ELSE IF ( IRegion .EQ. 2 ) THEN
      dVdX = -dVdX
      RETURN
    ELSE IF ( IRegion .EQ. 3 ) THEN
      Aux = dVdX
      dVdX = dVdY
      dVdY = Aux
      RETURN
    ELSE IF ( IRegion .EQ. 4 ) THEN
      Aux = dVdX
      dVdX = -dVdY
      dVdY = Aux
      RETURN
    ELSE IF ( IRegion .EQ. 5 ) THEN
      Aux = dVdX
      dVdX = dVdY
      dVdY = -Aux
      RETURN
    ELSE IF ( IRegion .EQ. 6 ) THEN
      Aux = dVdX
      dVdX = -dVdY
      dVdY = -Aux
      RETURN
    ELSE IF ( IRegion .EQ. 7 ) THEN
      dVdY = -dVdY
      RETURN
    ELSE IF ( IRegion .EQ. 8 ) THEN
      dVdX = -dVdX
      dVdY = -dVdY
      RETURN
    END IF

!C     If we arrive here is that there was some error in the IREG index.
    WRITE (*,*) 'ERROR IN TRANSF'
    STOP
  END SUBROUTINE

  SUBROUTINE Read_AtomSurface_Data( PES )
!C     ------------------------------------------------------------------
!C     A pesar de que en esta rutina se leen los diferentes valores
!C     tabulados de Z. Dichos valores deben ser siempre los mismos
!C     para todos los sitios ! ! ! !  ATENCION: esto NO lo controla
!C     la rutina ! ! ! !
!C     ------------------------------------------------------------------
    IMPLICIT NONE

    TYPE (CRP_AtomSurface_PES) :: PES
    INTEGER :: i, j, k
    REAL :: dz1, dz2

    REAL :: b0, b1, b2, delta, deriz, pot, vm1
    REAL :: der1(SIZE(PES%Cuts)), der2(SIZE(PES%Cuts))

!     ------------------------------------------------------------
!     Reading the data for the repulsive 1D potential

    OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Atom/intrep.dat", STATUS="OLD")
    READ(10, *) dz1
    READ(10, *) dz2
    dz1 = Convert_Force_Units( dz1, PES%InputUnits, InternalUnits )
    dz2 = Convert_Force_Units( dz2, PES%InputUnits, InternalUnits )
    READ(10, *) PES%CorrugationFunction1D%NX
    CALL Allocate_Spline1D( PES%CorrugationFunction1D, PES%CorrugationFunction1D%NX )
    DO i = 1, PES%CorrugationFunction1D%NX
      READ(10, *) PES%CorrugationFunction1D%X(i), PES%CorrugationFunction1D%F(i)
      PES%CorrugationFunction1D%X(i) = Convert_Length_Units( PES%CorrugationFunction1D%X(i), PES%InputUnits, InternalUnits )
      PES%CorrugationFunction1D%F(i) = Convert_Energy_Units( PES%CorrugationFunction1D%F(i), PES%InputUnits, InternalUnits )
    END DO
    CLOSE(10)

    CALL Compute_Spline1D( PES%CorrugationFunction1D, 2, dz1, 2, dz2 )

!   Now read all cuts from disk...
    DO j = 1, SIZE(PES%Cuts)
      OPEN(10, FILE=TRIM(ADJUSTL(PES%DataSet)) // "/Atom/" // TRIM(ADJUSTL(PES%Cuts(j)%FileName)), STATUS="OLD")
      READ(10, *) PES%Cuts(j)%Spline%NX
      CALL Allocate_Spline1D( PES%Cuts(j)%Spline, PES%Cuts(j)%Spline%NX )
      READ(10, *) dz1
      READ(10, *) dz2
      dz1 = Convert_Force_Units( dz1, PES%InputUnits, InternalUnits )
      dz2 = Convert_Force_Units( dz2, PES%InputUnits, InternalUnits )
      DO i = 1, PES%Cuts(j)%Spline%NX
        READ(10, *) PES%Cuts(j)%Spline%X(i), pot
        PES%Cuts(j)%Spline%X(i) = Convert_Length_Units( PES%Cuts(j)%Spline%X(i), PES%InputUnits, InternalUnits )
        pot = Convert_Energy_Units( pot, PES%InputUnits, InternalUnits )

        IF ( j .GT. 1 .AND. PES%Cuts(j)%Spline%X(i) .NE. PES%Cuts(1)%Spline%X(i) ) THEN
          PRINT *, "Error in data for site ", j
          STOP
        END IF

        CALL MURO(PES%Cuts(j)%X * PES%Geometry%LatticeConstant, PES%Cuts(j)%Y * PES%Geometry%LatticeConstant, &
                  PES%Cuts(j)%Spline%X(i), vm1, b0, b1, deriz, PES)
        PES%Cuts(j)%Spline%F(i) = pot - vm1
        IF (i .EQ. 1) THEN
          der1(j) = dz1 - deriz
        END IF
        IF (i .EQ. PES%Cuts(j)%Spline%NX) THEN
          der2(j) = dz2 - deriz
        END IF
      END DO
      CLOSE(10)

      CALL Compute_Spline1D( PES%Cuts(j)%Spline, 2, der1(j), 2, der2(j) )
    END DO

    CALL Allocate_Spline3DPeriodic( PES%SplineFunction, 5, 5, PES%Cuts(1)%Spline%NX )

    DO i = 1, 5
      PES%SplineFunction%X(i) = FLOAT(i - 1) * PES%Geometry%LatticeConstant * 0.25
    END DO

    DO j = 1, 5
      PES%SplineFunction%Y(j) = FLOAT(j - 1) * PES%Geometry%LatticeConstant * 0.25
    END DO

    DO i = 1, PES%Cuts(1)%Spline%NX
      PES%SplineFunction%Z(i) = PES%Cuts(1)%Spline%X(i)
    END DO

    ! Symmetrize the potential on top
    DO i = 1, PES%Cuts(1)%Spline%NX
      PES%SplineFunction%F(1, 1, i) = PES%Cuts(1)%Spline%F(i)
      PES%SplineFunction%F(1, 5, i) = PES%SplineFunction%F(1, 1, i)
      PES%SplineFunction%F(5, 1, i) = PES%SplineFunction%F(1, 1, i)
      PES%SplineFunction%F(5, 5, i) = PES%SplineFunction%F(1, 1, i)
      IF ( i .EQ. 1 ) THEN
        PES%SplineFunction%Der1(1, 1) = Der1(1)
        PES%SplineFunction%Der1(1, 5) = PES%SplineFunction%Der1(1, 1)
        PES%SplineFunction%Der1(5, 1) = PES%SplineFunction%Der1(1, 1)
        PES%SplineFunction%Der1(5, 5) = PES%SplineFunction%Der1(1, 1)
      END IF
      IF ( i .EQ. PES%Cuts(1)%Spline%NX ) THEN
        PES%SplineFunction%Der2(1, 1) = Der2(1)
        PES%SplineFunction%Der2(1, 5) = PES%SplineFunction%Der2(1, 1)
        PES%SplineFunction%Der2(5, 1) = PES%SplineFunction%Der2(1, 1)
        PES%SplineFunction%Der2(5, 5) = PES%SplineFunction%Der2(1, 1)
      END IF
    END DO

    ! Symnetrize the potential on hollow
    DO i = 1, PES%Cuts(2)%Spline%NX
      PES%SplineFunction%F(3, 3, i) = PES%Cuts(2)%Spline%F(i)
      IF ( i .EQ. 1 ) THEN
        PES%SplineFunction%Der1(3, 3) = Der1(2)
      END IF
      IF ( i .EQ. PES%Cuts(2)%Spline%NX ) THEN
        PES%SplineFunction%Der2(3, 3) = Der2(2)
      END IF
    END DO

    ! Symmetrize the potential on bridge
    DO i = 1, PES%Cuts(3)%Spline%NX
      PES%SplineFunction%F(3, 1, i) = PES%Cuts(3)%Spline%F(i)
      PES%SplineFunction%F(1, 3, i) = PES%SplineFunction%F(3, 1, i)
      PES%SplineFunction%F(5, 3, i) = PES%SplineFunction%F(3, 1, i)
      PES%SplineFunction%F(3, 5, i) = PES%SplineFunction%F(3, 1, i)
      IF ( i .EQ. 1 ) THEN
        PES%SplineFunction%Der1(3, 1) = Der1(3)
        PES%SplineFunction%Der1(1, 3) = PES%SplineFunction%Der1(3, 1)
        PES%SplineFunction%Der1(5, 3) = PES%SplineFunction%Der1(3, 1)
        PES%SplineFunction%Der1(3, 5) = PES%SplineFunction%Der1(3, 1)
      END IF
      IF ( i .EQ. PES%Cuts(3)%Spline%NX ) THEN
        PES%SplineFunction%Der2(3, 1) = Der2(3)
        PES%SplineFunction%Der2(1, 3) = PES%SplineFunction%Der2(3, 1)
        PES%SplineFunction%Der2(5, 3) = PES%SplineFunction%Der2(3, 1)
        PES%SplineFunction%Der2(3, 5) = PES%SplineFunction%Der2(3, 1)
      END IF
    END DO

    ! Symmetrize the potential on t2h
    DO i = 1, PES%Cuts(4)%Spline%NX
      PES%SplineFunction%F(2, 2, i) = PES%Cuts(4)%Spline%F(i)
      PES%SplineFunction%F(4, 4, i) = PES%SplineFunction%F(2, 2, i)
      PES%SplineFunction%F(4, 2, i) = PES%SplineFunction%F(2, 2, i)
      PES%SplineFunction%F(2, 4, i) = PES%SplineFunction%F(2, 2, i)
      IF ( i .EQ. 1 ) THEN
        PES%SplineFunction%Der1(2, 2) = Der1(4)
        PES%SplineFunction%Der1(4, 4) = PES%SplineFunction%Der1(2, 2)
        PES%SplineFunction%Der1(4, 2) = PES%SplineFunction%Der1(2, 2)
        PES%SplineFunction%Der1(2, 4) = PES%SplineFunction%Der1(2, 2)
      END IF
      IF ( i .EQ. PES%Cuts(4)%Spline%NX ) THEN
        PES%SplineFunction%Der2(2, 2) = Der2(4)
        PES%SplineFunction%Der2(4, 4) = PES%SplineFunction%Der2(2,2)
        PES%SplineFunction%Der2(4, 2) = PES%SplineFunction%Der2(2,2)
        PES%SplineFunction%Der2(2, 4) = PES%SplineFunction%Der2(2,2)
      END IF
    END DO

    ! Symmetrize the potential on b2h
    DO i = 1, PES%Cuts(5)%Spline%NX
      PES%SplineFunction%F(3, 2, i) = PES%Cuts(5)%Spline%F(i)
      PES%SplineFunction%F(2, 3, i) = PES%SplineFunction%F(3, 2, i)
      PES%SplineFunction%F(4, 3, i) = PES%SplineFunction%F(3, 2, i)
      PES%SplineFunction%F(3, 4, i) = PES%SplineFunction%F(3, 2, i)
      IF ( i .EQ. 1 ) THEN
        PES%SplineFunction%Der1(3, 2) = Der1(5)
        PES%SplineFunction%Der1(2, 3) = PES%SplineFunction%Der1(3, 2)
        PES%SplineFunction%Der1(4, 3) = PES%SplineFunction%Der1(3, 2)
        PES%SplineFunction%Der1(3, 4) = PES%SplineFunction%Der1(3, 2)
      END IF
      IF ( i .EQ. PES%Cuts(5)%Spline%NX ) THEN
        PES%SplineFunction%Der2(3, 2) = Der2(5)
        PES%SplineFunction%Der2(2, 3) = PES%SplineFunction%Der2(3, 2)
        PES%SplineFunction%Der2(4, 3) = PES%SplineFunction%Der2(3, 2)
        PES%SplineFunction%Der2(3, 4) = PES%SplineFunction%Der2(3, 2)
      END IF
    END DO

    ! Symmetrize the potential on t2b
    DO i = 1, PES%Cuts(6)%Spline%NX
      PES%SplineFunction%F(2, 1, i) = PES%Cuts(6)%Spline%F(i)
      PES%SplineFunction%F(4, 1, i) = PES%SplineFunction%F(2, 1, i)
      PES%SplineFunction%F(1, 2, i) = PES%SplineFunction%F(2, 1, i)
      PES%SplineFunction%F(5, 2, i) = PES%SplineFunction%F(2, 1, i)
      PES%SplineFunction%F(1, 4, i) = PES%SplineFunction%F(2, 1, i)
      PES%SplineFunction%F(5, 4, i) = PES%SplineFunction%F(2, 1, i)
      PES%SplineFunction%F(2, 5, i) = PES%SplineFunction%F(2, 1, i)
      PES%SplineFunction%F(4, 5, i) = PES%SplineFunction%F(2, 1, i)
      IF ( i .EQ. 1 ) THEN
        PES%SplineFunction%Der1(2, 1) = Der1(6)
        PES%SplineFunction%Der1(4, 1) = PES%SplineFunction%Der1(2, 1)
        PES%SplineFunction%Der1(1, 2) = PES%SplineFunction%Der1(2, 1)
        PES%SplineFunction%Der1(5, 2) = PES%SplineFunction%Der1(2, 1)
        PES%SplineFunction%Der1(1, 4) = PES%SplineFunction%Der1(2, 1)
        PES%SplineFunction%Der1(5, 4) = PES%SplineFunction%Der1(2, 1)
        PES%SplineFunction%Der1(2, 5) = PES%SplineFunction%Der1(2, 1)
        PES%SplineFunction%Der1(4, 5) = PES%SplineFunction%Der1(2, 1)
      END IF
      IF ( i .EQ. PES%Cuts(6)%Spline%NX ) THEN
        PES%SplineFunction%Der2(2, 1) = Der2(6)
        PES%SplineFunction%Der2(4, 1) = PES%SplineFunction%Der2(2, 1)
        PES%SplineFunction%Der2(1, 2) = PES%SplineFunction%Der2(2, 1)
        PES%SplineFunction%Der2(5, 2) = PES%SplineFunction%Der2(2, 1)
        PES%SplineFunction%Der2(1, 4) = PES%SplineFunction%Der2(2, 1)
        PES%SplineFunction%Der2(5, 4) = PES%SplineFunction%Der2(2, 1)
        PES%SplineFunction%Der2(2, 5) = PES%SplineFunction%Der2(2, 1)
        PES%SplineFunction%Der2(4, 5) = PES%SplineFunction%Der2(2, 1)
      END IF
    END DO

    CALL Compute_Spline3D_Periodic( PES%SplineFunction )
  END SUBROUTINE

!*********************************************************************************************
  SUBROUTINE MURO( X, Y, Z, V, dVX, dVY, dVZ, PES )
    IMPLICIT NONE

    INTEGER, PARAMETER :: nvec = 32
    REAL :: alpha, vec(nvec, 3), V, X, Y, Z, dVX, dVY, dVZ, r, Vr, dVdr, xij, yij, zij
    INTEGER :: i
    TYPE ( CRP_AtomSurface_PES ) :: PES
    parameter (ALPHA=0.97212628726799359364d0)

    VEC(1,1)=0.
    VEC(1,2)=-2.
    VEC(1,3)=0.
    VEC(2,1)=-1.
    VEC(2,2)=-1.
    VEC(2,3)=0.
    VEC(3,1)=0.
    VEC(3,2)=-1.
    VEC(3,3)=0.
    VEC(4,1)=1.
    VEC(4,2)=-1.
    VEC(4,3)=0
    VEC(5,1)=2.
    VEC(5,2)=-1.
    VEC(5,3)=0.
    VEC(6,1)=-2.
    VEC(6,2)=0.
    VEC(6,3)=0.
    VEC(7,1)=-1.
    VEC(7,2)=0.
    VEC(7,3)=0.
    VEC(8,1)=0.
    VEC(8,2)=0.
    VEC(8,3)=0.
    VEC(9,1)=1.
    VEC(9,2)=0.
    VEC(9,3)=0.
    VEC(10,1)=2.
    VEC(10,2)=0.
    VEC(10,3)=0.
    VEC(11,1)=-1.
    VEC(11,2)=1.
    VEC(11,3)=0.
    VEC(12,1)=0.
    VEC(12,2)=1.
    VEC(12,3)=0.
    VEC(13,1)=1.
    VEC(13,2)=1.
    VEC(13,3)=0.
    VEC(14,1)=2.
    VEC(14,2)=1.
    VEC(14,3)=0.
    VEC(15,1)=0.
    VEC(15,2)=2.
    VEC(15,3)=0.
    VEC(16,1)=1.
    VEC(16,2)=2.
    VEC(16,3)=0.
    VEC(17,1)=-0.5
    VEC(17,2)=-1.5
    VEC(17,3)=-1.
    VEC(18,1)=0.5
    VEC(18,2)=-1.5
    VEC(18,3)=-1.
    VEC(19,1)=1.5
    VEC(19,2)=-1.5
    VEC(19,3)=-1.
    VEC(20,1)=-1.5
    VEC(20,2)=-0.5
    VEC(20,3)=-1.
    VEC(21,1)=-0.5
    VEC(21,2)=-0.5
    VEC(21,3)=-1.
    VEC(22,1)=0.5
    VEC(22,2)=-0.5
    VEC(22,3)=-1.
    VEC(23,1)=1.5
    VEC(23,2)=-0.5
    VEC(23,3)=-1.
    VEC(24,1)=-1.5
    VEC(24,2)=0.5
    VEC(24,3)=-1.
    VEC(25,1)=-0.5
    VEC(25,2)=0.5
    VEC(25,3)=-1.
    VEC(26,1)=0.5
    VEC(26,2)=0.5
    VEC(26,3)=-1.
    VEC(27,1)=1.5
    VEC(27,2)=0.5
    VEC(27,3)=-1.
    VEC(28,1)=2.5
    VEC(28,2)=0.5
    VEC(28,3)=-1.
    VEC(29,1)=-0.5
    VEC(29,2)=1.5
    VEC(29,3)=-1.
    VEC(30,1)=0.5
    VEC(30,2)=1.5
    VEC(30,3)=-1.
    VEC(31,1)=1.5
    VEC(31,2)=1.5
    VEC(31,3)=-1.
    VEC(32,1)=0.5
    VEC(32,2)=2.5
    VEC(32,3)=-1.

    V = 0.0
    dVX = 0.0
    dVY = 0.0
    dVZ = 0.0
    DO i = 1, nVec
      Xij = Vec(i, 1) * PES%Geometry%LatticeConstant
      Yij = Vec(i, 2) * PES%Geometry%LatticeConstant

      ! WARNING: this code only works properly for the first sublevel of
      ! atoms... no more is included in the above list.
      IF ( PES%Geometry%InterlayerSpacings(1) .LT. 0.0 ) THEN
        Zij = -Vec(i, 3) * PES%Geometry%InterlayerSpacings(1) * PES%Geometry%LatticeConstant / SQRT(2.0)
      ELSE
        Zij = Vec(i, 3) * PES%Geometry%InterlayerSpacings(1)
      END IF
      R = SQRT((X - Xij)**2.0 + (Y - Yij)**2.0 + (Z - Zij)**2.0)
      CALL VREP1D( R, Vr, dVdR, PES )
      V = V + Vr
      IF ( R .GT. 0.0 ) THEN
        dVX = dVX + dVdR * (X - Xij) / R
        dVY = dVY + dVdR * (Y - Yij) / R
        dVZ = dVZ + dVdR * (Z - Zij) / R
      END IF
    END DO
  END SUBROUTINE

!*********************************************************************************************
  SUBROUTINE VREP1D( R, Vr, dVdR, PES )
    IMPLICIT NONE

    REAL :: R, Vr, dVdR
    TYPE (CRP_AtomSurface_PES) :: PES

    IF ( R .GT. PES%CorrugationFunction1D%X(PES%CorrugationFunction1D%NX) ) THEN
      VR = 0.0
      DVDR = 0.0
      RETURN
    ENDIF
    IF ( R .LT. 0.0 ) THEN
       WRITE(*,*)'Error en VREP1D: R<0'
       STOP
    ENDIF
    CALL SPLINT(PES%CorrugationFunction1D%X, PES%CorrugationFunction1D%F, PES%CorrugationFunction1D%Coefs, &
                PES%CorrugationFunction1D%NX, r, vr, dvdr)
  END SUBROUTINE

!****************************************************************************************************
  SUBROUTINE int_PES6CuHATOMCu100( X0, Y0, Z0, V, dVdX, dVdY, dVdZ, PES )
    IMPLICIT NONE

    REAL :: X0, Y0, Z0, F0, V, dVdX, dVdY, dVdZ, BigX0, BigY0, X0C, Y0C
    REAL :: VRepul, dVRepdX, dVRepdY, dVRepdZ, dX, dY, dZ
    INTEGER :: IReg
    INTEGER, PARAMETER :: idx = 5, idy = 5, idz = 53
    TYPE ( CRP_AtomSurface_PES ) :: PES

    IF ( Z0 .GE. PES%SplineFunction%Z(PES%SplineFunction%NZ) ) THEN
      V = 0.0
      dVdX = 0.0
      dVdY = 0.0
      dVdZ = 0.0
      RETURN
    END IF

    CALL ORIGEN( X0, Y0, PES%Geometry%LatticeConstant, BigX0, BigY0)
    CALL REGION( BigX0, BigY0, PES%Geometry%LatticeConstant, IReg)

!   -------------------------------
!   Calculate the repulsive potential
    X0C = BigX0
    Y0C = BigY0
    CALL MURO( X0C, Y0C, Z0, VRepul, dVRepdX, dVRepdY, dVRepdZ, PES )

    CALL Evaluate_Spline3D_Periodic( PES%SplineFunction, X0C, Y0C, Z0, F0, dX, dY, dZ )

    V = (F0 + VRepul)
    dVdX = (dX + dVRepdX)
    dVdY = (dY + dVRepdY)
    dVdZ = (dZ + dVRepdZ)
    CALL TRANSF( IReg, dVdX, dVdY)
  END SUBROUTINE
END MODULE

MODULE CRP_GasPhase
  USE CRP_Constants
  USE CRP_General
  USE Spline

  IMPLICIT NONE
CONTAINS

!*******************************************************************************
! Switch_Function
!*******************************************************************************
!> This routine computes the switch function used to switch from the 6D
!> full potential to the 2D gas phase potential.
!*******************************************************************************
  SUBROUTINE Switch_Function( Zcc, Fso, dFso, PES )
    IMPLICIT NONE

    TYPE (CRP_GasPhase_2D) :: PES
    REAL       :: Zcc, Fso, dFso

    IF (Zcc .LE. PES%ZsoMin) THEN
      Fso = 1.00
      dFso = 0.00
      RETURN
    END IF

    IF (zcc .GE. PES%ZsoMax) THEN
      Fso = 0.00
      dFso = 0.00
      RETURN
    END IF

    Fso = 0.500 + 0.500 * COS((Zcc - PES%ZsoMin) * CRP_Constants_PI / (PES%ZsoMax - PES%ZsoMin))
    dFso = -0.500 * CRP_Constants_PI / (PES%ZsoMax - PES%ZsoMin) * SIN((Zcc - PES%ZsoMin) * &
             CRP_Constants_PI / (PES%ZsoMax - PES%ZsoMin))
  END SUBROUTINE

!*******************************************************************************
! Calculate_CRP_GasPhase_Potential
!*******************************************************************************
!>    In this routine we define a 2D potential dependent on r and Z,
!>    which is used far from the surface to switch the full 6D PES
!>    to the H2 potential in the vacuum.
!>
!>    This 2D potential is a sum of 2 1D potentials depending just on r
!>    and Z. Then, in the region where the PES id equal to this 2D
!>    potential the dynamics is "trivial". The r dependence doen't
!>    change with Z. Then ZPE is constant and the molecules are
!>    accelerated toward the surface due to the attraction with Z.
!>    Then, the results of the dynamics should not depend on
!>    the shape of the Z dependence of this 2D potential.
!.    Just the difference of the 1D Z dependent term between
!>    ZSOMAX and infinitty is important.
!*********************************************************************
  SUBROUTINE Calculate_CRP_GasPhase_Potential( Zcc, ro, V2D, dV2DinfZ, dV2DinfR, PES )
    IMPLICIT NONE

    TYPE (CRP_GasPhase_2D) :: PES
    REAL       :: Zcc, ro, V2D, dV2DinfZ, dV2DinfR, V1D, VH2

    ! Compute the contribution from r
    CALL SPLINT( PES%Rdep%X, PES%Rdep%F, PES%Rdep%Coefs, PES%Rdep%NX, ro, VH2, dV2DinfR )

    ! Compute the contribution from Z
    IF (Zcc .GE. PES%ZsoMin .AND. Zcc .LE. PES%Zdep%X(PES%Zdep%NX)) THEN
      ! The molecule is within the area spanned by the interpolated Z dependency
      CALL SPLINT( PES%Zdep%X, PES%Zdep%F, PES%Zdep%Coefs, PES%Zdep%NX, Zcc, V1D, dV2DinfZ )
    ELSE
      IF (Zcc .GT. PES%Zdep%X(PES%Zdep%NX)) THEN
        ! The molecule is above the area spanned by the interpolated Z dependency
        V1D = PES%Zdep%F(PES%Zdep%NX)
        dV2DinfZ = 0.00
      ELSE
        PRINT *, "ERROR IN V2DINF"
        STOP
      END IF
    END IF

    V2D = VH2 + V1D
  END SUBROUTINE
END MODULE
